/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AE_ACCOUNT_FNS_H
#define AE_ACCOUNT_FNS_H


#include <aqfinance/engine/book/ae_account.h>



#ifdef __cplusplus
extern "C" {
#endif



AE_API void AE_Account_Tree_ClearBranchBalances(AE_ACCOUNT_TREE *at);
AE_API void AE_Account_Tree_CalcBranchBalances(AE_ACCOUNT_TREE *at);
AE_API void AE_Account_Tree_CalcBranchBalance(AE_ACCOUNT *acc);

AE_API void AE_Account_Tree_ClearBalances(AE_ACCOUNT_TREE *at);

AE_API int AE_Account_Tree_AddToBalance(AE_ACCOUNT_TREE *at,
					AQDB_ID accountId,
					const AQDB_VALUE *v,
					AQDB_ID commodityId);

AE_API int AE_Account_Tree_SubFromBalance(AE_ACCOUNT_TREE *at,
					  AQDB_ID accountId,
					  const AQDB_VALUE *vt,
					  AQDB_ID commodityId);

AE_API int AE_AccountType_NeedReverseSign(AE_ACCOUNT_TYPE t);
AE_API int AE_AccountGroup_NeedReverseSign(AE_ACCOUNT_GROUP g);

AE_API void AE_Account_Tree_SetSelected(AE_ACCOUNT *acc);
AE_API void AE_Account_Tree_SelectAccountAndChildrenByName(AE_ACCOUNT_TREE *at, const char *path, int withChildren);

AE_API void AE_Account_Tree_SelectMatching(AE_ACCOUNT_TREE *at, const char *s);

AE_API int AE_Account_Tree_IsAncestorOf(const AE_ACCOUNT *parentInQuestion, const AE_ACCOUNT *acc);


AE_API void AE_Account_Tree_AddRuntimeFlagsUpAndDown(AE_ACCOUNT *acc, int withParents, int withChildren, uint32_t rtflags);
AE_API void AE_Account_Tree_SubRuntimeFlagsUpAndDown(AE_ACCOUNT *acc, int withParents, int withChildren, uint32_t rtflags);

AE_API void AE_Account_Tree_AddRuntimeFlags(AE_ACCOUNT_TREE *at, uint32_t rtflags);
AE_API void AE_Account_Tree_SubRuntimeFlags(AE_ACCOUNT_TREE *at, uint32_t rtflags);


#ifdef __cplusplus
}
#endif



#endif
