/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AE_JOB_FNS_H
#define AE_JOB_FNS_H


#include <aqfinance/engine/book/ae_job.h>

#include <aqdatabase/aqdb_value.h>


#ifdef __cplusplus
extern "C" {
#endif


AE_API void AE_Job_AddItem(AE_JOB *j, AE_ITEM *item);
AE_API AE_ITEM *AE_Job_GetFirstItem(const AE_JOB *j);

AE_API int AE_Job_SampleBuyTaxes(const AE_JOB *j, AQDB_ID *idBuffer, int size);
AE_API int AE_Job_SampleSellTaxes(const AE_JOB *j, AQDB_ID *idBuffer, int size);

AE_API int AE_Job_CalculateBuyTax(const AE_JOB *j, AQDB_ID taxId, AQDB_VALUE *v);
AE_API int AE_Job_CalculateSellTax(const AE_JOB *j, AQDB_ID taxId, AQDB_VALUE *v);

AE_API int AE_Job_CalculateBuyNetSum(const AE_JOB *j, AQDB_VALUE *v);
AE_API int AE_Job_CalculateSellNetSum(const AE_JOB *j, AQDB_VALUE *v);

AE_API int AE_Job_CalculateBuyTotalSum(const AE_JOB *j, AQDB_VALUE *v);
AE_API int AE_Job_CalculateSellTotalSum(const AE_JOB *j, AQDB_VALUE *v);


#ifdef __cplusplus
}
#endif


#endif
