/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010-2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef AE_MODULES_IMPORT_QBM_H
#define AE_MODULES_IMPORT_QBM_H


#include <aqfinance/engine/book/ae_book.h>
#include <aqbanking/imexporter.h>



#ifdef __cplusplus
extern "C" {
#endif


/**
 * This module imports QBankManager accounts, transfers and transactions into the given
 * im-/exporter context.
 * @param b book to use
 * @param abpath AqBanking's home path (e.g. "/home/me/.aqbanking")
 * @param ctx context into which to import the QBankManager data
 */
AE_API int AE_Book_ImportQbm(AE_BOOK *b, const char *abpath, AB_IMEXPORTER_CONTEXT *ctx);


#ifdef __cplusplus
}
#endif

#endif
