/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef AE_MODULES_READXML_H
#define AE_MODULES_READXML_H


#include <aqfinance/engine/book/ae_book.h>


#ifdef __cplusplus
extern "C" {
#endif


/**
 * This function reads a database from an XML file created by @ref AE_Book_WriteXml().
 * The database should be empty before calling this function. Calls to this function
 * must be framed by calls to @ref AE_Book_BeginEdit() and @ref AE_Book_EndEdit().
 *
 * @param b pointer to the book to export (must be open)
 * @param fname name of the XML file to be read
 * @param openAndCloseTables if !=0 then this function will open/create the tables
 *   found in the XML file. If 0 then the tables are expected to already exist and be empty.
 *
 * @return 0 if ok, error code otherwise
 */
AE_API int AE_Book_ReadXml(AE_BOOK *b, const char *fname, int openAndCloseTables);


#ifdef __cplusplus
}
#endif

#endif
