/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2008 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef AE_MODULES_STATEMENTEXPORT_H
#define AE_MODULES_STATEMENTEXPORT_H


#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_statement.h>

#include <aqbanking/imexporter.h>
#include <aqbanking/transaction.h>


#ifdef __cplusplus
extern "C" {
#endif


AE_API
int AE_StatementExport_StatementToTransaction(const AE_STATEMENT *st,
					      AB_TRANSACTION *t);


AE_API
int AE_StatementExport_ExportContext(AE_BOOK *b,
				     AB_IMEXPORTER_CONTEXT *iec,
				     AE_BOOK_TABLE_TYPE tt,
				     const char *queryString);

#ifdef __cplusplus
}
#endif


#endif
