/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AE_MODULES_TRANS4JOB_H
#define AE_MODULES_TRANS4JOB_H


#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_job.h>
#include <aqfinance/engine/book/ae_transaction.h>


#ifdef __cplusplus
extern "C" {
#endif


AE_API int AE_Transaction4SellInvoice(AE_BOOK *b, AE_JOB *j,
				      AE_TRANSACTION *t,
				      AQDB_ID receivableAccountId);


AE_API int AE_Transaction4BuyInvoice(AE_BOOK *b, AE_JOB *j,
				     AE_TRANSACTION *t,
				     AQDB_ID payableAccountId);

AE_API int AE_Transaction4SellPayment(AE_BOOK *b, AE_JOB *j,
				      AE_TRANSACTION *t,
				      AQDB_ID receivableAccountId,
				      AQDB_ID bankAccountId);

AE_API int AE_Transaction4BuyPayment(AE_BOOK *b, AE_JOB *j,
				     AE_TRANSACTION *t,
				     AQDB_ID payableAccountId,
				     AQDB_ID bankAccountId);



#ifdef __cplusplus
}
#endif



#endif

