/**********************************************************
 * This file has been automatically created by "typemaker2"
 * from the file "af_graphics.xml".
 * Please do not edit this file, all changes will be lost.
 * Better edit the mentioned source file instead.
 **********************************************************/

#ifndef AF_GRAPHICS_H
#define AF_GRAPHICS_H


#ifdef __cplusplus
extern "C" {
#endif

/* define AF_GRAPHICS_RTFLAGS */
#define AF_GRAPHICS_RTFLAGS_MODIFIED 0x00000001


/* needed system headers */
#include <gwenhywfar/types.h>
#include <gwenhywfar/list1.h>
#include <gwenhywfar/list2.h>
#include <gwenhywfar/inherit.h>

/* pre-headers */
#include <aqfinance/engine/ae.h>

typedef struct AF_GRAPHICS AF_GRAPHICS;
GWEN_LIST_FUNCTION_LIB_DEFS(AF_GRAPHICS, AF_Graphics, AE_API)
GWEN_LIST2_FUNCTION_LIB_DEFS(AF_GRAPHICS, AF_Graphics, AE_API)
GWEN_INHERIT_FUNCTION_LIB_DEFS(AF_GRAPHICS, AE_API)


enum {
  AF_Graphics_Slant_Unknown = -1,
  AF_Graphics_Slant_None = 0,
  AF_Graphics_Slant_Italic
};


enum {
  AF_Graphics_Weight_Unknown = -1,
  AF_Graphics_Weight_None = 0,
  AF_Graphics_Weight_Bold
};


enum {
  AF_Graphics_Direction_Unknown = -1,
  AF_Graphics_Direction_Vertical,
  AF_Graphics_Direction_Horizontal
};


enum {
  AF_Graphics_Dash_Unknown = -1,
  AF_Graphics_Dash_None = 0,
  AF_Graphics_Dash_Format1,
  AF_Graphics_Dash_Format2,
  AF_Graphics_Dash_Format3,
  AF_Graphics_Dash_Format4,
  AF_Graphics_Dash_Format5,
  AF_Graphics_Dash_Format6,
  AF_Graphics_Dash_Format7,
  AF_Graphics_Dash_Format8
};


/* post-headers */


/* definitions for virtual functions (post) */
typedef int  (*AF_GRAPHICS_PENCREATE_FN)(AF_GRAPHICS *p_struct, uint32_t frontColor, int lineWidth, int dashType);

typedef int  (*AF_GRAPHICS_PENRELEASE_FN)(AF_GRAPHICS *p_struct, int pen);

typedef int  (*AF_GRAPHICS_DRAWLINE_FN)(AF_GRAPHICS *p_struct, int pen, int xStart, int yStart, int xEnd, int yEnd);

typedef int  (*AF_GRAPHICS_DRAWRECT_FN)(AF_GRAPHICS *p_struct, int pen, int x, int y, int width, int height);

typedef int  (*AF_GRAPHICS_DRAWFILLEDRECT_FN)(AF_GRAPHICS *p_struct, int pen, int x, int y, int width, int height);

typedef int  (*AF_GRAPHICS_FONTCREATE_FN)(AF_GRAPHICS *p_struct, const char* fontName, int fontSize, int fontSlant, int fontWeight);

typedef int  (*AF_GRAPHICS_FONTRELEASE_FN)(AF_GRAPHICS *p_struct, int font);

typedef int  (*AF_GRAPHICS_DRAWTEXT_FN)(AF_GRAPHICS *p_struct, int pen, int font, int direction, int x, int y, const char* text);

typedef int  (*AF_GRAPHICS_GETTEXTWIDTH_FN)(AF_GRAPHICS *p_struct, int font, const char* text);

typedef int  (*AF_GRAPHICS_GETTEXTHEIGHT_FN)(AF_GRAPHICS *p_struct, int font, const char* text);

typedef int  (*AF_GRAPHICS_FINISH_FN)(AF_GRAPHICS *p_struct);

AE_API int AF_Graphics_Slant_fromString(const char *p_s);

AE_API int AF_Graphics_Weight_fromString(const char *p_s);

AE_API int AF_Graphics_Direction_fromString(const char *p_s);

AE_API int AF_Graphics_Dash_fromString(const char *p_s);

AE_API const char *AF_Graphics_Slant_toString(int p_i);

AE_API const char *AF_Graphics_Weight_toString(int p_i);

AE_API const char *AF_Graphics_Direction_toString(int p_i);

AE_API const char *AF_Graphics_Dash_toString(int p_i);

/** Constructor. */
AE_API AF_GRAPHICS *AF_Graphics_new(void);

/** Destructor. */
AE_API void AF_Graphics_free(AF_GRAPHICS *p_struct);

AE_API void AF_Graphics_Attach(AF_GRAPHICS *p_struct);

/** Getter.
 * Use this function to get the member "id"
*/
AE_API AQDB_ID AF_Graphics_GetId(const AF_GRAPHICS *p_struct);

/** Getter.
 * Use this function to get the member "typeName"
*/
AE_API const char *AF_Graphics_GetTypeName(const AF_GRAPHICS *p_struct);

/** Setter.
 * Use this function to set the member "id"
*/
AE_API void AF_Graphics_SetId(AF_GRAPHICS *p_struct, AQDB_ID p_src);

/** Setter.
 * Use this function to set the member "typeName"
*/
AE_API void AF_Graphics_SetTypeName(AF_GRAPHICS *p_struct, const char *p_src);

/* prototypes for virtual functions */
/**
 * Creates a pen from the given info.
 * @param frontColor Foreground colour used for drawing
 */
AE_API int AF_Graphics_PenCreate(AF_GRAPHICS *p_struct, uint32_t frontColor, int lineWidth, int dashType);

/**
 * Release the given pen.
 */
AE_API int AF_Graphics_PenRelease(AF_GRAPHICS *p_struct, int pen);

/**
 * Draws a line from xStart/yStart to xEnd/yEnd using the given pen.
 * @param pen Pen to be used.
 */
AE_API int AF_Graphics_DrawLine(AF_GRAPHICS *p_struct, int pen, int xStart, int yStart, int xEnd, int yEnd);

/**
 * Draws a non-filled rectangle.
 * @param pen Pen to be used.
 */
AE_API int AF_Graphics_DrawRect(AF_GRAPHICS *p_struct, int pen, int x, int y, int width, int height);

/**
 * Draws a filled rectangle.
 * @param pen Pen to be used.
 */
AE_API int AF_Graphics_DrawFilledRect(AF_GRAPHICS *p_struct, int pen, int x, int y, int width, int height);

/**
 * Creates a font from the given info.
 */
AE_API int AF_Graphics_FontCreate(AF_GRAPHICS *p_struct, const char* fontName, int fontSize, int fontSlant, int fontWeight);

/**
 * Releases the given font.
 */
AE_API int AF_Graphics_FontRelease(AF_GRAPHICS *p_struct, int font);

/**
 * Draws the given text at the given position using the given font and pen.
 * @param pen Pen to be used.
 * @param font Font to be used.
 */
AE_API int AF_Graphics_DrawText(AF_GRAPHICS *p_struct, int pen, int font, int direction, int x, int y, const char* text);

/**
 * Query the width used for the given text using the given font.
 */
AE_API int AF_Graphics_GetTextWidth(AF_GRAPHICS *p_struct, int font, const char* text);

/**
 * Query the height used for the given text using the given font.
 */
AE_API int AF_Graphics_GetTextHeight(AF_GRAPHICS *p_struct, int font, const char* text);

/**
 * Call this when your are finished drawing.
 */
AE_API int AF_Graphics_Finish(AF_GRAPHICS *p_struct);

/* setters for virtual functions */
AE_API AF_GRAPHICS_PENCREATE_FN AF_Graphics_SetPenCreateFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_PENCREATE_FN fn);

AE_API AF_GRAPHICS_PENRELEASE_FN AF_Graphics_SetPenReleaseFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_PENRELEASE_FN fn);

AE_API AF_GRAPHICS_DRAWLINE_FN AF_Graphics_SetDrawLineFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_DRAWLINE_FN fn);

AE_API AF_GRAPHICS_DRAWRECT_FN AF_Graphics_SetDrawRectFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_DRAWRECT_FN fn);

AE_API AF_GRAPHICS_DRAWFILLEDRECT_FN AF_Graphics_SetDrawFilledRectFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_DRAWFILLEDRECT_FN fn);

AE_API AF_GRAPHICS_FONTCREATE_FN AF_Graphics_SetFontCreateFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_FONTCREATE_FN fn);

AE_API AF_GRAPHICS_FONTRELEASE_FN AF_Graphics_SetFontReleaseFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_FONTRELEASE_FN fn);

AE_API AF_GRAPHICS_DRAWTEXT_FN AF_Graphics_SetDrawTextFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_DRAWTEXT_FN fn);

AE_API AF_GRAPHICS_GETTEXTWIDTH_FN AF_Graphics_SetGetTextWidthFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_GETTEXTWIDTH_FN fn);

AE_API AF_GRAPHICS_GETTEXTHEIGHT_FN AF_Graphics_SetGetTextHeightFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_GETTEXTHEIGHT_FN fn);

AE_API AF_GRAPHICS_FINISH_FN AF_Graphics_SetFinishFn(AF_GRAPHICS *p_struct, AF_GRAPHICS_FINISH_FN fn);

AE_API AF_GRAPHICS *AF_Graphics_List_GetById(const AF_GRAPHICS_LIST *p_list, AQDB_ID p_cmp);

#ifdef __cplusplus
}
#endif

#endif

