/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_GRAPH_DATASET_FNS_H
#define AF_GRAPH_DATASET_FNS_H

#ifdef __cplusplus
extern "C" {
#endif


AE_API double AF_Graph_DataSet_GetRoundedMaxVal(double val);

AE_API void AF_Graph_DataSet_AdjustXRange(AF_GRAPH_DATASET *ds);
AE_API void AF_Graph_DataSet_AdjustYRange(AF_GRAPH_DATASET *ds);

AE_API void AF_Graph_DataSet_AddTicks(AF_GRAPH_DATASET *ds);

AE_API void AF_Graph_DataSet_AddSubGraph(AF_GRAPH_DATASET *ds, const char *label,
                                         int level, int graphType, int dataMode, int colour, int lineWidth, int dashType);

AE_API AF_GRAPH_SUBGRAPH *AF_Graph_DataSet_GetSubGraphByLevel(AF_GRAPH_DATASET *ds, int level);

AE_API void AF_Graph_DataSet_AddDataPair(AF_GRAPH_DATASET *ds, AF_GRAPH_DATAPAIR *dp);

AE_API int AF_Graph_DataSet_GetAverageValueDistX(const AF_GRAPH_DATASET *ds, int level, double *pResult);
AE_API int AF_Graph_DataSet_GetAverageValueDistY(const AF_GRAPH_DATASET *ds, int level, double *pResult);

AE_API int AF_Graph_DataSet_GetMinValueDistX(const AF_GRAPH_DATASET *ds, int level, double *pResult);
AE_API int AF_Graph_DataSet_GetMinValueDistY(const AF_GRAPH_DATASET *ds, int level, double *pResult);


AE_API void AF_Graph_DataSet_SortDataPairs(AF_GRAPH_DATASET *ds, int ascending);

AE_API void AF_Graph_DataSet_AccumulateDataPairs(AF_GRAPH_DATASET *ds, int level);
AE_API void AF_Graph_DataSet_AverageDataPairs(AF_GRAPH_DATASET *ds, int level);
AE_API void AF_Graph_DataSet_FloatingAverageDataPairs(AF_GRAPH_DATASET *ds, int level, int num);


#ifdef __cplusplus
}
#endif



#endif


