/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_GRAPH_TICK_FNS_H
#define AF_GRAPH_TICK_FNS_H

#ifdef __cplusplus
extern "C" {
#endif


AE_API void AF_Graph_Tick_AddTicks(AF_GRAPH_TICK_LIST *tickList, int dataType, double minVal, double maxVal, int prec);

AE_API void AF_Graph_Tick_AddTicks_DateYears(AF_GRAPH_TICK_LIST *tickList, int level, double minVal, double maxVal);
AE_API void AF_Graph_Tick_AddTicks_DateMonths(AF_GRAPH_TICK_LIST *tickList, int level, double minVal, double maxVal);
AE_API void AF_Graph_Tick_AddTicks_DateWeeks(AF_GRAPH_TICK_LIST *tickList, int level, double minVal, double maxVal);
AE_API void AF_Graph_Tick_AddTicks_DateDays(AF_GRAPH_TICK_LIST *tickList, int level, double minVal, double maxVal);


AE_API void AF_Graph_Tick_List_SortByValueAndLevel(AF_GRAPH_TICK_LIST *list, int ascending);

AE_API int AF_Graph_Tick_List_GetAverageValueDist(const AF_GRAPH_TICK_LIST *tl, int level, double *pResult);


#ifdef __cplusplus
}
#endif



#endif


