/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_REPORT_H
#define AF_REPORT_H


#include <gwenhywfar/xml.h>
#include <gwenhywfar/syncio.h>
#include <gwenhywfar/gwendate.h>

#include <aqfinance/engine/ae.h>
#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/report/af_report_decl.h>



#ifdef __cplusplus
extern "C" {
#endif


#define AF_REPORT_HTMLSPLIT_FLAGS_WITH_ASSETS      0x00000001
#define AF_REPORT_HTMLSPLIT_FLAGS_WITH_LIABILITIES 0x00000002
#define AF_REPORT_HTMLSPLIT_FLAGS_WITH_INCOME      0x00000004
#define AF_REPORT_HTMLSPLIT_FLAGS_WITH_EXPENSE     0x00000008
#define AF_REPORT_HTMLSPLIT_FLAGS_WITH_EQUITY      0x00000010

#define AF_REPORT_HTMLSPLIT_FLAGS_SUM_PARENTS      0x00000020



AE_API int AF_Report_BuildHtmlSplitReport(AE_BOOK *b,
                                          const char *mainTitle,
                                          AE_SPLIT_LIST *sl,
                                          uint32_t flags,
                                          GWEN_SYNCIO *sio);





#ifdef __cplusplus
}
#endif


#endif

