/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_REPORT_DATA_FNS_H
#define AF_REPORT_DATA_FNS_H


#ifdef __cplusplus
extern "C" {
#endif


AE_API void AF_Report_Data_AddDataPairToCategories(AF_REPORT_DATA *rd,
                                                   AQDB_ID cat,
                                                   const char *catName,
                                                   const GWEN_DATE *d,
                                                   const AQDB_VALUE *val,
                                                   AF_REPORT_DATAPAIR *dp);
AE_API void AF_Report_Data_AddDataPairToList(AF_REPORT_DATA *rd, AF_REPORT_DATAPAIR *dp);

AE_API void AF_Report_Data_AdjustAxisRange(AF_REPORT_DATA *rd, int idx);
AE_API void AF_Report_Data_SortIntByIdx(AF_REPORT_DATA *rd, int asc, int idx);
AE_API void AF_Report_Data_SortValueByIdx(AF_REPORT_DATA *rd, int asc, int idx);
AE_API void AF_Report_Data_SortDateByIdx(AF_REPORT_DATA *rd, int asc, int idx);
AE_API void AF_Report_Data_SortStringByIdx(AF_REPORT_DATA *rd, int asc, int idx);

AE_API void AF_Report_Data_AddTicksForString(AF_REPORT_DATA *rd,
                                             int idx,
                                             int level,
                                             uint32_t flags,
                                             int color);



#ifdef __cplusplus
}
#endif


#endif

