/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_REPORT_DATAFIELD_FNS_H
#define AF_REPORT_DATAFIELD_FNS_H


#include <gwenhywfar/xml.h>


#ifdef __cplusplus
extern "C" {
#endif


AE_API void AF_Report_DataField_SetData(AF_REPORT_DATAFIELD *df, const char *v);

AE_API void AF_Report_DataField_SetDataAsValue(AF_REPORT_DATAFIELD *df, const AQDB_VALUE *v);
AE_API const AQDB_VALUE *AF_Report_DataField_GetDataAsValue(AF_REPORT_DATAFIELD *df);

AE_API void AF_Report_DataField_SetDataAsInt(AF_REPORT_DATAFIELD *df, int d);
AE_API int AF_Report_DataField_GetDataAsInt(AF_REPORT_DATAFIELD *df);

AE_API void AF_Report_DataField_SetDataAsDate(AF_REPORT_DATAFIELD *df, const GWEN_DATE *d);
AE_API const GWEN_DATE *AF_Report_DataField_GetDataAsDate(AF_REPORT_DATAFIELD *df);




#ifdef __cplusplus
}
#endif


#endif

