/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_REPORT2_H
#define AF_REPORT2_H



#include <aqfinance/engine/ae.h>
#include <aqfinance/report2/af_report2_datapair.h>
#include <aqfinance/report2/af_report2_category.h>
#include <aqfinance/report2/af_report2_settings.h>

#include <aqfinance/graphs/af_graph_dataset.h>

#include <gwenhywfar/types.h>
#include <gwenhywfar/list1.h>
#include <gwenhywfar/list2.h>
#include <gwenhywfar/db.h>
#include <gwenhywfar/xml.h>



typedef struct AF_REPORT2 AF_REPORT2;
GWEN_LIST_FUNCTION_LIB_DEFS(AF_REPORT2, AF_Report2, AE_API)
GWEN_LIST2_FUNCTION_LIB_DEFS(AF_REPORT2, AF_Report2, AE_API)

#include <aqfinance/engine/book/ae_book.h>


#define AF_REPORT2_FLAGS_SUM_MASK     0x00000003
#define AF_REPORT2_FLAGS_SUM_TOTAL    0x00000001
#define AF_REPORT2_FLAGS_SUM_POSITIVE 0x00000002
#define AF_REPORT2_FLAGS_SUM_NEGATIVE 0x00000003

#define AF_REPORT2_FLAGS_REVERSE_SIGN 0x00000004
#define AF_REPORT2_FLAGS_ACCUMULATE   0x00000008
#define AF_REPORT2_FLAGS_ENABLED      0x00000010


enum {
  AF_Report2_DateSpanType_None=0,
  AF_Report2_DateSpanType_UserDefined,

  AF_Report2_DateSpanType_ThisMonth,
  AF_Report2_DateSpanType_ThisQuarterYear,
  AF_Report2_DateSpanType_ThisHalfYear,
  AF_Report2_DateSpanType_ThisYear,

  AF_Report2_DateSpanType_LastMonth,
  AF_Report2_DateSpanType_LastQuarterYear,
  AF_Report2_DateSpanType_LastHalfYear,
  AF_Report2_DateSpanType_LastYear
};


enum {
  AF_Report2_DateUnits_Days=0,
  AF_Report2_DateUnits_Months,
  AF_Report2_DateUnits_Years
};


enum {
  AF_Report2_DataMode_Direct=0,
  AF_Report2_DataMode_Average,
  AF_Report2_DataMode_FloatingAverage
};


AE_API int AF_Report2_CreateReport(AE_BOOK *b, const AF_REPORT2_SETTINGS *settings, const char *fname);




#endif

