/***************************************************************************
 begin       : Sat Jun 25 2011
 copyright   : (C) 2011 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef AF_UPDATE_H
#define AF_UPDATE_H


#include <aqfinance/engine/ae_api.h>
#include <aqfinance/update/af_update_release.h>

#include <gwenhywfar/cryptkey.h>


typedef struct AF_UPDATE AF_UPDATE;


#ifdef __cplusplus
extern "C" {
#endif


AE_API AF_UPDATE *AF_Update_new(const char *server, const char *dataFolder);
AE_API void AF_Update_Attach(AF_UPDATE *upd);
AE_API void AF_Update_free(AF_UPDATE *upd);

/**
 * Takes over the given key
 */
AE_API void AF_Update_SetPubKey(AF_UPDATE *upd, GWEN_CRYPT_KEY *pubKey);

AE_API int AF_Update_Init(AF_UPDATE *upd);
AE_API int AF_Update_Fini(AF_UPDATE *upd);

AE_API int AF_Update_DownloadNewReleaseInfos(AF_UPDATE *upd, AF_UPDATE_RELEASE_LIST *rl);

AE_API int AF_Update_DownloadRelease(AF_UPDATE *upd,
                                     const AF_UPDATE_RELEASE *rel,
                                     const char *fname);
AE_API int AF_Update_UnzipFile(AF_UPDATE *upd, const char *inFile, const char *outFile);


AE_API int AF_Update_InstallRelease(AF_UPDATE *upd, const AF_UPDATE_RELEASE *rel, uint32_t pid);


#ifdef __cplusplus
}
#endif



#endif


