/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_ABOUT_HPP
#define FF_ABOUT_HPP


#include <fx.h>

class FF_App;
class FOX16_HtmlLabel;



class FF_About: public FXDialogBox {
  FXDECLARE(FF_About)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_TEXTFIELD,
    ID_DATEEDIT,
    ID_LAST
  };

  FF_About(FF_App* a,
	   FXComposite *parent,
	   const FXString& title,
	   FXuint opts=DECOR_TITLE|DECOR_BORDER,
	   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	   FXint hs=0, FXint vs=0);
  ~FF_About();

  FXint getDefaultHeight();

  static bool about(FF_App* app,
		    FXComposite *parent,
		    const FXString &title);

  void init();
  void fini();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_About();

  FF_App *m_app;
  FOX16_HtmlLabel *m_label;

};




#endif




