/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_ASKUPDATE_HPP
#define FF_ASKUPDATE_HPP


#include <fx.h>

class FF_App;
class FOX16_HtmlLabel;


class FF_AskUpdate: public FXDialogBox {
  FXDECLARE(FF_AskUpdate)

public:

  FF_AskUpdate(FF_App* a,
	       FXComposite *parent,
	       const FXString& title,
	       const FXString& text,
	       FXuint opts=DECOR_TITLE|DECOR_BORDER,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	       FXint hs=0, FXint vs=0);
  ~FF_AskUpdate();

  FXint getDefaultHeight();

  static bool askUpdate(FF_App* app,
			FXComposite *parent,
			const FXString &title,
			const FXString &text);

  void init();
  void fini();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_AskUpdate();

  FF_App *m_app;
  FXText *m_textBrowser;
};




#endif




