/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_CONFLICTHANDLER_HPP
#define FF_CONFLICTHANDLER_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_dbconflict.h>


class FF_App;


class FF_ConflictHandler: public FXDialogBox {
  FXDECLARE(FF_ConflictHandler);

public:
  FF_ConflictHandler(AE_DBCONFLICT_LIST *clist,
		     FF_App* a,
		     const FXString& title,
		     const FXString& text,
		     FXuint opts=DECOR_TITLE|DECOR_BORDER,
		     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		     FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		     FXint hs=0, FXint vs=0);
  ~FF_ConflictHandler();

  static bool handleConflicts(FF_App* app,
			      const FXString &title,
			      const FXString &text,
			      AE_DBCONFLICT_LIST *clist);

  void init();
  void fini();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_ConflictHandler();

  AE_DBCONFLICT_LIST *m_conflictList;
};




#endif


