/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_DATEPICKER_HPP
#define FF_DATEPICKER_HPP


#include <fx.h>


class FXXDatePicker;


class FF_DatePicker: public FXDialogBox {
  FXDECLARE(FF_DatePicker)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_DATEPICKER,
    ID_LAST
  };

  FF_DatePicker(FXComposite *parent,
                const FXString& title,
                FXuint opts=DECOR_TITLE|DECOR_BORDER,
                FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                FXint hs=0, FXint vs=0);
  ~FF_DatePicker();

  static bool pickDate(FXComposite *parent,
                       const FXString &title,
                       FXDate &result);


  FXint checkGui(FXbool quiet);
  FXint toGui(const FXDate &d);
  FXint fromGui(FXDate &d);

  void create();

  long onCmdDatePicker(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_DatePicker();

  FXXDatePicker *m_datePicker;
};




#endif




