/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_EDITACCSTMRULE_HPP
#define FF_EDITACCSTMRULE_HPP


#include "ff_editstmrule.hpp"

#include <fx.h>

#include <aqfinance/engine/book/ae_rule.h>


class FF_App;
class FF_AccountEdit;


class FF_EditAccountStatementRule: public FF_EditStatementRule {
public:

  FF_EditAccountStatementRule(FF_App* a,
                              FXComposite *parent,
                              const FXString& title,
                              FXuint opts=DECOR_TITLE|DECOR_BORDER,
                              FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                              FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                              FXint hs=0, FXint vs=0);
  ~FF_EditAccountStatementRule();

  static bool editRule(FF_App* app,
                       FXComposite *parent,
                       const FXString &title,
                       AE_RULE *r);

  virtual FXint checkGui(FXbool quiet);
  virtual FXint toGui(const AE_RULE *r);
  virtual FXint fromGui(AE_RULE *r);

protected:
  FF_EditAccountStatementRule();

  FF_AccountEdit *m_accountEdit;
};




#endif


