/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITADDESS_HPP
#define FF_EDITADDESS_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_address.h>


class FF_App;


class FF_EditAddress: public FXDialogBox {
  FXDECLARE(FF_EditAddress)

public:

  enum {
    ID_EDIT_NAME=FXDialogBox::ID_LAST,
    ID_EDIT_STREETNUM,
    ID_EDIT_ZIPCODE,
    ID_EDIT_CITY,
    ID_EDIT_STATE,
    ID_EDIT_REGION,
    ID_EDIT_COUNTRY,
    ID_EDIT_PPHONE,
    ID_EDIT_PMOBILE,
    ID_EDIT_OPHONE,
    ID_EDIT_OMOBILE,
    ID_EDIT_DEPT,
    ID_EDIT_FAX,
    ID_EDIT_EMAIL,
    ID_LAST
  };


  FF_EditAddress(FF_App* a,
		 FXComposite *parent,
		 const FXString& title,
		 FXuint opts=DECOR_TITLE|DECOR_BORDER,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		 FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		 FXint hs=0, FXint vs=0);
  virtual ~FF_EditAddress();


  static bool editAddress(FF_App* app,
			  FXComposite *parent,
			  const FXString &title,
			  AE_ADDRESS *addr);


  int checkGui(FXbool quiet);
  int toGui(const AE_ADDRESS *addr);
  int fromGui(AE_ADDRESS *addr);

  void create();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditAddress();

  FF_App *m_app;

  FXTextField *m_nameEdit;
  FXTextField *m_deptEdit;
  FXTextField *m_streetNumEdit;
  FXTextField *m_zipCodeEdit;
  FXTextField *m_cityEdit;
  FXTextField *m_stateEdit;
  FXTextField *m_regionEdit;
  FXTextField *m_countryEdit;

  FXTextField *m_pPhoneEdit;
  FXTextField *m_pMobilePhoneEdit;

  FXTextField *m_oPhoneEdit;
  FXTextField *m_oMobilePhoneEdit;

  FXTextField *m_faxEdit;
  FXTextField *m_emailEdit;

  FXCheckButton *m_billingCheck;
  FXCheckButton *m_deliveryCheck;

};




#endif




