/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITBANKACCOUNT_HPP
#define FF_EDITBANKACCOUNT_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_bankaccount.h>


class FF_App;
class FF_GroupTree;
class FF_CommodityEdit;


class FF_EditBankAccount: public FXDialogBox {
  FXDECLARE(FF_EditBankAccount)

public:

  enum {
    ID_TEXTFIELD_ACCTID=FXDialogBox::ID_LAST,
    ID_COMBO_COUNTRY,
    ID_TEXTFIELD_BANKCODE,
    ID_TEXTFIELD_BIC,
    ID_TEXTFIELD_IBAN,
    ID_GROUP,
    ID_TEXTFIELD_BANKNAME,
    ID_TEXTFIELD_ACCOUNTNAME,
    ID_COMBO_CURRENCY,
    ID_TEXTFIELD_OWNERNAME,
    ID_LAST
  };

  enum {
    FF_EDITBANKACCOUNT_OPTS_SHOWGROUP = 0x80000000
  };

  FF_EditBankAccount(FF_App* a,
                     FXComposite *parent,
                     const FXString& title,
                     FXuint opts=DECOR_TITLE|DECOR_BORDER,
                     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                     FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                     FXint hs=0, FXint vs=0);
  ~FF_EditBankAccount();

  static bool editBankAccount(FF_App* app,
                              FXComposite *parent,
			      const FXString &title,
                              FXuint opts,
			      AE_BANKACCOUNT *ba);

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_BANKACCOUNT *ba);
  FXint fromGui(AE_BANKACCOUNT *ba);

  void create();

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);
  long onCmdTextField(FXObject*, FXSelector, void *ptr);
  long onCmdBankCode(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  FXint getDefaultHeight();

protected:
  FF_EditBankAccount();

  void updateBankName();

  FF_App *m_app;
  FXTextField *m_ownerNameEdit;
  FXListBox *m_countryCombo;
  FXTextField *m_bankNameEdit;
  FXTextField *m_accountNameEdit;
  FXTextField *m_acctIdEdit;
  FXTextField *m_bankCodeEdit;
  FXTextField *m_ibanEdit;
  FXTextField *m_bicEdit;
  FF_CommodityEdit *m_currencyEdit;
  FF_GroupTree *m_groupTree;

};




#endif




