/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITCURRENCY_HPP
#define FF_EDITCURRENCY_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_commodity.h>


class FF_App;
class FOX16_HtmlLabel;
class FF_DateEdit;


class FF_EditCurrency: public FXDialogBox {
  FXDECLARE(FF_EditCurrency)

public:

  enum {
    ID_EDIT_CODE=FXDialogBox::ID_LAST,
    ID_EDIT_NAME,
    ID_EDIT_SYMBOL,
    ID_EDIT_DESCR,
    ID_EDIT_FRACTION,
    ID_LAST
  };


  FF_EditCurrency(FF_App* a,
                  FXComposite *parent,
                  const FXString& title,
                  FXuint opts=DECOR_TITLE|DECOR_BORDER,
                  FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                  FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                  FXint hs=0, FXint vs=0);
  virtual ~FF_EditCurrency();


  static bool editCurrency(FF_App* app,
                           FXComposite *parent,
                           const FXString &title,
                           AE_COMMODITY *co);


  int checkGui(FXbool quiet);
  int toGui(const AE_COMMODITY *co);
  int fromGui(AE_COMMODITY *co);

  void create();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdFraction(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditCurrency();

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;

  FXTextField *m_codeEdit;
  FXTextField *m_nameEdit;
  FXTextField *m_symbolEdit;
  FXTextField *m_descrEdit;
  FXTextField *m_fractionEdit;
};




#endif




