/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITGROUP_HPP
#define FF_EDITGROUP_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_group.h>


class FF_App;
class FF_GroupTree;


class FF_EditGroup: public FXDialogBox {
  FXDECLARE(FF_EditGroup)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_TEXTFIELD,
    ID_GROUP,
    ID_LAST
  };

  FF_EditGroup(FF_App* a,
	       FXComposite *parent,
	       const FXString& title,
	       FXuint opts=DECOR_TITLE|DECOR_BORDER,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	       FXint hs=0, FXint vs=0);
  ~FF_EditGroup();

  FXint getDefaultHeight();

  static bool editGroup(FF_App* app,
			FXComposite *parent,
			const FXString &title,
			AE_BOOK_TABLE_TYPE tt,
			AE_GROUP *gr);

  void init();
  void fini();

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_GROUP *gr, AE_BOOK_TABLE_TYPE tt);
  FXint fromGui(AE_GROUP *gr);

  void create();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditGroup();

  FF_App *m_app;
  FXTextField *m_nameEdit;
  FF_GroupTree *m_groupTree;

};




#endif




