/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITLOADCELLPHONE_HPP
#define FF_EDITLOADCELLPHONE_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_load_cellphone.h>

#include <aqbanking/cellphoneproduct.h>



class FF_App;


class FF_EditLoadCellPhone: public FXDialogBox {
  FXDECLARE(FF_EditLoadCellPhone)

public:

  enum {
    ID_COMBO_LOCAL_ACC=FXDialogBox::ID_LAST,
    ID_PHONE_NUMBER,
    ID_COMBO_PRODUCT,
    ID_EDIT_AMOUNT,
    ID_COMBO_CURRENCY,
    ID_LAST
  };

  FF_EditLoadCellPhone(FF_App* a,
                       FXComposite *parent,
                       const FXString& title,
                       FXuint opts=DECOR_TITLE|DECOR_BORDER,
                       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                       FXint hs=0, FXint vs=0);
  ~FF_EditLoadCellPhone();

  FXint getDefaultHeight();

  static bool editLoadCellPhone(FF_App* app,
                                FXComposite *parent,
                                const FXString &title,
                                AE_LOAD_CELLPHONE *lc);

  void init();
  void fini();

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_LOAD_CELLPHONE *lc);
  FXint fromGui(AE_LOAD_CELLPHONE *lc);

  void create();

  long onCmdLocalAccount(FXObject*, FXSelector, void *ptr);
  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAmount(FXObject*, FXSelector, void *ptr);

  long onCmdDate(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditLoadCellPhone();

  virtual void selectLocalAccount(int i);
  FXString createCellPhoneComboString(const char *providerName, const char *productName);


  FF_App *m_app;
  FXComboBox *m_localAccountCombo;
  FXComboBox *m_productCombo;

  FXTextField *m_phoneNumberEdit;
  FXTextField *m_memoEdit;

  FXTextField *m_amountEdit;
  FXComboBox *m_currencyCombo;

  AE_BANKACCOUNT_LIST *m_bankAccountList;
  AB_CELLPHONE_PRODUCT_LIST *m_productList;

};




#endif




