/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITPAYMENT_HPP
#define FF_EDITPAYMENT_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_job.h>


class FF_App;
class FF_DateEdit;
class FF_ItemTable;
class FF_PartnerEdit;
class FF_ValueEdit;
class FOX16_HtmlLabel;


class FF_EditPayment: public FXDialogBox {
  FXDECLARE(FF_EditPayment)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_TEXTFIELD,
    ID_DATEEDIT,
    ID_LAST
  };

  FF_EditPayment(bool isBuy,
		 FF_App* a,
		 FXComposite *parent,
		 const FXString& title,
		 FXuint opts=DECOR_TITLE|DECOR_BORDER,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		 FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		 FXint hs=0, FXint vs=0);
  ~FF_EditPayment();

  FXint getDefaultHeight();

  static bool editPayment(FF_App* app,
			  FXComposite *parent,
			  const FXString &title,
			  AE_JOB *j,
			  bool isBuy);

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_JOB *j);
  FXint fromGui(AE_JOB *j);

  void init();
  void fini();

  void reload();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditPayment();

  FF_App *m_app;

  FF_DateEdit *m_enterDateEdit;
  FF_ValueEdit *m_valueEdit;

  AE_COMMODITY_LIST *m_commodities;

  bool m_isBuy;
};




#endif




