/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITRULE_HPP
#define FF_EDITRULE_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_rule.h>


class FF_App;


class FF_EditRule: public FXDialogBox {
  FXDECLARE(FF_EditRule)

public:

  enum {
    MAX_SUBRULES=4
  };

  enum {
    ID_CHECK_COMBINEMODE=FXDialogBox::ID_LAST,
    ID_COMBO_FIELD,
    ID_COMBO_OPERATOR,
    ID_TEXTFIELD_OPERAND,
    ID_LAST
  };

  typedef struct {
    const char *name;
    const char *text;
  } FieldDescription;


  FF_EditRule(FF_App* a,
              const FieldDescription *fd,
              FXComposite *parent,
              const FXString& title,
              FXuint opts=DECOR_TITLE|DECOR_BORDER,
              FXint x=0, FXint y=0, FXint w=0, FXint h=0,
              FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
              FXint hs=0, FXint vs=0);
  ~FF_EditRule();

  static bool editRule(FF_App* app,
                       const FieldDescription *fd,
                       FXComposite *parent,
                       const FXString &title,
                       AE_RULE *r);

  void init();
  void fini();

  virtual FXint checkGui(FXbool quiet);
  virtual FXint toGui(const AE_RULE *r);
  virtual FXint fromGui(AE_RULE *r);

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  void addDialogLine();

protected:
  FF_EditRule();

  FF_App *m_app;
  const FieldDescription *m_fieldDescriptions;

  FXButton *m_okButton;
  FXButton *m_abortButton;
  FXVerticalFrame *m_verticalFrame;
  FXCheckButton *m_checkCombineAnd;
  FXComboBox *m_comboField[MAX_SUBRULES];
  FXComboBox *m_comboOperator[MAX_SUBRULES];
  FXTextField *m_editOperand[MAX_SUBRULES];

};




#endif




