/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITTAX_HPP
#define FF_EDITTAX_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_tax.h>


class FF_App;
class FOX16_HtmlLabel;
class FF_AmountEdit;
class FF_GroupView;
class FF_AccountEdit;


class FF_EditTax: public FXDialogBox {
  FXDECLARE(FF_EditTax)

public:

  enum {
    ID_EDIT_CODE=FXDialogBox::ID_LAST,
    ID_EDIT_NAME,
    ID_EDIT_DESCR,
    ID_LIST_TYPE,
    ID_EDIT_AMOUNT,
    ID_VIEW_GROUP,
    ID_LAST
  };


  FF_EditTax(FF_App* a,
	     FXComposite *parent,
	     const FXString& title,
	     FXuint opts=DECOR_TITLE|DECOR_BORDER,
	     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	     FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	     FXint hs=0, FXint vs=0);
  virtual ~FF_EditTax();


  static bool editTax(FF_App* app,
		      FXComposite *parent,
		      const FXString &title,
		      AE_TAX *tax);


  void init();
  void fini();

  int checkGui(FXbool quiet);
  int toGui(const AE_TAX *tax);
  int fromGui(AE_TAX *tax);

  void create();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdTypeList(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditTax();

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;

  FXTextField *m_codeEdit;
  FXTextField *m_nameEdit;
  FXTextField *m_descrEdit;
  FF_AccountEdit *m_taxAccountEdit;
  FXListBox *m_typeList;
  FXLabel *m_valueLabel;
  FF_AmountEdit *m_valueEdit;
  FF_GroupView *m_groupView;

};




#endif




