/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITTRANSACTION_HPP
#define FF_EDITTRANSACTION_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_transaction.h>


class FF_App;
class FF_DateEdit;
class FF_SplitTable;
class FF_PartnerEdit;
class FOX16_HtmlLabel;


class FF_EditTransaction: public FXDialogBox {
  FXDECLARE(FF_EditTransaction)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_TABBOOK,
    ID_TEXTFIELD,
    ID_SPLIT_TABLE,
    ID_DATEEDIT,
    ID_CMD_DELSPLIT,
    ID_LAST
  };

  FF_EditTransaction(FF_App* a,
		     FXComposite *parent,
		     const FXString& title,
		     FXuint opts=DECOR_TITLE|DECOR_BORDER,
		     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		     FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		     FXint hs=0, FXint vs=0);
  ~FF_EditTransaction();

  FXint getDefaultHeight();

  static bool editTransaction(FF_App* app,
			      FXComposite *parent,
			      const FXString &title,
			      AE_TRANSACTION *t);

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_TRANSACTION *t);
  FXint fromGui(AE_TRANSACTION *t);

  void init();
  void fini();

  void create();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);
  long onRplSplitTable(FXObject*, FXSelector, void *ptr);
  long onCmdPartnerEdit(FXObject*, FXSelector, void *ptr);

  long onListRightBtnReleased(FXObject*, FXSelector, void *ptr);
  long onCmdDelSplit(FXObject*, FXSelector, void* ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditTransaction();

  FF_App *m_app;

  FF_DateEdit *m_dateEdit;
  FXTextField *m_receiptEdit;
  FXTextField *m_memoEdit;

  FF_SplitTable *m_splitTable;
  FOX16_HtmlLabel *m_helpLabel;


};




#endif




