/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_EDITTRANSACTIONS_HPP
#define FF_EDITTRANSACTIONS_HPP


#include "ff_transactiontable.hpp"

#include <aqfinance/engine/book/ae_transaction.h>

#include <fx.h>

#include <list>



class FF_App;
class FOX16_HtmlLabel;



class FF_EditTransactions: public FXDialogBox {
  FXDECLARE(FF_EditTransactions)
public:

  enum {
    ID_TRANSACTION_LIST=FXDialogBox::ID_LAST,
    ID_FILTER_BY_PURPOSE,
    ID_FILTER_BY_ACCOUNT,
    ID_FILTER_BY_NAME,
    ID_AUTOMATCH,
    ID_EDIT_SPLITS,
    ID_LAST
  };

  FF_EditTransactions(FF_App* a,
                      FXComposite *parent,
                      const FXString& title,
                      FXuint opts=DECOR_TITLE|DECOR_BORDER,
                      FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                      FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                      FXint hs=0, FXint vs=0);
  ~FF_EditTransactions();

  static bool editTransactions(FF_App* app,
                               FXComposite *parent,
                               const FXString &title,
                               AE_TRANSACTION_LIST *tlist);

  void init();
  void fini();

  FXint checkGui(FXbool quiet);
  void toGui(const AE_TRANSACTION_LIST *tlist);
  void fromGui(AE_TRANSACTION_LIST *tlist);

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onCmdFilterByPurpose(FXObject*, FXSelector, void *ptr);
  long onCmdFilterByAccount(FXObject*, FXSelector, void *ptr);
  long onCmdFilterByName(FXObject*, FXSelector, void *ptr);

  long onCmdAutoMatch(FXObject*, FXSelector, void *ptr);
  long onCmdSplitEditor(FXObject*, FXSelector, void *ptr);

  long onListRightBtnReleased(FXObject*, FXSelector, void *ptr);

  void autoMatch();

protected:
  FF_EditTransactions();

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;
  FF_TransactionTable *m_transactionTable;
};


#endif


