/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITTRANSFERGROUP_HPP
#define FF_EDITTRANSFERGROUP_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_group.h>


class FF_App;
class FF_GroupTree;


class FF_EditTransferGroup: public FXDialogBox {
  FXDECLARE(FF_EditTransferGroup)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_TEXTFIELD,
    ID_GROUP,
    ID_LAST
  };

  FF_EditTransferGroup(FF_App* a,
                          FXComposite *parent,
                          const FXString& title,
                          FXuint opts=DECOR_TITLE|DECOR_BORDER,
                          FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                          FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                          FXint hs=0, FXint vs=0);
  ~FF_EditTransferGroup();

  FXint getDefaultHeight();

  static bool editGroup(FF_App* app,
                        FXComposite *parent,
                        const FXString &title,
                        AE_GROUP *gr);

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_GROUP *gr);
  FXint fromGui(AE_GROUP *gr);

  void create();

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);
  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditTransferGroup();

  FF_App *m_app;
  FXComboBox *m_moduleCombo;
  FXTextField *m_nameEdit;
  FF_GroupTree *m_groupTree;

};




#endif




