/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2012 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITVEHICLE_HPP
#define FF_EDITVEHICLE_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_vehicle.h>


class FF_App;
class FF_DateEdit;
class FF_GroupTree;


class FF_EditVehicle: public FXDialogBox {
  FXDECLARE(FF_EditVehicle)

public:

  enum {
    ID_EDIT_NAME=FXDialogBox::ID_LAST,
    ID_EDIT_MAKE,
    ID_EDIT_MODEL,
    ID_EDIT_BUILDYEAR,
    ID_EDIT_BASE,
    ID_EDIT_LICENSEPLATE,
    ID_EDIT_VIN,
    ID_EDIT_MEMO,
    ID_EDIT_FUELCAPACITY,
    ID_EDIT_BUYDATE,
    ID_GROUP,
    ID_LAST
  };


  FF_EditVehicle(FF_App* a,
		 FXComposite *parent,
		 const FXString& title,
		 FXuint opts=DECOR_TITLE|DECOR_BORDER,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		 FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		 FXint hs=0, FXint vs=0);
  virtual ~FF_EditVehicle();


  static bool editVehicle(FF_App* app,
                          FXComposite *parent,
                          const FXString &title,
                          AE_VEHICLE *veh);

  void init();
  void fini();

  int checkGui(FXbool quiet);
  int toGui(const AE_VEHICLE *veh);
  int fromGui(AE_VEHICLE *veh);

  void create();
  FXint getDefaultHeight();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditVehicle();

  bool _checkValueAndUnits(FXbool quiet, FXbool needed, FXTextField *tf, const FXString &errorTitle);
  int _strToValue(FXbool needed, const FXString &str, AQDB_VALUE **pValue, int *pUnits);

  FF_App *m_app;

  FXTextField *m_nameEdit;
  FXTextField *m_makeEdit;
  FXTextField *m_modelEdit;
  FXTextField *m_buildYearEdit;
  FXTextField *m_baseEdit;
  FXTextField *m_licensePlateEdit;
  FXTextField *m_identificationNumberEdit;
  FXTextField *m_memoEdit;
  FXTextField *m_fuelCapacityEdit;
  FF_DateEdit *m_buyDateEdit;
  FF_GroupTree *m_groupTree;

};




#endif




