/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_FLICKERDIALOG_HPP
#define FF_FLICKERDIALOG_HPP


#include <fx.h>

class FF_App;
class FOX16_HtmlLabel;

class FF_FlickerWidget;


class FF_FlickerDialog: public FXDialogBox {
  FXDECLARE(FF_FlickerDialog)

public:

  enum {
    ID_BUTTON_WIDTH_UP=FXDialogBox::ID_LAST,
    ID_BUTTON_WIDTH_DOWN,
    ID_BUTTON_HEIGHT_UP,
    ID_BUTTON_HEIGHT_DOWN,
    ID_BUTTON_SPEED_UP,
    ID_BUTTON_SPEED_DOWN,
    ID_EDIT_TAN,
    ID_LAST
  };

  FF_FlickerDialog(FF_App* a,
                   FXWindow *parent,
                   const FXString& title,
                   FXuint opts=DECOR_TITLE|DECOR_BORDER,
                   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                   FXint hs=0, FXint vs=0);
  ~FF_FlickerDialog();

  static bool getTan(FF_App* app,
                     FXWindow *parent,
                     const FXString &title,
                     const FXString &message,
                     const FXString &code,
                     int minLen,
                     int maxLen,
                     FXString &response);


  void init();
  void fini();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onCmdWidthUp(FXObject*, FXSelector, void *ptr);
  long onCmdWidthDown(FXObject*, FXSelector, void *ptr);

  long onCmdHeightUp(FXObject*, FXSelector, void *ptr);
  long onCmdHeightDown(FXObject*, FXSelector, void *ptr);

  long onCmdSpeedUp(FXObject*, FXSelector, void *ptr);
  long onCmdSpeedDown(FXObject*, FXSelector, void *ptr);

  long onCmdTan(FXObject*, FXSelector, void *ptr);
  long onChgTan(FXObject*, FXSelector, void *ptr);

protected:
  FF_FlickerDialog();

  FF_App *m_app;
  int m_tanMinLen;
  int m_tanMaxLen;
  FOX16_HtmlLabel *m_label;

  FXButton *m_widthDownButton;
  FXButton *m_widthUpButton;

  FXButton *m_heightDownButton;
  FXButton *m_heightUpButton;

  FXButton *m_speedDownButton;
  FXButton *m_speedUpButton;

  FF_FlickerWidget *m_flickerWidget;
  FXTextField *m_tanInput;
  FXButton *m_okButton;

  FXIcon *m_iconWidthDown;
  FXIcon *m_iconWidthUp;

  FXIcon *m_iconHeightDown;
  FXIcon *m_iconHeightUp;

  FXIcon *m_iconSpeedDown;
  FXIcon *m_iconSpeedUp;

};




#endif




