/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_MANAGETAXES_HPP
#define FF_MANAGETAXES_HPP


#include <fx.h>

#include <list>



class FF_App;
class FF_TaxView;



class FF_ManageTaxes: public FXDialogBox {
  FXDECLARE(FF_ManageTaxes)
public:

  enum {
    ID_TAX_VIEW=FXDialogBox::ID_LAST,
    ID_LAST
  };

  FF_ManageTaxes(FF_App* a,
		 FXComposite *parent,
		 const FXString& title,
		 FXuint opts=DECOR_TITLE|DECOR_BORDER,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		 FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		 FXint hs=0, FXint vs=0);
  ~FF_ManageTaxes();

  static void manageTaxes(FF_App* app,
			  FXComposite *parent,
			  const FXString &title);

  void init();
  void fini();

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);

  long onTaxInserted(FXObject*, FXSelector, void*);
  long onTaxReplaced(FXObject*, FXSelector, void*);
  long onTaxOpened(FXObject*, FXSelector, void*);

protected:
  FF_ManageTaxes();

  void reload();

  FF_App *m_app;

  FF_TaxView *m_taxView;
};


#endif


