/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_MANAGETRANSFERS_HPP
#define FF_MANAGETRANSFERS_HPP


#include <aqfinance/engine/book/ae_book.h>

#include <fx.h>

#include <list>



class FF_App;
class FF_TransferView;



class FF_ManageTransfers: public FXDialogBox {
  FXDECLARE(FF_ManageTransfers)
public:

  enum {
    ID_STATEMENT_VIEW=FXDialogBox::ID_LAST,
    ID_LAST
  };

  FF_ManageTransfers(FF_App* a,
                     FXComposite *parent,
                     const FXString& title,
                     AE_BOOK_TABLE_TYPE tt,
                     FXuint opts=DECOR_TITLE|DECOR_BORDER,
                     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                     FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                     FXint hs=0, FXint vs=0);
  ~FF_ManageTransfers();

  static void manageTransfers(FF_App* app,
                              FXComposite *parent,
                              const FXString &title,
                              AE_BOOK_TABLE_TYPE tt);

  void init();
  void fini();

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);

  long onTransferInserted(FXObject*, FXSelector, void*);
  long onTransferReplaced(FXObject*, FXSelector, void*);
  long onTransferOpened(FXObject*, FXSelector, void*);
  long onTransferDeleted(FXObject*, FXSelector, void *ptr);

protected:
  FF_ManageTransfers();

  void reload();

  FF_App *m_app;

  FF_TransferView *m_transferView;
  AE_BOOK_TABLE_TYPE m_type;

};


#endif


