/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_OPENDB_HPP
#define FF_OPENDB_HPP


#include <fx.h>



class FF_App;
class FOX16_HtmlLabel;


class FF_OpenDB: public FXDialogBox {
  FXDECLARE(FF_OpenDB)

public:

  enum {
    ID_COMBOBOX=FXDialogBox::ID_LAST,
    ID_TEXTFIELD,
    ID_PATHBUTTON,
    ID_LAST
  };

  FF_OpenDB(FF_App* a,
            FXComposite *parent,
            const FXString& title,
            FXuint opts=DECOR_TITLE|DECOR_BORDER,
            FXint x=0, FXint y=0, FXint w=0, FXint h=0,
            FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	    FXint hs=0, FXint vs=0);
  ~FF_OpenDB();

  static FXString getCreateDbUrl(FF_App* app,
                                 FXComposite *parent,
                                 const FXString &title,
                                 const FXString &url);

  static FXString getOpenDbUrl(FF_App* app,
                               FXComposite *parent,
                               const FXString &title,
                               const FXString &url);


  FXint checkGui(FXbool quiet);
  FXint toGui(const FXString &url);
  FXint fromGui(FXString &url);

  void create();

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);
  long onCmdPathButton(FXObject*, FXSelector, void *ptr);
  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_OpenDB();

  void selectModule(int i);

  FXComboBox *m_moduleCombo;
  FXLabel *m_pathLabel;
  FXTextField *m_pathEdit;
  FXButton *m_pathButton;
  FOX16_HtmlLabel *m_moduleLabel;

  bool m_mustExist;
};




#endif




