/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_PICKSTARTDATE_HPP
#define FF_PICKSTARTDATE_HPP


#include <fx.h>

#include <list>


class FOX16_HtmlLabel;
class FF_DateEdit;


class FF_PickStartDate: public FXDialogBox {
  FXDECLARE(FF_PickStartDate)
public:

  enum {
    ID_NODATE=FXDialogBox::ID_LAST,
    ID_LAST_UPDATE,
    ID_FIRST_POSSIBLE,
    ID_CUSTOM_BUTTON,
    ID_CUSTOM_EDIT,
    ID_LAST
  };

  FF_PickStartDate(FXComposite *parent,
		   const FXString& title,
		   FXuint opts=DECOR_TITLE|DECOR_BORDER,
		   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		   FXint hs=0, FXint vs=0);
  ~FF_PickStartDate();

  static bool pickStartDate(FXComposite *parent,
                            const FXString &title,
                            const FXDate &firstPossible,
                            const FXDate &lastUpdate,
                            int defaultChoice,
                            FXDate &result);

  const FXDate &getFirstPossibleDate() const { return m_firstPossibleDate;};
  void setFirstPossibleDate(const FXDate &d) { m_firstPossibleDate=d;};

  const FXDate &getLastUpdateDate() const { return m_lastUpdateDate;};
  void setLastUpdateDate(const FXDate &d) { m_lastUpdateDate=d;};

  int getDefaultChoice() const { return m_defaultChoice;};
  void setDefaultChoice(int i) { m_defaultChoice=i;};

  void toGui();
  int fromGui(FXDate &d);
  int checkGui(bool quiet);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onCmdTextField(FXObject*, FXSelector, void *ptr);
  long onCmdNoDate(FXObject*, FXSelector, void *ptr);
  long onCmdLastUpdate(FXObject*, FXSelector, void *ptr);
  long onCmdFirstPossible(FXObject*, FXSelector, void *ptr);
  long onCmdCustomDate(FXObject*, FXSelector, void *ptr);


protected:

  FF_PickStartDate();

  void selectRadioButton(int i);


  FXDate m_firstPossibleDate;
  FXDate m_lastUpdateDate;
  int m_defaultChoice;

  FOX16_HtmlLabel *m_label;
  FXRadioButton *m_buttonNoDate;
  FXRadioButton *m_buttonLastDate;
  FXLabel *m_lastDateLabel;
  FXRadioButton *m_buttonFirstDate;
  FXLabel *m_firstDateLabel;
  FXRadioButton *m_buttonCustomDate;
  FF_DateEdit *m_customDateEdit;
  FXButton *m_okButton;

};


#endif


