/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_PICKTRANSFER_HPP
#define FF_PICKTRANSFER_HPP


#include <aqfinance/engine/book/ae_book.h>

#include <fx.h>

#include <list>



class FF_App;
class FF_TransferTree;



class FF_PickTransfer: public FXDialogBox {
  FXDECLARE(FF_PickTransfer)
public:

  enum {
    ID_STATEMENT_TREE=FXDialogBox::ID_LAST,
    ID_LAST
  };

  FF_PickTransfer(FF_App* a,
                  FXComposite *parent,
                  const FXString& title,
                  AE_BOOK_TABLE_TYPE tt,
                  FXuint opts=DECOR_TITLE|DECOR_BORDER,
                  FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                  FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                  FXint hs=0, FXint vs=0);
  ~FF_PickTransfer();

  static bool pickTransfer(FF_App* app,
                           FXComposite *parent,
                           const FXString &title,
                           AE_BOOK_TABLE_TYPE tt,
                           AE_STATEMENT **pStm);

  void init();
  void fini();

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onTreeChanged(FXObject*, FXSelector, void*);
  long onTreeDoubleClicked(FXObject*, FXSelector, void*);

protected:
  FF_PickTransfer();

  void reload();

  FF_App *m_app;

  FF_TransferTree *m_transferTree;
  FXButton *m_acceptButton;
  AE_BOOK_TABLE_TYPE m_type;
  AE_STATEMENT *m_selectedStatement;
};


#endif


