/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_SELECTACCOUNT_HPP
#define FF_SELECTACCOUNT_HPP


#include <aqfinance/engine/book/ae_account.h>


#include <fx.h>

#include <list>



class FF_App;
class FOX16_HtmlLabel;
class FF_AccountTree;



class FF_SelectAccount: public FXDialogBox {
  FXDECLARE(FF_SelectAccount)
public:

  enum {
    ID_ACCOUNT_LIST=FXDialogBox::ID_LAST,
    ID_CREATE_ACCOUNT,
    ID_EDIT_ACCOUNT,
    ID_MATCHER,
    ID_LAST
  };

  FF_SelectAccount(FF_App* a,
                   FXComposite *parent,
                   const FXString& title,
                   AQDB_ID id,
                   FXuint opts=DECOR_TITLE|DECOR_BORDER,
                   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                   FXint hs=0, FXint vs=0);

  FF_SelectAccount(FF_App* a,
                   const FXString& title,
                   AQDB_ID id,
                   FXuint opts=DECOR_TITLE|DECOR_BORDER,
                   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                   FXint hs=0, FXint vs=0);
  ~FF_SelectAccount();

  static bool selectAccount(FF_App* app,
                            FXComposite *parent,
                            const FXString &title,
                            AQDB_ID &id);

  static bool selectAccount(FF_App* app,
                            const FXString &title,
                            AQDB_ID &id);

  FXint checkGui(FXbool quiet);
  FXint toGui(AQDB_ID id);
  FXint fromGui(AQDB_ID &id);

  void init();
  void fini();

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);
  long onCmdCreateAccount(FXObject*, FXSelector, void *ptr);
  long onCmdEditAccount(FXObject*, FXSelector, void *ptr);

  long onChgMatcher(FXObject*, FXSelector, void* ptr);

protected:
  FF_SelectAccount();

  void rebuild();

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;

  FF_AccountTree *m_accountTree;

  AQDB_ID m_accountId;

  FXTextField *m_matcher;

};


#endif


