/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_SELECTBANKACC_HPP
#define FF_SELECTBANKACC_HPP


#include <aqfinance/engine/book/ae_bankaccount.h>


#include <fx.h>

#include <list>



class FF_App;
class FOX16_HtmlLabel;
class FF_BankAccountTree;



class FF_SelectBankAccount: public FXDialogBox {
  FXDECLARE(FF_SelectBankAccount)
public:

  enum {
    ID_ACCOUNT_LIST=FXDialogBox::ID_LAST,
    ID_BUTTON_CREATE,
    ID_LAST
  };

  FF_SelectBankAccount(FF_App* a,
                       FXComposite *parent,
                       const FXString& title,
                       FXuint opts=DECOR_TITLE|DECOR_BORDER,
                       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                       FXint hs=0, FXint vs=0);
  ~FF_SelectBankAccount();

  static bool selectAccount(FF_App* app,
                            FXComposite *parent,
                            const FXString &title,
                            const AE_BANKACCOUNT *ba,
                            AQDB_ID &id);

  void init();
  void fini();

  FXint checkGui(FXbool quiet);
  FXint toGui(const AE_BANKACCOUNT *ba, AQDB_ID id);
  FXint fromGui(AQDB_ID &id);

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onCmdCreate(FXObject*, FXSelector, void *ptr);

protected:
  FF_SelectBankAccount();

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;
  FXButton *m_okButton;

  FF_BankAccountTree *m_accountTree;

  const AE_BANKACCOUNT *m_presetBankAccount;
};


#endif


