/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SELECTITEM_HPP
#define FF_SELECTITEM_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_item.h>


class FF_App;
class FF_ItemView;
class FOX16_HtmlLabel;


class FF_SelectItem: public FXDialogBox {
  FXDECLARE(FF_SelectItem)

public:

  enum {
    ID_ITEM_VIEW=FXDialogBox::ID_LAST,
    ID_LAST
  };

  FF_SelectItem(FF_App* a,
		FXComposite *parent,
		const FXString& title,
		FXuint opts=DECOR_TITLE|DECOR_BORDER,
		FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		FXint hs=0, FXint vs=0);
  ~FF_SelectItem();

  FXint getDefaultHeight();

  AE_ITEM *getSelectedEngineItem();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onEngineItemInserted(FXObject*, FXSelector, void*);
  long onEngineItemReplaced(FXObject*, FXSelector, void*);
  long onEngineItemOpened(FXObject*, FXSelector, void*);

  void init();
  void fini();


  /**
   * The tax returned (if any) must be freed by the caller using @ref AE_Item_free.
   */
  static AE_ITEM *selectEngineItem(FF_App* a,
				   FXComposite *parent,
				   const FXString& title,
				   FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE);


protected:
  FF_SelectItem();

  void reload();

  FF_App *m_app;
  FOX16_HtmlLabel *m_label;
  FF_ItemView *m_itemView;
};




#endif




