/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_SELECTJOB_HPP
#define FF_SELECTJOB_HPP


#include <aqfinance/engine/book/ae_task.h>
#include <aqfinance/engine/book/ae_job.h>


#include <fx.h>

#include <list>



class FF_App;
class FOX16_HtmlLabel;
class FF_JobTree;



class FF_SelectJob: public FXDialogBox {
  FXDECLARE(FF_SelectJob)
public:

  enum {
    ID_JOB_LIST=FXDialogBox::ID_LAST,
    ID_LAST
  };

  typedef enum {
    JobSelection_Buys =0x8000,
    JobSelection_Sells=0x4000,
    JobSelection_All  =0xc000
  } JobSelection;


  FF_SelectJob(FF_App* a,
	       FXComposite *parent,
	       const FXString& title,
	       const FXString &text,
	       AQDB_ID id,
               JobSelection js,
	       FXuint opts=DECOR_TITLE|DECOR_BORDER,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	       FXint hs=0, FXint vs=0);

  FF_SelectJob(FF_App* a,
	       const FXString& title,
	       const FXString &text,
	       AQDB_ID id,
               JobSelection js,
	       FXuint opts=DECOR_TITLE|DECOR_BORDER,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	       FXint hs=0, FXint vs=0);
  ~FF_SelectJob();

  static bool selectJob(FF_App* app,
			FXComposite *parent,
			const FXString &title,
			const FXString &text,
			AQDB_ID &id,
			JobSelection js);

  static bool selectJob(FF_App* app,
			const FXString &title,
			const FXString &text,
			AQDB_ID &id,
			JobSelection js);

  FXint checkGui(FXbool quiet);
  FXint toGui(AQDB_ID id);
  FXint fromGui(AQDB_ID &id);

  void init();
  void fini();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_SelectJob();

  void rebuild();
  void construct(const FXString &text);

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;

  FF_JobTree *m_jobTree;

  AQDB_ID m_jobId;
  JobSelection m_jobSelection;
};


#endif


