/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SELECTPARTNER_HPP
#define FF_SELECTPARTNER_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_partner.h>


class FF_App;
class FF_PartnerView;
class FOX16_HtmlLabel;


class FF_SelectPartner: public FXDialogBox {
  FXDECLARE(FF_SelectPartner)

public:

  enum {
    ID_PARTNER_VIEW=FXDialogBox::ID_LAST,
    ID_MATCHER,
    ID_LAST
  };

  FF_SelectPartner(FF_App* a,
		   FXComposite *parent,
		   const FXString& title,
		   FXuint opts=DECOR_TITLE|DECOR_BORDER,
		   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		   FXint hs=0, FXint vs=0);
  ~FF_SelectPartner();

  FXint getDefaultHeight();

  AE_PARTNER *getSelectedPartner();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onPartnerInserted(FXObject*, FXSelector, void*);
  long onPartnerReplaced(FXObject*, FXSelector, void*);
  long onPartnerOpened(FXObject*, FXSelector, void*);

  long onChgMatcher(FXObject*, FXSelector, void* ptr);

  void init();
  void fini();


  /**
   * The partner returned (if any) must be freed by the caller using @ref AE_Partner_free.
   */
  static AE_PARTNER *selectPartner(FF_App* a,
				   FXComposite *parent,
				   const FXString& title,
				   FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE);


protected:
  FF_SelectPartner();

  void reload();

  FF_App *m_app;
  FOX16_HtmlLabel *m_label;
  FF_PartnerView *m_partnerView;
  FXTextField *m_matcher;

};




#endif




