/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SELECTTAX_HPP
#define FF_SELECTTAX_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_tax.h>


class FF_App;
class FF_TaxView;
class FOX16_HtmlLabel;


class FF_SelectTax: public FXDialogBox {
  FXDECLARE(FF_SelectTax)

public:

  enum {
    ID_TAX_VIEW=FXDialogBox::ID_LAST,
    ID_LAST
  };

  FF_SelectTax(FF_App* a,
	       FXComposite *parent,
	       const FXString& title,
	       FXuint opts=DECOR_TITLE|DECOR_BORDER,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	       FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	       FXint hs=0, FXint vs=0);
  ~FF_SelectTax();

  FXint getDefaultHeight();

  AE_TAX *getSelectedTax();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onTaxInserted(FXObject*, FXSelector, void*);
  long onTaxReplaced(FXObject*, FXSelector, void*);
  long onTaxOpened(FXObject*, FXSelector, void*);

  void init();
  void fini();


  /**
   * The tax returned (if any) must be freed by the caller using @ref AE_Tax_free.
   */
  static AE_TAX *selectTax(FF_App* a,
			   FXComposite *parent,
			   const FXString& title,
			   FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE);


protected:
  FF_SelectTax();

  void reload();

  FF_App *m_app;
  FOX16_HtmlLabel *m_label;
  FF_TaxView *m_taxView;
};




#endif




