/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_SESSIONDLG_HPP
#define FF_SESSIONDLG_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FF_SessionList;
class FF_App;

class FF_SessionDlg: public FXDialogBox {
  FXDECLARE(FF_SessionDlg)
public:
  enum {
    ID_SESSION_LIST=FXHorizontalFrame::ID_LAST,
    ID_BUTTON_ROLLBACK,
    ID_LAST
  };

  FF_SessionDlg(FXComposite *parent,
                const FXString& title,
                FXuint opts=DECOR_TITLE|DECOR_BORDER,
                FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                FXint hs=0, FXint vs=0);
  ~FF_SessionDlg();

  void init();
  void fini();

  void create();

  long onCmdRollback(FXObject*, FXSelector, void* ptr);
  long onCmdClose(FXObject*, FXSelector, void* ptr);

  void rebuild();

  static bool manageSessions(FXComposite *parent,
                             const FXString& title);

protected:
  FF_SessionDlg();

  FF_SessionList *m_sessionList;
  FXButton *m_rollbackButton;
  FXButton *m_closeButton;
};



#endif
