/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SETTINGS_HPP
#define FF_SETTINGS_HPP


#include <fx.h>

#include <aqfinance/engine/ae.h>


class FF_App;
class FF_CommodityEdit;


class FF_Settings: public FXDialogBox {
  FXDECLARE(FF_Settings)

public:

  enum {
    ID_TABBOOK=FXDialogBox::ID_LAST,
    ID_GENERIC_PDF_COMBO,
    ID_GENERIC_EMAIL_COMBO,
    ID_CACHE_ENTRIES,
    ID_CACHE_SIZE,
    ID_BUTTON_SHOW_BA_GRAPHS,

    ID_LAST
  };

  FF_Settings(FF_App* a,
	      FXComposite *parent,
	      const FXString& title,
	      FXuint opts=DECOR_TITLE|DECOR_BORDER,
	      FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	      FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
	      FXint hs=0, FXint vs=0);
  ~FF_Settings();

  static bool edit(FF_App* app,
		   FXComposite *parent,
		   const FXString &title);

  void init();
  void fini();

  FXint checkGui(FXbool quiet);
  FXint toGui();
  FXint fromGui();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_Settings();

  FF_App *m_app;

  FXTabBook *m_tabBook;

  FXComboBox *m_genericPdfCombo;
  FXComboBox *m_genericEmailCombo;

  FXSpinner *m_cacheEntriesSpinner;
  FXSpinner *m_cacheSizeSpinner;

  FF_CommodityEdit *m_primaryCurrencyEdit;

  FXCheckButton *m_showBankAccountGraphButton;

};




#endif




