/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDIT_REPORT2_SETTINGS_HPP
#define FF_EDIT_REPORT2_SETTINGS_HPP


#include <fx.h>


#include <aqfinance/report2/af_report2_settings.h>

#include <gwenhywfar/db.h>

#include <list>



class FF_View_Report2Settings;
class FF_View_Report2Graph;
class FF_View_Report2Db;


class FF_Edit_Report2Settings: public FXDialogBox {
  FXDECLARE(FF_Edit_Report2Settings)


public:
  enum {
    ID_TABBOOK=FXDialogBox::ID_LAST,
    ID_TABITEM,
    ID_LAST
  };

  FF_Edit_Report2Settings(FXComposite *parent,
                          const FXString& title,
                          FXuint opts=DECOR_TITLE|DECOR_BORDER,
                          FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                          FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                          FXint hs=0, FXint vs=0);
  ~FF_Edit_Report2Settings();


  static bool editSettings(FXComposite *parent,
                           const FXString &title,
                           AF_REPORT2_SETTINGS *settings);


  void init();
  void fini();

  void toGui(const AF_REPORT2_SETTINGS *settings);
  bool fromGui(AF_REPORT2_SETTINGS *settings);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_Edit_Report2Settings();

  FXTabBook *m_tabBook;
  FF_View_Report2Db *m_dbPage;
  FF_View_Report2Settings *m_generalPage;
  std::list<FF_View_Report2Graph*> m_graphPageList;

};





#endif



