/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_VIEW_REPORT2_GRAPH_HPP
#define FF_VIEW_REPORT2_GRAPH_HPP


#include <fx.h>


#include <aqfinance/report2/af_report2_settings.h>


class FF_App;
class FF_DateEdit;
class FF_AccountEdit;


class FF_View_Report2Graph: public FXHorizontalFrame {
  FXDECLARE(FF_View_Report2Graph)

public:

  enum {
    ID_BUTTON_ENABLED=FXHorizontalFrame::ID_LAST,
    ID_EDIT_LABEL,
    ID_COMBO_GRAPHTYPE,
    ID_COMBO_DATAMODE,
    ID_COLOURWELL_COLOUR,
    ID_SPINNER_LINEWIDTH,
    ID_COMBO_DASHTYPE,
    ID_BUTTON_REVERSE_SIGN,
    ID_BUTTON_ACCUMULATE,
    ID_ACCEDIT_1,
    ID_ACCEDIT_2,
    ID_LAST
  };

public:
  FF_View_Report2Graph(FXComposite *p,
			  FXuint opts=0,
			  FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_View_Report2Graph();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AF_REPORT2_SETTINGS_GRAPH *settings);
  bool fromGui(AF_REPORT2_SETTINGS_GRAPH *settings);


  long onCmdDateSpan(FXObject*, FXSelector, void *ptr);
  long onCmdFirstDate(FXObject*, FXSelector, void *ptr);
  long onCmdLastDate(FXObject*, FXSelector, void *ptr);

  long onCmdEnable(FXObject*, FXSelector, void *ptr);


protected:
  FF_View_Report2Graph();

  void enableInputs();
  void disableInputs();

  FXCheckButton *m_enableButton;
  FXTextField *m_labelEdit;

  FXComboBox *m_graphTypeCombo;
  FXComboBox *m_sumTypeCombo;
  FXComboBox *m_dataModeCombo;

  FXColorWell *m_colourWell;
  FXSpinner *m_lineWidthSpinner;
  FXComboBox *m_dashTypeCombo;

  FXCheckButton *m_reverseSignButton;
  FXCheckButton *m_accumulateButton;

  FF_AccountEdit *m_accountEdit1;
  FF_AccountEdit *m_accountEdit2;
};





#endif


