/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_VIEW_REPORT2_SETTINGS_HPP
#define FF_VIEW_REPORT2_SETTINGS_HPP


#include <fx.h>


#include <aqfinance/report2/af_report2_settings.h>


class FF_App;
class FF_DateEdit;
class FF_CommodityEdit;


class FF_View_Report2Settings: public FXHorizontalFrame {
  FXDECLARE(FF_View_Report2Settings)

public:

  enum {
    ID_EDIT_WIDTH=FXHorizontalFrame::ID_LAST,
    ID_EDIT_HEIGHT,
    ID_EDIT_TITLE,
    ID_EDIT_SUBTITLE,
    ID_EDIT_XLABEL,
    ID_EDIT_YLABEL,
    ID_EDIT_YPRECISION,
    ID_COMBO_DATESPAN,
    ID_DATEEDIT_FIRST,
    ID_BUTTON_FIRSTDATE,
    ID_DATEEDIT_LAST,
    ID_BUTTON_LASTDATE,
    ID_EDIT_COMMODITY,
    ID_COMBO_DATEUNIT,

    ID_LAST
  };

public:
  FF_View_Report2Settings(FXComposite *p,
			  FXuint opts=0,
			  FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_View_Report2Settings();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AF_REPORT2_SETTINGS *settings);
  bool fromGui(AF_REPORT2_SETTINGS *settings);


  long onCmdDateSpan(FXObject*, FXSelector, void *ptr);
  long onCmdFirstDate(FXObject*, FXSelector, void *ptr);
  long onCmdLastDate(FXObject*, FXSelector, void *ptr);


protected:
  FF_View_Report2Settings();

  FXTextField *m_widthEdit;
  FXTextField *m_heightEdit;

  FXTextField *m_titleEdit;
  FXTextField *m_subTitleEdit;

  FXTextField *m_xLabelEdit;
  FXTextField *m_yLabelEdit;

  FXTextField *m_yPrecisionEdit;

  FXComboBox *m_dateSpanTypeCombo;
  FF_DateEdit *m_firstDateEdit;
  FXButton *m_firstDateButton;
  FF_DateEdit *m_lastDateEdit;
  FXButton *m_lastDateButton;

  FF_CommodityEdit *m_commodityEdit;
  FXComboBox *m_dateUnitsCombo;


};





#endif


