/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_GREPORTWIZ_HPP
#define FF_GREPORTWIZ_HPP


#include "ff_wizard.hpp"

#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>


class FF_GraphReportWiz;

class FF_GraphReportWiz_Intro;
class FF_GraphReportWiz_Admin;
class FF_GraphReportWiz_TimeSpan;
class FF_GraphReportWiz_Accounts;
class FF_GraphReportWiz_Graph;
class FF_GraphReportWiz_Extro;


class FF_GraphReportWizPage: public FF_WizardPage {
  FXDECLARE(FF_GraphReportWizPage)
public:
  FF_GraphReportWizPage(FF_GraphReportWiz *p,
                        const FXString &name,
                        FXuint opts=0,
                        FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                        FXint pl=DEFAULT_SPACING, FXint pr=DEFAULT_SPACING,
                        FXint pt=DEFAULT_SPACING, FXint pb=DEFAULT_SPACING,
                        FXint hs=DEFAULT_SPACING, FXint vs=DEFAULT_SPACING);
  FF_GraphReportWizPage();

  virtual ~FF_GraphReportWizPage();

protected:
  FF_GraphReportWiz *m_wizard;
};





class FF_GraphReportWiz: public FF_Wizard {
public:

  enum {
    WITH_ADMIN_PAGE=0x01000000
  };

  FF_GraphReportWiz(FXWindow *owner, const FXString &title,
                    FXImage *image,
                    FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE|WITH_ADMIN_PAGE,
                    FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                    FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_GraphReportWiz();

  static bool createProfile(FXComposite *parent,
                            const FXString &title,
                            AF_REPORT2_SETTINGS *settings,
                            FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE|WITH_ADMIN_PAGE);


  void fromGui(AF_REPORT2_SETTINGS *settings);

  FXint getDefaultWidth();
  FXint getDefaultHeight();

protected:
  FF_GraphReportWiz();

  FF_GraphReportWiz_Intro *m_introPage;
  FF_GraphReportWiz_Admin *m_adminPage;
  FF_GraphReportWiz_TimeSpan *m_timeSpanPage;
  FF_GraphReportWiz_Accounts *m_accountsPage;
  FF_GraphReportWiz_Graph *m_graphPage;
  FF_GraphReportWiz_Extro *m_extroPage;

};



#endif

