/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_GREPORTWIZ_ACCOUNTS_HPP
#define FF_GREPORTWIZ_ACCOUNTS_HPP


#include "ff_greportwiz.hpp"

#include <fx.h>


class FOX16_HtmlLabel;
class FF_GraphReportWiz;
class FF_AccountEdit;
class FF_CommodityEdit;


class FF_GraphReportWiz_Accounts: public FF_GraphReportWizPage {
  FXDECLARE(FF_GraphReportWiz_Accounts)
public:

  enum {
    ID_ACCEDIT_1=FF_GraphReportWizPage::ID_LAST,
    ID_ACCEDIT_2,
    ID_EDIT_COMMODITY,

    ID_LAST
  };


  FF_GraphReportWiz_Accounts(FF_GraphReportWiz *p,
			     FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
			     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
			     FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_GraphReportWiz_Accounts();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();

  virtual void init(GWEN_DB_NODE *db);
  virtual void fini(GWEN_DB_NODE *db);

  FXString getAccount1();
  FXString getAccount2();

  FXString getCommodity();

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);
  long onCmdEdit(FXObject*, FXSelector, void *ptr);

protected:
  FF_GraphReportWiz_Accounts();

  FOX16_HtmlLabel *m_label;

  FF_AccountEdit *m_accountEdit1;
  FF_AccountEdit *m_accountEdit2;

  FF_CommodityEdit *m_commodityEdit;

};



#endif

