/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_GREPORTWIZ_ADMIN_HPP
#define FF_GREPORTWIZ_ADMIN_HPP


#include "ff_greportwiz.hpp"

#include <fx.h>


class FOX16_HtmlLabel;
class FF_GroupView;
class FF_GraphReportWiz;


class FF_GraphReportWiz_Admin: public FF_GraphReportWizPage {
  FXDECLARE(FF_GraphReportWiz_Admin)
public:

  enum {
    ID_EDIT_NAME=FXHorizontalFrame::ID_LAST,
    ID_EDIT_DESCR,
    ID_VIEW_GROUP,

    ID_LAST
  };


  FF_GraphReportWiz_Admin(FF_GraphReportWiz *p,
                          FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
                          FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                          FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_GraphReportWiz_Admin();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();

  virtual void init(GWEN_DB_NODE *db);
  virtual void fini(GWEN_DB_NODE *db);

  FXString getName();
  FXString getDescription();
  AQDB_ID getGroupId();

  long onCmdEdit(FXObject*, FXSelector, void *ptr);

protected:
  FF_GraphReportWiz_Admin();

  FOX16_HtmlLabel *m_label;

  FXTextField *m_nameEdit;
  FXTextField *m_descrEdit;

  FF_GroupView *m_groupView;


};



#endif

