/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ff_greportwiz_extro.hpp"

#include <gwen-gui-fox16/fox16_htmllabel.hpp>




FXDEFMAP(FF_GraphReportWiz_Extro) FF_GraphReportWiz_ExtroMap[]={
  //FXMAPFUNC(SEL_COMMAND, FXDialogBox::ID_ACCEPT, FF_GraphReportWiz_Extro::onCmdAccept),
};


FXIMPLEMENT(FF_GraphReportWiz_Extro, FF_GraphReportWizPage, FF_GraphReportWiz_ExtroMap, ARRAYNUMBER(FF_GraphReportWiz_ExtroMap))




FF_GraphReportWiz_Extro::FF_GraphReportWiz_Extro(FF_GraphReportWiz *p,
                                                 FXuint opts,
                                                 FXint x, FXint y, FXint w, FXint h,
                                                 FXint pl, FXint pr, FXint pt, FXint pb, FXint hs, FXint vs)
:FF_GraphReportWizPage(p, "extro", opts, x, y, w, h, pl, pr, pt, pb, hs, vs)
{
  m_label=new FOX16_HtmlLabel(this, "", LAYOUT_FILL_X | LAYOUT_FILL_Y | FOX16_HtmlLabel::FLAGS_USE_FULL_WIDTH);
  m_label->setMinimumWidth(150);
  new FXSpring(this, LAYOUT_FILL_Y);
}



FF_GraphReportWiz_Extro::FF_GraphReportWiz_Extro()
:FF_GraphReportWizPage()
{
}



FF_GraphReportWiz_Extro::~FF_GraphReportWiz_Extro() {
}



void FF_GraphReportWiz_Extro::init(GWEN_DB_NODE *db) {
  m_label->setText(I18N("<html>"
                        "<p>We now have all the information needed to create a graphical report.</p>"
                        "<p>You can later edit this newly created profile in detail.</p>"
                        "</html>"));
}



void FF_GraphReportWiz_Extro::fini(GWEN_DB_NODE *db) {
}



void FF_GraphReportWiz_Extro::enterPageForwards() {
  layout();
  /* this is the intro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}



void FF_GraphReportWiz_Extro::enterPageBackwards() {
  /* this is the intro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}




