/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_GREPORTWIZ_GRAPH_HPP
#define FF_GREPORTWIZ_GRAPH_HPP


#include "ff_greportwiz.hpp"

#include <fx.h>


class FOX16_HtmlLabel;
class FF_GraphReportWiz;


class FF_GraphReportWiz_Graph: public FF_GraphReportWizPage {
  FXDECLARE(FF_GraphReportWiz_Graph)
public:

  enum {
    ID_EDIT_WIDTH=FF_GraphReportWizPage::ID_LAST,
    ID_EDIT_HEIGHT,
    ID_EDIT_TITLE,
    ID_EDIT_SUBTITLE,

    ID_BUTTON_AVERAGE,
    ID_BUTTON_FLOATING_AVERAGE,

    ID_LAST
  };


  FF_GraphReportWiz_Graph(FF_GraphReportWiz *p,
                          FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
                          FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                          FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_GraphReportWiz_Graph();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();

  virtual void init(GWEN_DB_NODE *db);
  virtual void fini(GWEN_DB_NODE *db);

  int getWidth();
  int getHeight();
  FXString getTitle();
  FXString getSubTitle();

  bool getWithAverage();
  bool getWithFloatingAverage();

  long onCmdEdit(FXObject*, FXSelector, void *ptr);

protected:
  FF_GraphReportWiz_Graph();

  FOX16_HtmlLabel *m_label;

  FXTextField *m_widthEdit;
  FXTextField *m_heightEdit;

  FXTextField *m_titleEdit;
  FXTextField *m_subTitleEdit;

  FXCheckButton *m_averageButton;
  FXCheckButton *m_floatingAverageButton;

};



#endif

