/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ff_greportwiz_intro.hpp"

#include <gwen-gui-fox16/fox16_htmllabel.hpp>


FXDEFMAP(FF_GraphReportWiz_Intro) FF_GraphReportWiz_IntroMap[]={
  //FXMAPFUNC(SEL_COMMAND, FXDialogBox::ID_ACCEPT, FF_GraphReportWiz_Intro::onCmdAccept),
};


FXIMPLEMENT(FF_GraphReportWiz_Intro, FF_GraphReportWizPage, FF_GraphReportWiz_IntroMap, ARRAYNUMBER(FF_GraphReportWiz_IntroMap))




FF_GraphReportWiz_Intro::FF_GraphReportWiz_Intro(FF_GraphReportWiz *p,
                                                 FXuint opts,
                                                 FXint x, FXint y, FXint w, FXint h,
                                                 FXint pl, FXint pr, FXint pt, FXint pb, FXint hs, FXint vs)
:FF_GraphReportWizPage(p, "intro", opts, x, y, w, h, pl, pr, pt, pb, hs, vs)
{
  m_label=new FOX16_HtmlLabel(this, "", LAYOUT_FILL_X | LAYOUT_FILL_Y | FOX16_HtmlLabel::FLAGS_USE_FULL_WIDTH);
  m_label->setMinimumWidth(150);
  new FXSpring(this, LAYOUT_FILL_Y);
}



FF_GraphReportWiz_Intro::FF_GraphReportWiz_Intro()
:FF_GraphReportWizPage()
{
}



FF_GraphReportWiz_Intro::~FF_GraphReportWiz_Intro() {
}



void FF_GraphReportWiz_Intro::init(GWEN_DB_NODE *db) {
  m_label->setText(I18N("<html>"
                        "<p>This wizard will guide you through the process of "
                        "setting a graphic report.</p>"
                        "</html>"));
}



void FF_GraphReportWiz_Intro::fini(GWEN_DB_NODE *db) {
}



void FF_GraphReportWiz_Intro::enterPageForwards() {
  layout();
  /* this is the intro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}



void FF_GraphReportWiz_Intro::enterPageBackwards() {
  /* this is the intro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}




