/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_GREPORTWIZ_TIMESPAN_HPP
#define FF_GREPORTWIZ_TIMESPAN_HPP


#include "ff_greportwiz.hpp"

#include <fx.h>


class FOX16_HtmlLabel;
class FF_GraphReportWiz;
class FF_DateEdit;



class FF_GraphReportWiz_TimeSpan: public FF_GraphReportWizPage {
  FXDECLARE(FF_GraphReportWiz_TimeSpan)
public:

  enum {
    ID_COMBO_DATESPAN=FXHorizontalFrame::ID_LAST,
    ID_DATEEDIT_FIRST,
    ID_BUTTON_FIRSTDATE,
    ID_DATEEDIT_LAST,
    ID_BUTTON_LASTDATE,

    ID_LAST
  };


  FF_GraphReportWiz_TimeSpan(FF_GraphReportWiz *p,
			     FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
			     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
			     FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_GraphReportWiz_TimeSpan();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();

  virtual void init(GWEN_DB_NODE *db);
  virtual void fini(GWEN_DB_NODE *db);

  int getTimeSpanType();
  GWEN_DATE *getFirstDate();
  GWEN_DATE *getLastDate();

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);
  long onCmdEdit(FXObject*, FXSelector, void *ptr);

protected:
  FF_GraphReportWiz_TimeSpan();

  FOX16_HtmlLabel *m_label;

  FXComboBox *m_dateSpanTypeCombo;
  FF_DateEdit *m_firstDateEdit;
  FXButton *m_firstDateButton;
  FF_DateEdit *m_lastDateEdit;
  FXButton *m_lastDateButton;
};



#endif

