/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ff_setupwiz.hpp"
#include "ff_setupwiz_intro.hpp"
#include "ff_setupwiz_db.hpp"
#include "ff_setupwiz_currency.hpp"
#include "ff_setupwiz_accounts.hpp"
#include "ff_setupwiz_bank.hpp"
#include "ff_setupwiz_extro.hpp"

#include <gwen-gui-fox16/theme.h>



FXDEFMAP(FF_SetupWizPage) FF_SetupWizPageMap[]={
  //FXMAPFUNC(SEL_COMMAND, FXDialogBox::ID_ACCEPT, FF_WizardPage::onCmdAccept),
};


FXIMPLEMENT(FF_SetupWizPage, FF_WizardPage, FF_SetupWizPageMap, ARRAYNUMBER(FF_SetupWizPageMap))




FF_SetupWizPage::FF_SetupWizPage(FF_SetupWiz *p,
				 const FXString &name,
				 FXuint opts,
				 FXint x, FXint y, FXint w, FXint h,
				 FXint pl, FXint pr,
				 FXint pt, FXint pb,
				 FXint hs, FXint vs)
:FF_WizardPage(p, name, opts, x, y, w, h, pl, pr, pt, pb, hs, vs)
,m_wizard(p)
{
}



FF_SetupWizPage::FF_SetupWizPage()
:FF_WizardPage()
,m_wizard(NULL)
{
}



FF_SetupWizPage::~FF_SetupWizPage() {
}





FF_SetupWiz::FF_SetupWiz(FXWindow *owner, const FXString &title,
			 FXImage *image,
			 FXuint opts,
			 FXint x, FXint y, FXint w, FXint h,
			 FXint pl, FXint pr, FXint pt, FXint pb, FXint hs, FXint vs)
:FF_Wizard(owner, title, "FF_SetupWiz", image, opts, x, y, w, h, pl, pr, pt, pb, hs, vs)
,m_commodities(NULL)
,m_accountTree(NULL)
,m_bankAccountList(NULL)
{
  m_commodities=AE_Commodity_List_new();
  m_accountTree=AE_Account_Tree_new();
  m_bankAccountList=AE_BankAccount_List_new();

  new FF_SetupWiz_Intro(this, LAYOUT_FILL_X | LAYOUT_FILL_Y);
  new FF_SetupWiz_Db(this, LAYOUT_FILL_X | LAYOUT_FILL_Y);
  new FF_SetupWiz_Currency(this, LAYOUT_FILL_X | LAYOUT_FILL_Y);
  new FF_SetupWiz_Accounts(this, LAYOUT_FILL_X | LAYOUT_FILL_Y);
  new FF_SetupWiz_Bank(this, LAYOUT_FILL_X | LAYOUT_FILL_Y);
  new FF_SetupWiz_Extro(this, LAYOUT_FILL_X | LAYOUT_FILL_Y);
}


FF_SetupWiz::FF_SetupWiz()
:FF_Wizard()
,m_commodities(NULL)
,m_accountTree(NULL)
,m_bankAccountList(NULL)
{
}



FF_SetupWiz::~FF_SetupWiz() {
  AE_Commodity_List_free(m_commodities);
  AE_Account_Tree_free(m_accountTree);
  AE_BankAccount_List_free(m_bankAccountList);
}



FXint FF_SetupWiz::getDefaultWidth() {
  FXint w;

  w=FF_Wizard::getDefaultWidth();
  if (w<800)
    w=800;
  return w;
}



FXint FF_SetupWiz::getDefaultHeight() {
  FXint h;

  h=FF_Wizard::getDefaultHeight();
  if (h<500)
    h=500;
  return h;
}






