/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SETUPWIZ_ACCOUNTS_HPP
#define FF_SETUPWIZ_ACCOUNTS_HPP


#include "ff_setupwiz.hpp"

#include <fx.h>

#include <gwenhywfar/xml.h>


class FOX16_HtmlLabel;
class FF_SetupWiz;
class FXXCheckTree;
class FF_AccountTree;



class FF_SetupWiz_Accounts: public FF_SetupWizPage {
  FXDECLARE(FF_SetupWiz_Accounts)
public:

  enum {
    ID_FILE_TREE=FF_SetupWizPage::ID_LAST,
    ID_ACCOUNT_TREE,

    ID_LAST
  };

  FF_SetupWiz_Accounts(FF_SetupWiz *p,
		       FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
		       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		       FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_SetupWiz_Accounts();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();

  virtual void leavePageForwards();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  long onAccLeftButtonPress(FXObject*, FXSelector, void *ptr);
  long onFileLeftButtonPress(FXObject*, FXSelector, void *ptr);

protected:
  FF_SetupWiz_Accounts();

  FXString getAccountFolder();
  void updateAccountTree();

  FOX16_HtmlLabel *m_label;
  FXXCheckTree *m_checkTree;
  FF_AccountTree *m_accountTree;
  GWEN_XMLNODE *m_xmlNodes;
};



#endif

