/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SETUPWIZ_CURRENCY_HPP
#define FF_SETUPWIZ_CURRENCY_HPP


#include "ff_setupwiz.hpp"

#include <fx.h>


class FOX16_HtmlLabel;
class FF_SetupWiz;


class FF_SetupWiz_Currency: public FF_SetupWizPage {
  FXDECLARE(FF_SetupWiz_Currency)
public:

  enum {
    ID_CURRENCY_COMBO=FF_SetupWizPage::ID_LAST,
    ID_LAST
  };

  FF_SetupWiz_Currency(FF_SetupWiz *p,
		       FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
		       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		       FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_SetupWiz_Currency();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();
  virtual void leavePageForwards();

  virtual void init(GWEN_DB_NODE *db);

  FXint checkGui(FXbool quiet);
  FXint toGui(const FXString &urlString);
  FXint fromGui(FXString &urlString);

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);

protected:
  FF_SetupWiz_Currency();

  FOX16_HtmlLabel *m_label;
  FXComboBox *m_currencyCombo;
};



#endif

