/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_SETUPWIZ_DB_HPP
#define FF_SETUPWIZ_DB_HPP


#include "ff_setupwiz.hpp"

#include <fx.h>


class FOX16_HtmlLabel;
class FF_SetupWiz;


class FF_SetupWiz_Db: public FF_SetupWizPage {
  FXDECLARE(FF_SetupWiz_Db)
public:

  enum {
    ID_FILENAME_EDIT=FF_WizardPage::ID_LAST,
    ID_FILENAME_BUTTON,
    ID_COMBOBOX,
    ID_LAST
  };

  FF_SetupWiz_Db(FF_SetupWiz *p,
		 FXuint opts=DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		 FXint pl=10, FXint pr=10, FXint pt=10, FXint pb=10, FXint hs=10, FXint vs=10);

  ~FF_SetupWiz_Db();

  virtual void enterPageForwards();
  virtual void enterPageBackwards();

  virtual void leavePageForwards();

  long onCmdButton(FXObject*, FXSelector, void *ptr);
  long onCmdEdit(FXObject*, FXSelector, void *ptr);
  long onChangedEdit(FXObject*, FXSelector, void *ptr);

  long onCmdComboBox(FXObject*, FXSelector, void *ptr);

  void init(GWEN_DB_NODE *db);

protected:
  FF_SetupWiz_Db();

  void selectModule(int i);

  FXint checkGui(FXbool quiet);
  FXint toGui(const FXString &currString);
  FXint fromGui(FXString &currString);

  FOX16_HtmlLabel *m_label;

  FXComboBox *m_moduleCombo;
  FXLabel *m_pathLabel;
  FXTextField *m_pathEdit;
  FXButton *m_pathButton;
  FOX16_HtmlLabel *m_moduleLabel;
};



#endif

