/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ff_setupwiz_extro.hpp"

#include <gwen-gui-fox16/fox16_htmllabel.hpp>


FXDEFMAP(FF_SetupWiz_Extro) FF_SetupWiz_ExtroMap[]={
  //FXMAPFUNC(SEL_COMMAND, FXDialogBox::ID_ACCEPT, FF_SetupWiz_Extro::onCmdAccept),
};


FXIMPLEMENT(FF_SetupWiz_Extro, FF_SetupWizPage, FF_SetupWiz_ExtroMap, ARRAYNUMBER(FF_SetupWiz_ExtroMap))




FF_SetupWiz_Extro::FF_SetupWiz_Extro(FF_SetupWiz *p,
				     FXuint opts,
				     FXint x, FXint y, FXint w, FXint h,
				     FXint pl, FXint pr, FXint pt, FXint pb, FXint hs, FXint vs)
:FF_SetupWizPage(p, "extro", opts, x, y, w, h, pl, pr, pt, pb, hs, vs)
{
  m_label=new FOX16_HtmlLabel(this,
			      I18N("<p>We have now all information needed to create a usable database.</p>"
				   "<p>If you click <i>Finish</i> now the database with the given specification "
				   "will be created.</p>"
                                   "<p>Click <i>Cancel</i> to abort this process."),
			      LAYOUT_FILL_X | LAYOUT_FILL_Y);
  m_label->setMinimumWidth(150);
  new FXSpring(this, LAYOUT_FILL_Y);
}



FF_SetupWiz_Extro::FF_SetupWiz_Extro()
:FF_SetupWizPage()
{
}



FF_SetupWiz_Extro::~FF_SetupWiz_Extro() {
}



void FF_SetupWiz_Extro::enterPageForwards() {
  layout();
  /* this is the extro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}



void FF_SetupWiz_Extro::enterPageBackwards() {
  /* this is the extro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}




