/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ff_setupwiz_intro.hpp"

#include <gwen-gui-fox16/fox16_htmllabel.hpp>


FXDEFMAP(FF_SetupWiz_Intro) FF_SetupWiz_IntroMap[]={
  //FXMAPFUNC(SEL_COMMAND, FXDialogBox::ID_ACCEPT, FF_SetupWiz_Intro::onCmdAccept),
};


FXIMPLEMENT(FF_SetupWiz_Intro, FF_SetupWizPage, FF_SetupWiz_IntroMap, ARRAYNUMBER(FF_SetupWiz_IntroMap))




FF_SetupWiz_Intro::FF_SetupWiz_Intro(FF_SetupWiz *p,
				     FXuint opts,
				     FXint x, FXint y, FXint w, FXint h,
				     FXint pl, FXint pr, FXint pt, FXint pb, FXint hs, FXint vs)
:FF_SetupWizPage(p, "intro", opts, x, y, w, h, pl, pr, pt, pb, hs, vs)
{
  m_label=new FOX16_HtmlLabel(this,
			      I18N("This wizard will guide you through the process of "
				   "setting up the database."),
			      LAYOUT_FILL_X | LAYOUT_FILL_Y);
  m_label->setMinimumWidth(150);
  new FXSpring(this, LAYOUT_FILL_Y);
}



FF_SetupWiz_Intro::FF_SetupWiz_Intro()
:FF_SetupWizPage()
{
}



FF_SetupWiz_Intro::~FF_SetupWiz_Intro() {
}



void FF_SetupWiz_Intro::enterPageForwards() {
  layout();
  /* this is the intro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}



void FF_SetupWiz_Intro::enterPageBackwards() {
  /* this is the intro, nothing to prevent the user from going to the next page */
  m_wizard->enableNext();
}




