/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_GUI_HPP
#define FF_GUI_HPP


#include <gwen-gui-fox16/fox16_gui.hpp>

#include <fx.h>


class FF_App;


class FF_Gui: public FOX16_Gui {
protected:
  bool m_hookActive;
  GWEN_LOGGER_LEVEL m_maxLogLevel;
  FXString m_dataPath;
  FXString m_logFile;

public:
  FF_Gui(FF_App* a, const FXString &dataPath);
  ~FF_Gui();

  virtual int print(const char *docTitle,
                    const char *docType,
                    const char *descr,
                    const char *text,
                    uint32_t guiid);


  virtual int getPassword(uint32_t flags,
                          const char *token,
                          const char *title,
                          const char *text,
                          char *buffer,
                          int minLen,
                          int maxLen,
                          uint32_t guiid);

  void setupLogging(bool withDebug);

  virtual int logHook(const char *logDomain,
		      GWEN_LOGGER_LEVEL priority, const char *s);

protected:
  FXString getHhdCode(const char *text);
  FXString removeHhdCode(const char *text);

};


#endif

