/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2012 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_MODTABBOOK_HPP
#define FF_MODTABBOOK_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <fx.h>

#include <list>



class FF_ModTabPage;


class FF_ModTabBook: public FXHorizontalFrame {
  FXDECLARE(FF_ModTabBook)
public:
  enum {
    ID_TABBOOK=FXHorizontalFrame::ID_LAST,
    ID_TABITEM,
    ID_LAST
  };

  FF_ModTabBook(FXComposite *p,
                FXuint opts=0,
                FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  virtual ~FF_ModTabBook();

  virtual void init(GWEN_DB_NODE *db);
  virtual void fini(GWEN_DB_NODE *db);

  virtual void dbOpened(AE_BOOK *bk);
  virtual void dbClosing();
  virtual void dbClosed();
  virtual void dbReload(AE_BOOK_TABLE_TYPE tt);

  virtual void aboutToSendJobs();

  virtual void enter();
  virtual void leave();
  virtual void reset();

  void setCurrentPage(FF_ModTabPage *p);

  FF_ModTabPage *findPageById(const FXString &id);
  int findIndexById(const FXString &id);
  FF_ModTabPage *findPageAt(int idx);
  int findIndexByPage(FF_ModTabPage *p);

  FXTabItem *addTabHeader(const FXString &title, bool closeable);
  void addTabPage(FF_ModTabPage *p);

  FXTabBook *getTabBookWidget() const { return m_tabBook;};

  void create();

  long onTabClicked(FXObject*, FXSelector, void*);
  long onTabLeftButtonPressed(FXObject*, FXSelector, void *ptr);

protected:
  FF_ModTabBook();

  FXTabBook *m_tabBook;

  FF_ModTabPage *m_lastEnteredTab;

  FXIcon *m_closeTabIcon;
  GWEN_DB_NODE *m_config;

  std::list<FF_ModTabPage*> m_tabPages;

};



#endif
