/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2012 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "ff_modtabpage.hpp"
#include "ff_modtabbook.hpp"
#include "ff_app.hpp"

#include <gwenhywfar/debug.h>
#include <gwenhywfar/i18n.h>



#define I18N(msg) GWEN_I18N_Translate(PACKAGE, msg)



FXDEFMAP(FF_ModTabPage) FF_ModTabPageMap[]={
};


FXIMPLEMENT(FF_ModTabPage, FXHorizontalFrame,
            FF_ModTabPageMap, ARRAYNUMBER(FF_ModTabPageMap))





FF_ModTabPage::FF_ModTabPage(const FXString &pageId,
			     FF_ModTabBook *mtb,
			     FXuint opts,
			     FXint x, FXint y, FXint w, FXint h)
:FXHorizontalFrame(mtb->getTabBookWidget(), opts, x, y, w, h)
,m_tabBook(mtb)
,m_pageId(pageId)
,m_needReload(true)
,m_isVisible(false)
{
}



FF_ModTabPage::FF_ModTabPage()
:FXHorizontalFrame()
{
}



FF_ModTabPage::~FF_ModTabPage() {
}



void FF_ModTabPage::enter() {
  m_isVisible=true;

  layout();
  if (m_needReload) {
    reload();
    m_needReload=false;
  }
}



void FF_ModTabPage::leave() {
  m_isVisible=false;
}



void FF_ModTabPage::reset() {
}



void FF_ModTabPage::init(GWEN_DB_NODE *db) {
}



void FF_ModTabPage::fini(GWEN_DB_NODE *db) {
}



void FF_ModTabPage::dbOpened(AE_BOOK *bk) {
  if (m_isVisible) {
    reload();
    m_needReload=false;
  }
  else
    m_needReload=true;
}



void FF_ModTabPage::dbClosing() {
}



void FF_ModTabPage::dbClosed() {
}



void FF_ModTabPage::dbReload(AE_BOOK_TABLE_TYPE tt) {
}



void FF_ModTabPage::aboutToSendJobs() {
}


void FF_ModTabPage::reload() {
}




