/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2012 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_MODTABPAGE_HPP
#define FF_MODTABPAGE_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <fx.h>


class FF_ModTabBook;


class FF_ModTabPage: public FXHorizontalFrame {
  FXDECLARE(FF_ModTabPage)
public:

  FF_ModTabPage(const FXString &pageId,
		FF_ModTabBook *mtb,
		FXuint opts=0,
		FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  virtual ~FF_ModTabPage();

  const FXString &getPageId() const { return m_pageId;};

  virtual void init(GWEN_DB_NODE *db);
  virtual void fini(GWEN_DB_NODE *db);

  virtual void dbOpened(AE_BOOK *bk);
  virtual void dbClosing();
  virtual void dbClosed();
  virtual void dbReload(AE_BOOK_TABLE_TYPE tt);

  virtual void aboutToSendJobs();

  virtual void enter();
  virtual void leave();
  virtual void reset();

  bool getIsCloseable() const { return m_closeable;};

protected:
  FF_ModTabPage();
  virtual void reload();

  FF_ModTabBook *m_tabBook;
  FXString m_pageId;
  bool m_closeable;

  bool m_needReload;
  bool m_isVisible;


};



#endif
