/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FM_ACCOUNTS_HPP
#define FM_ACCOUNTS_HPP


#include "ff_module.hpp"

#include <fx.h>

#include <gwenhywfar/db.h>


class FM_AccountPage;


class FM_Accounts: public FF_Module {
public:
  FM_Accounts(FF_ModuleManager *mm);
  virtual ~FM_Accounts();

  virtual void init(FXComposite *parentForView);
  virtual void fini();

  virtual void enter();
  virtual void leave();

  virtual void reset();

  virtual void dbOpened(AE_BOOK *bk);
  virtual void dbClosing();
  virtual void dbClosed();
  virtual void dbReload(AE_BOOK_TABLE_TYPE tt);

  virtual void aboutToSendJobs();

  void dump(int indent);

protected:
  FM_AccountPage *m_page;
  GWEN_DB_NODE *m_config;
};




#endif



