/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_BUSINESSPAGE_HPP
#define FM_BUSINESSPAGE_HPP



#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_task.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FM_BusinessTaskPage;


class FM_BusinessPage: public FXHorizontalFrame {
  FXDECLARE(FM_BusinessPage)
public:
  enum {
    ID_TABBOOK=FXHorizontalFrame::ID_LAST
  };

  FM_BusinessPage(FXComposite *p,
		  FXuint opts=0,
		  FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_BusinessPage();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbOpened(AE_BOOK *bk);
  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void enter();
  void leave();
  void reset();

  long onTabClicked(FXObject*, FXSelector, void*);

  AE_TASK_LIST *getOpenTasks() const { return m_openTasks;};

protected:
  FM_BusinessPage();

  FXTabBook *m_tabBook;
  int m_lastEnteredTab;

  FM_BusinessTaskPage *m_incomingTaskPage;
  FM_BusinessTaskPage *m_outgoingTaskPage;

  AE_TASK_LIST *m_openTasks;

  GWEN_DB_NODE *m_config;
};



#endif
