/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_OUTBOXPAGE_HPP
#define FM_OUTBOXPAGE_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <aqbanking/job.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FF_BankingJobTree;
class FM_Outbox;


class FM_OutboxPage: public FXHorizontalFrame {
  FXDECLARE(FM_OutboxPage)
public:
  enum {
    ID_JOBLIST=FXHorizontalFrame::ID_LAST,
    ID_BUTTON_SENDALL,
    ID_BUTTON_SENDSEL,
    ID_BUTTON_ABORTSEL,
    ID_LAST
  };


  FM_OutboxPage(FM_Outbox *m,
                FXComposite *p,
                FXuint opts=0,
                FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_OutboxPage();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbOpened(AE_BOOK *bk);
  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void enter();
  void leave();

  void jobListUpdated();

  void create();

  long onCmdSendAll(FXObject*, FXSelector, void* ptr);
  long onCmdSendSelected(FXObject*, FXSelector, void* ptr);

  long onCmdAbortSelected(FXObject*, FXSelector, void* ptr);

protected:
  FM_OutboxPage();

  int sendJobList(AB_JOB_LIST2 *jobs);

  FM_Outbox *m_module;

  FF_BankingJobTree *m_jobList;
  FXButton *m_sendAllButton;
  FXButton *m_sendSelectedButton;
  FXButton *m_abortSelectedButton;

  int m_sessionNumber;
};



#endif
