/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_TRANSFER_HPP
#define FM_TRANSFER_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>


class FF_PartnerView;


class FM_PartnerPage: public FXVerticalFrame {
  FXDECLARE(FM_PartnerPage)
public:
  enum {
    ID_PARTNERVIEW=FXVerticalFrame::ID_LAST,
    ID_MATCHER,
    ID_LAST
  };

  FM_PartnerPage(FXComposite *p,
		 FXuint opts=0,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_PartnerPage();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbOpened(AE_BOOK *bk);
  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void enter();
  void leave();
  void reset();

  long onPartnerInserted(FXObject*, FXSelector, void*);
  long onPartnerReplaced(FXObject*, FXSelector, void*);
  long onPartnerOpened(FXObject*, FXSelector, void*);

  long onChgMatcher(FXObject*, FXSelector, void* ptr);

protected:
  FM_PartnerPage();
  void reload();

  FF_PartnerView *m_partnerView;

  FXTextField *m_matcher;
  FXString m_tempMatcherString;

};



#endif
