/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2012 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_GREPORTSTAB_HPP
#define FM_GREPORTSTAB_HPP


#include "ff_modtabpage.hpp"

#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>


class FF_Report2SettingsTree;
class FM_ReportsPage;


class FM_GraphicsReportsTab: public FF_ModTabPage {
  FXDECLARE(FM_GraphicsReportsTab)

public:
  enum {
    ID_SETTINGS_TREE=FXPacker::ID_LAST,

    ID_BUTTON_ADDGROUP,
    ID_BUTTON_EDITGROUP,
    ID_BUTTON_DELGROUP,

    ID_BUTTON_ADDSETTINGS,
    ID_BUTTON_EDITSETTINGS,
    ID_BUTTON_DELSETTINGS,

    ID_BUTTON_MKREPORT,

    ID_LAST
  };

public:
  FM_GraphicsReportsTab(const FXString &pageId,
                        FM_ReportsPage *mainPage,
                        FXuint opts=0,
                        FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_GraphicsReportsTab();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbOpened(AE_BOOK *bk);
  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void reset();

  void create();

  long onCmdAddGroup(FXObject*, FXSelector, void*);
  long onCmdEditGroup(FXObject*, FXSelector, void*);
  long onCmdDelGroup(FXObject*, FXSelector, void*);

  long onCmdAddSettings(FXObject*, FXSelector, void*);
  long onCmdEditSettings(FXObject*, FXSelector, void*);
  long onCmdDelSettings(FXObject*, FXSelector, void*);

  long onCmdMkReport(FXObject*, FXSelector, void*);

  long onTreeChanged(FXObject*, FXSelector, void*);
  long onTreeCommand(FXObject*, FXSelector, void* ptr);
  long onTreeRightBtnPress(FXObject*, FXSelector, void* ptr);

  void dump(int indent);

  bool isEditing() const { return m_isEditing;};

protected:
  FM_GraphicsReportsTab();

  FM_ReportsPage *m_mainPage;

  FF_Report2SettingsTree *m_reportSettingsTree;

  bool m_isEditing;
};




#endif

