/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_GREPORTTAB_HPP
#define FM_GREPORTTAB_HPP


#include "ff_modtabpage.hpp"

#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/db.h>

#include <fx.h>


class FM_ReportsPage;


class FM_GraphicsReportTab: public FF_ModTabPage {
  FXDECLARE(FM_GraphicsReportTab)

public:
  FM_GraphicsReportTab(const AF_REPORT2_SETTINGS *settings,
                       const FXString &pageId,
                       FM_ReportsPage *mainPage,
                       FXuint opts=0,
                       FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_GraphicsReportTab();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void reset();
  void reload();

  void create();

  void dump(int indent);

protected:
  FM_GraphicsReportTab();

  FM_ReportsPage *m_mainPage;
  AF_REPORT2_SETTINGS *m_settings;

  FXImageView *m_imageView;
  FXImage *m_image;

  FXString m_fileName;
};




#endif

