/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FM_REPORTS_HPP
#define FM_REPORTS_HPP


#include "ff_module.hpp"

#include <fx.h>

#include <gwenhywfar/db.h>


class FM_ReportsPage;


class FM_Reports: public FF_Module {
public:
  FM_Reports(FF_ModuleManager *mm);
  virtual ~FM_Reports();

  virtual void init(FXComposite *parentForView);
  virtual void fini();

  virtual void enter();
  virtual void leave();

  virtual void reset();

  virtual void dbOpened(AE_BOOK *bk);
  virtual void dbClosing();
  virtual void dbClosed();
  virtual void dbReload(AE_BOOK_TABLE_TYPE tt);

  void dump(int indent);

protected:
  FM_ReportsPage *m_page;
  GWEN_DB_NODE *m_config;
};




#endif



