/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2012 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_REPORTSPAGE_HPP
#define FM_REPORTSPAGE_HPP


#include "ff_modtabbook.hpp"

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/report2/af_report2_settings.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FM_GraphicsReportsTab;


class FM_ReportsPage: public FF_ModTabBook {
public:
  FM_ReportsPage(FXComposite *p,
                 FXuint opts=0,
                 FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_ReportsPage();

  void openGraphicsReportPage(const AF_REPORT2_SETTINGS *settings);

protected:
  FM_ReportsPage();

  FM_GraphicsReportsTab *m_graphReportsTab;
};



#endif
