/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_TRANSFER_HPP
#define FM_TRANSFER_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FM_TransferStmPage;
class FM_TransferStoPage;
class FM_TransferPlannedPage;


class FM_TransferPage: public FXHorizontalFrame {
  FXDECLARE(FM_TransferPage)
public:
  enum {
    ID_TABBOOK=FXHorizontalFrame::ID_LAST
  };

  FM_TransferPage(FXComposite *p,
		     FXuint opts=0,
		     FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_TransferPage();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbOpened(AE_BOOK *bk);
  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void enter();
  void leave();
  void reset();

  long onTabClicked(FXObject*, FXSelector, void*);

protected:
  FM_TransferPage();

  FM_TransferStmPage *getTransferPageAt(int idx);

  FXTabBook *m_tabBook;
  int m_lastEnteredTab;
  FM_TransferStmPage *m_transfersPage;
  FM_TransferStoPage *m_stoPage;
  FM_TransferPlannedPage *m_plannedPage;


  GWEN_DB_NODE *m_config;
};



#endif
