/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_ADDRESSVIEW_HPP
#define FF_ADDRESSVIEW_HPP


#include "ff_addresstree.hpp"

#include <aqfinance/engine/book/ae_book.h>

#include <fx.h>

#include <list>


class FF_AddressTree;


class FF_AddressView: public FXHorizontalFrame {
  FXDECLARE(FF_AddressView)

public:
  enum {
    ID_ADDRESS_TREE=FXPacker::ID_LAST,
    ID_BUTTON_ADDADDRESS,
    ID_BUTTON_EDITADDRESS,
    ID_BUTTON_DELADDRESS,

    ID_LAST
  };

public:
  FF_AddressView(FXComposite *p,
		 FXuint opts=0,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_AddressView();

  void enter();
  void leave();

  void create();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AE_ADDRESS_LIST *addresses);
  void fromGui(AE_ADDRESS_LIST *addresses);

  void clear();
  void sortAddresss();

  long onCmdAddAddress(FXObject*, FXSelector, void*);
  long onCmdEditAddress(FXObject*, FXSelector, void*);
  long onCmdDelAddress(FXObject*, FXSelector, void*);

  long onTreeChanged(FXObject*, FXSelector, void*);

  void dump(int indent);

protected:
  FF_AddressView();

  FF_AddressTree *m_addressTree;

  FXButton *m_addAddressButton;
  FXButton *m_editAddressButton;
  FXButton *m_delAddressButton;
};




#endif

