/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_CURRENCYVIEW_HPP
#define FM_CURRENCYVIEW_HPP



#include <aqfinance/engine/book/ae_book.h>

#include <aqbanking/job.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FF_CurrencyTree;
class FM_Outbox;


class FF_CurrencyView: public FXHorizontalFrame {
  FXDECLARE(FF_CurrencyView)
public:
  enum {
    ID_CURRENCY_TREE=FXHorizontalFrame::ID_LAST,
    ID_BUTTON_ADD,
    ID_BUTTON_EDIT,
    ID_BUTTON_DEL,
    ID_LAST
  };

  FF_CurrencyView(FXComposite *p,
                  FXuint opts=0,
                  FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_CurrencyView();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void create();

  long onCmdCurrencyAdd(FXObject*, FXSelector, void* ptr);
  long onCmdCurrencyEdit(FXObject*, FXSelector, void* ptr);
  long onCmdCurrencyDel(FXObject*, FXSelector, void* ptr);

  void rebuild();

protected:
  FF_CurrencyView();

  FF_CurrencyTree *m_currencyTree;
  FXButton *m_addCurrencyButton;
  FXButton *m_editCurrencyButton;
  FXButton *m_delCurrencyButton;
};



#endif
