/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_GROUPVIEW_HPP
#define FF_GROUPVIEW_HPP


#include "ff_grouptree.hpp"

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_group.h>

#include <fx.h>

#include <list>


class FF_GroupTree;


class FF_GroupView: public FXHorizontalFrame {
  FXDECLARE(FF_GroupView)

public:
  enum {
    ID_GROUP_TREE=FXPacker::ID_LAST,
    ID_BUTTON_ADDGROUP,
    ID_BUTTON_EDITGROUP,
    ID_BUTTON_DELGROUP,

    ID_LAST
  };

public:
  FF_GroupView(AE_BOOK_TABLE_TYPE tt,
	       FXComposite *p,
	       FXuint opts=0,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_GroupView();

  void create();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void reload();

  long onCmdAddGroup(FXObject*, FXSelector, void*);
  long onCmdEditGroup(FXObject*, FXSelector, void*);
  long onCmdDelGroup(FXObject*, FXSelector, void*);

  long onTreeChanged(FXObject*, FXSelector, void*);

  void selectGroup(AQDB_ID id, bool b);
  void makeGroupVisible(AQDB_ID id);

  AE_GROUP *getCurrentGroup();
  AE_GROUP *getFirstSelectedGroup();

protected:
  FF_GroupView();

  FF_GroupTree *m_groupTree;

  FXButton *m_addGroupButton;
  FXButton *m_editGroupButton;
  FXButton *m_delGroupButton;

  AE_BOOK_TABLE_TYPE m_type;
};




#endif

