/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_PRINTDOCVIEW_HPP
#define FF_PRINTDOCVIEW_HPP


#include "ff_printdoctree.hpp"

#include <aqfinance/engine/book/ae_book.h>

#include <fx.h>

#include <list>


class FF_PrintDocTree;


class FF_PrintDocView: public FXHorizontalFrame {
  FXDECLARE(FF_PrintDocView)

public:
  enum {
    ID_DOC_TREE=FXPacker::ID_LAST,
    ID_BUTTON_ADDDOC,
    ID_BUTTON_EDITDOC,
    ID_BUTTON_DELDOC,

    ID_LAST
  };

public:
  FF_PrintDocView(FXComposite *p,
		  FXuint opts=0,
		  FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_PrintDocView();

  void enter();
  void leave();

  void create();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AF_PRINT_DOC_LIST *docs);
  void fromGui(AF_PRINT_DOC_LIST *docs);

  void clear();
  void sortDocs();
  void addDoc(AF_PRINT_DOC *doc, FXbool notify=FALSE);

  long onCmdAddDoc(FXObject*, FXSelector, void*);
  long onCmdEditDoc(FXObject*, FXSelector, void*);
  long onCmdDelDoc(FXObject*, FXSelector, void*);

  long onTreeChanged(FXObject*, FXSelector, void*);

  FF_PrintDocTree *getDocTree() const { return m_printDocTree;};

  void dump(int indent);

protected:
  FF_PrintDocView();

  FF_PrintDocTree *m_printDocTree;

  FXButton *m_addPrintDocButton;
  FXButton *m_editPrintDocButton;
  FXButton *m_delPrintDocButton;
};




#endif

