/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_RULEVIEW_HPP
#define FM_RULEVIEW_HPP



#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_rule.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>



class FF_RuleTree;


class FF_RuleView: public FXHorizontalFrame {
  FXDECLARE(FF_RuleView)
public:
  enum {
    ID_RULE_TREE=FXHorizontalFrame::ID_LAST,
    ID_BUTTON_ADD,
    ID_BUTTON_EDIT,
    ID_BUTTON_DEL,
    ID_BUTTON_TEST,
    ID_LAST
  };

  FF_RuleView(FXComposite *p,
              FXObject* tgt=NULL,
              FXSelector sel=0,
              FXuint opts=0,
              FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_RuleView();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AE_RULE_LIST *rules);
  void fromGui(AE_RULE_LIST *rules);

  void create();

  long onCmdRuleAdd(FXObject*, FXSelector, void* ptr);
  long onCmdRuleEdit(FXObject*, FXSelector, void* ptr);
  long onCmdRuleDel(FXObject*, FXSelector, void* ptr);
  long onCmdRuleTest(FXObject*, FXSelector, void* ptr);

protected:
  FF_RuleView();

  FF_RuleTree *m_ruleTree;
  FXButton *m_addRuleButton;
  FXButton *m_editRuleButton;
  FXButton *m_delRuleButton;
  FXButton *m_testRuleButton;

  AE_BOOK_TABLE_TYPE m_ownerType;
  AQDB_ID m_ownerId;
};



#endif
