/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_ACCOUNTEDIT_HPP
#define FF_ACCOUNTEDIT_HPP


#include <fx.h>

#include <aqfoxext/fxx_comboedit.hpp>

#include <aqfinance/engine/book/ae_account.h>



class FF_AccountEdit: public FXHorizontalFrame {
  FXDECLARE(FF_AccountEdit)

public:

  enum {
    ID_COMBOEDIT=FXHorizontalFrame::ID_LAST,
    ID_BUTTON,
    ID_LAST
  };

  FF_AccountEdit(FXComposite *p,
                 FXObject* tgt=NULL,
                 FXSelector sel=0,
                 FXuint opts=0,
                 FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_AccountEdit();

  void create();

  void enable();
  void disable();

  void setFont(FXFont* fnt);
  FXFont* getFont() const;

  virtual void setBackColor(FXColor clr);

  void setTextColor(FXColor clr);

  void setSelBackColor(FXColor clr);

  void setSelTextColor(FXColor clr);

  void setText(const FXString& text);
  FXString getText() const;

  void selectAll();

  void setAccountId(AQDB_ID id);
  AQDB_ID getAccountId();

  long onCmdCombo(FXObject*, FXSelector, void*);
  long onChgCombo(FXObject*, FXSelector, void*);
  long onCmdButton(FXObject*, FXSelector, void*);
  long onCmdCancel(FXObject *sender, FXSelector sel, void *ptr);
  long onFocusSelf(FXObject *sender, FXSelector sel, void *ptr);
  long onFocusIn(FXObject *sender, FXSelector sel, void *ptr);

  void reload();

  void setTipText(const FXString &text);

protected:
  FF_AccountEdit();

  AE_ACCOUNT_TREE *m_accountTree;
  FXXComboEdit *m_comboEdit;
  FXButton *m_button;
  FXIcon *m_iconButton;
};




#endif
