/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_AMOUNTEDIT_HPP
#define FF_AMOUNTEDIT_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_commodity.h>

#include <aqdatabase/aqdb_value.h>



class FF_AmountEdit: public FXHorizontalFrame {
  FXDECLARE(FF_AmountEdit)

public:

  enum {
    ID_TEXTFIELD=FXHorizontalFrame::ID_LAST,
    ID_COMBOBOX,
    ID_LAST
  };

  FF_AmountEdit(FXComposite *p,
		FXObject* tgt=NULL,
		FXSelector sel=0,
		FXuint opts=0,
		FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		FXint pl=DEFAULT_PAD,
		FXint pr=DEFAULT_PAD,
		FXint pt=DEFAULT_PAD,
		FXint pb=DEFAULT_PAD);
  ~FF_AmountEdit();

  void create();

  void setFont(FXFont* fnt);
  FXFont* getFont() const;

  virtual void setBackColor(FXColor clr);

  void setTextColor(FXColor clr);

  void setSelBackColor(FXColor clr);

  void setSelTextColor(FXColor clr);

  void setValue(const AQDB_VALUE *v);
  AQDB_VALUE *getValue();

  FXString getText();
  void setText(const char *s);

  AE_COMMODITY *getCurrency();

  void setCurrencyById(AQDB_ID id);
  AQDB_ID getCurrencyId();

  /* takes over the commodity */
  void addCurrency(AE_COMMODITY *co);

  void selectAll();

  void reload();

  long onCmdTextField(FXObject*, FXSelector, void*);
  long onFocusIn(FXObject *sender, FXSelector sel, void *ptr);

protected:
  FF_AmountEdit();

  AE_COMMODITY_LIST *m_commodities;

  FXTextField *m_textField;
  FXComboBox *m_comboBox;
};




#endif
