/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_COMMODITYEDIT_HPP
#define FF_COMMODITYEDIT_HPP


#include <fx.h>

#include <aqfoxext/fxx_comboedit.hpp>

#include <aqfinance/engine/book/ae_commodity.h>



class FF_CommodityEdit: public FXHorizontalFrame {
  FXDECLARE(FF_CommodityEdit)

public:

  enum {
    ID_COMBOEDIT=FXHorizontalFrame::ID_LAST,
    ID_BUTTON,
    ID_LAST
  };

  FF_CommodityEdit(FXComposite *p,
                 FXObject* tgt=NULL,
                 FXSelector sel=0,
                 FXuint opts=0,
                 FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                 FXint pl=DEFAULT_PAD,
                 FXint pr=DEFAULT_PAD,
                 FXint pt=DEFAULT_PAD,
                 FXint pb=DEFAULT_PAD);
  ~FF_CommodityEdit();

  void create();

  void setFont(FXFont* fnt);
  FXFont* getFont() const;

  virtual void setBackColor(FXColor clr);

  void setTextColor(FXColor clr);

  void setSelBackColor(FXColor clr);

  void setSelTextColor(FXColor clr);

  void setText(const FXString& text);
  FXString getText() const;

  void selectAll();

  void setCommodityId(AQDB_ID id);
  AQDB_ID getCommodityId();

  void setCurrency(const char *s);
  FXString getCurrency();

  long onCmdCombo(FXObject*, FXSelector, void*);
  long onCmdButton(FXObject*, FXSelector, void*);
  long onCmdCancel(FXObject *sender, FXSelector sel, void *ptr);
  long onFocusIn(FXObject *sender, FXSelector sel, void *ptr);

  void reload();

protected:
  FF_CommodityEdit();

  AE_COMMODITY_LIST *m_commodityList;
  FXXComboEdit *m_comboEdit;
  FXButton *m_button;
  FXIcon *m_iconButton;
};




#endif
