/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_FLICKERWIDGET_HPP
#define FF_FLICKERWIDGET_HPP


#include <fx.h>



class FF_FlickerWidget: public FXFrame {
  FXDECLARE(FF_FlickerWidget)

public:

  enum {
    ID_TIMER=FXFrame::ID_LAST,
    ID_LAST
  };


  FF_FlickerWidget(FXComposite *p,
                   FXuint opts=0,
                   FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_FlickerWidget();

  void setPhaseLength(int i);

  void setFlickerCode(const char *code);
  void startFlicker();
  void stopFlicker();

  long onPaint(FXObject*,FXSelector,void*);
  long onTimer(FXObject*,FXSelector,void*);

protected:
  FF_FlickerWidget();

  FXint m_flickerWidth;
  FXint m_flickerHeight;
  FXint m_phaseLength;

  FXbool m_isRunning;
  FXString m_code;
  FXint m_currentPos;
  FXint m_clock;

};




#endif
