/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_ITEMEDIT_HPP
#define FF_ITEMEDIT_HPP


#include <fx.h>

#include <aqfoxext/fxx_comboedit.hpp>

#include <aqfinance/engine/book/ae_book.h>
#include <aqfinance/engine/book/ae_item.h>



class FF_ItemEdit: public FXHorizontalFrame {
  FXDECLARE(FF_ItemEdit)

public:

  enum {
    ID_COMBOEDIT=FXHorizontalFrame::ID_LAST,
    ID_BUTTON,
    ID_LAST
  };

  FF_ItemEdit(AE_BOOK_TABLE_TYPE tt,
	      FXComposite *p,
	      FXObject* tgt=NULL,
	      FXSelector sel=0,
	      FXuint opts=0,
	      FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	      FXint pl=DEFAULT_PAD,
	      FXint pr=DEFAULT_PAD,
	      FXint pt=DEFAULT_PAD,
	      FXint pb=DEFAULT_PAD);
  ~FF_ItemEdit();

  void create();

  void setFont(FXFont* fnt);
  FXFont* getFont() const;

  virtual void setBackColor(FXColor clr);

  void setTextColor(FXColor clr);

  void setSelBackColor(FXColor clr);

  void setSelTextColor(FXColor clr);

  void setText(const FXString& text);
  FXString getText() const;

  void selectAll();

  void setItemId(AQDB_ID id);
  AQDB_ID getItemId();

  long onCmdCombo(FXObject*, FXSelector, void*);
  long onCmdButton(FXObject*, FXSelector, void*);
  long onCmdCancel(FXObject *sender, FXSelector sel, void *ptr);
  long onFocusIn(FXObject *sender, FXSelector sel, void *ptr);

  void reload();

protected:
  FF_ItemEdit();

  AE_ITEM_LIST *m_itemList;
  FXXComboEdit *m_comboEdit;
  FXButton *m_button;
  FXIcon *m_iconButton;

  AE_BOOK_TABLE_TYPE m_tableType;
};




#endif
