/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_LISTITEM_HPP
#define FF_LISTITEM_HPP


#include <fx.h>


/**
 * This list item displays text below an icon. The original FXListItem
 * displays the text on the right hand side of the icon.
 */
class FF_ListItem: public FXListItem {
protected:
  virtual void draw(const FXList* list, FXDC& dc,
                    FXint x, FXint y, FXint w, FXint h);
  FF_ListItem():FXListItem() {};

public:
  FF_ListItem(const FXString& text,
              FXIcon* ic=NULL,
              void* ptr=NULL);
  ~FF_ListItem();

  FXint getWidth(const FXList* list) const;
  FXint getHeight(const FXList* list) const;

};


#endif
