/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_PRINTDOCTREE_HPP
#define FF_PRINTDOCTREE_HPP

#include "ff_grouptree.hpp"

#include <fx.h>

#include <aqfinance/print/af_print_doc.h>




class FF_PrintDocTreeItem: public FF_GroupTreeItem {
public:
  FF_PrintDocTreeItem(AF_PRINT_DOC *doc, FXIcon* oi=NULL, FXIcon* ci=NULL, void* ptr=NULL);

  virtual ~FF_PrintDocTreeItem();

  AF_PRINT_DOC *getDoc() const { return m_doc;};

  void rebuild();

protected:

  AF_PRINT_DOC *m_doc;
};



class FF_PrintDocTree: public FF_GroupTree {

public:
  FF_PrintDocTree(FXComposite *p, FXObject* tgt=NULL, FXSelector sel=0, FXuint opts=0,
		  FXint x=0, FXint y=0, FXint w=0, FXint h=0);

  virtual ~FF_PrintDocTree();

  FF_PrintDocTreeItem *findDocItem(AQDB_ID id);
  FF_PrintDocTreeItem *findDocItem(FF_GroupTreeItem *grItem, AQDB_ID id);
  FF_PrintDocTreeItem *findDocItem(const char *category, const char *name);
  FF_PrintDocTreeItem *findDocItem(const char *name);

  void addDoc(AF_PRINT_DOC *doc, FXbool notify=FALSE);

  AF_PRINT_DOC *getCurrentDoc();
  AF_PRINT_DOC *getFirstSelectedDoc();
  void getSelectedDocs(AF_PRINT_DOC_LIST2 *al);

  void selectDoc(AQDB_ID id, bool b);
  void selectDoc(const char *category, const char *name, bool b);

  void makeDocVisible(AQDB_ID id);
  void makeDocVisible(const char *category, const char *name);

protected:
  FF_PrintDocTree();

};



#endif




