/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_RECURRENCEEDIT_HPP
#define FF_RECURRENCEEDIT_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_recurrence.h>

#include <aqbanking/transactionlimits.h>



class FF_RecurrenceEdit: public FXHorizontalFrame {
  FXDECLARE(FF_RecurrenceEdit)

public:

  enum {
    ID_EVERY_COMBO=FXHorizontalFrame::ID_LAST,
    ID_PERIOD_COMBO,
    ID_ON_COMBO,
    ID_BUTTON,
    ID_LAST
  };

  FF_RecurrenceEdit(FXComposite *p,
                    FXObject* tgt=NULL,
                    FXSelector sel=0,
                    FXuint opts=0,
                    FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_RecurrenceEdit();

  void create();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AE_RECURRENCE *rec);
  void fromGui(AE_RECURRENCE *rec);
  int checkGui(bool quiet);

  void setBankingLimits(const AB_TRANSACTION_LIMITS *l, bool withChangeLimits);

  long onCmdPeriodCombo(FXObject*, FXSelector, void*);

protected:
  FF_RecurrenceEdit();

  void updatePeriodCombo();
  void updateOnCombo();
  void updateEveryCombo();

  void _updateEveryCombo();
  void _updateOnCombo();
  void _updatePeriodCombo();

  FXComboBox *m_everyCombo;
  FXComboBox *m_periodCombo;
  FXComboBox *m_onCombo;
  FXLabel *m_periodLabel;

  int m_comboPosPeriodDay;
  int m_comboPosPeriodWeek;
  int m_comboPosPeriodMonth;
  int m_comboPosPeriodYear;

  int m_comboPosOnLastOfMonth;

  AB_TRANSACTION_LIMITS *m_bankingLimits;

};




#endif
