/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_RULETREE_HPP
#define FF_RULETREE_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_rule.h>

#include <list>



class FF_RuleTreeItem: public FXFoldingItem {
public:
  /**
   *
   */
  FF_RuleTreeItem(AE_RULE *r);

  virtual ~FF_RuleTreeItem();

  void updateRule();
  AE_RULE *getRule() const { return m_rule;};

protected:
  AE_RULE *m_rule;
};



class FF_RuleTree: public FXFoldingList {
  FXDECLARE(FF_RuleTree)

public:
  FF_RuleTree(FXComposite *p, FXObject* tgt=NULL, FXSelector sel=0, FXuint opts=0,
              FXint x=0, FXint y=0, FXint w=0, FXint h=0);

  virtual ~FF_RuleTree();

  FF_RuleTreeItem *findRuleItem(AQDB_ID id);

  AE_RULE *getCurrentRule();
  AE_RULE *getFirstSelectedRule();

  void expandItems();

  void addRule(const AE_RULE *r);
  void addRules(const AE_RULE_LIST *rl);

  void selectRule(AQDB_ID id, bool b);
  void makeRuleVisible(AQDB_ID id);

  void create();

protected:
  FF_RuleTree();

};



#endif




