/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_SESSIONLIST_HPP
#define FF_SESSIONLIST_HPP


#include <fx.h>

#include <aqdatabase/aqdb_sessiondescr.h>

#include <list>




class FF_SessionList: public FXFoldingList {

public:
  FF_SessionList(FXComposite *p, FXObject* tgt=NULL, FXSelector sel=0, FXuint opts=0,
                 FXint x=0, FXint y=0, FXint w=0, FXint h=0);

  virtual ~FF_SessionList();

  void addSession(AQDB_SESSION_DESCR *sd);
  void removeSession(AQDB_ID sid);

  AQDB_SESSION_DESCR *getCurrentSession();
  AQDB_SESSION_DESCR *getFirstSelectedSession();

  void selectSession(AQDB_ID sid);
  void deselectSession(AQDB_ID sid);

  void sortByColumn(int c, bool up);
  void setHeaderArrowDir(int c, FXbool b);
  FXbool getHeaderArrowDir(int c) const;

  void sort();

  long onHeaderClicked(FXObject*, FXSelector, void* ptr);

protected:
  FF_SessionList();

  static FXint sortFunctionUpSessionId(const FXFoldingItem *it1, const FXFoldingItem *it2);
  static FXint sortFunctionDownSessionId(const FXFoldingItem *it1, const FXFoldingItem *it2);

  static FXint sortFunctionUpDate(const FXFoldingItem *it1, const FXFoldingItem *it2);
  static FXint sortFunctionDownDate(const FXFoldingItem *it1, const FXFoldingItem *it2);

  static FXint sortFunctionUpUserName(const FXFoldingItem *it1, const FXFoldingItem *it2);
  static FXint sortFunctionDownUserName(const FXFoldingItem *it1, const FXFoldingItem *it2);

};



#endif


