/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef FF_VALUEEDIT_HPP
#define FF_VALUEEDIT_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_book.h>

#include <aqdatabase/aqdb_value.h>



class FF_ValueEdit: public FXTextField {
  FXDECLARE(FF_ValueEdit)

public:

  FF_ValueEdit(FXComposite *p,
	       FXint cols,
	       FXObject* tgt=NULL,
	       FXSelector sel=0,
	       FXuint opts=0,
	       FXint x=0, FXint y=0, FXint w=0, FXint h=0,
	       FXint pl=DEFAULT_PAD,
	       FXint pr=DEFAULT_PAD,
	       FXint pt=DEFAULT_PAD,
	       FXint pb=DEFAULT_PAD);
  ~FF_ValueEdit();

  void setValue(const AQDB_VALUE *v);
  void setValueAndUnits(const AQDB_VALUE *v, const char *units);

  AQDB_VALUE *getValue();

protected:
  FF_ValueEdit();
};




#endif
