/**********************************************************
 * This file has been automatically created by "typemaker2"
 * from the file "ae_account.xml".
 * Please do not edit this file, all changes will be lost.
 * Better edit the mentioned source file instead.
 **********************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ae_account_p.h"

#include <gwenhywfar/misc.h>
#include <gwenhywfar/debug.h>

/* code headers */

/* macro functions */
GWEN_LIST_FUNCTIONS(AE_ACCOUNT, AE_Account)
GWEN_TREE_FUNCTIONS(AE_ACCOUNT, AE_Account)


AE_ACCOUNT_GROUP AE_AccountGroup_fromString(const char *p_s) {
  if (p_s && *p_s) {
    if (strcasecmp(p_s, "asset")==0)
      return AE_AccountGroup_Asset;
    else if (strcasecmp(p_s, "liability")==0)
      return AE_AccountGroup_Liability;
    else if (strcasecmp(p_s, "equity")==0)
      return AE_AccountGroup_Equity;
    else if (strcasecmp(p_s, "income")==0)
      return AE_AccountGroup_Income;
    else if (strcasecmp(p_s, "expense")==0)
      return AE_AccountGroup_Expense;
  }
  return AE_AccountGroup_Unknown;
}

AE_ACCOUNT_TYPE AE_AccountType_fromString(const char *p_s) {
  if (p_s && *p_s) {
    if (strcasecmp(p_s, "asset")==0)
      return AE_AccountType_Asset;
    else if (strcasecmp(p_s, "cash")==0)
      return AE_AccountType_Cash;
    else if (strcasecmp(p_s, "bank")==0)
      return AE_AccountType_Bank;
    else if (strcasecmp(p_s, "openDebitNotes")==0)
      return AE_AccountType_OpenDebitNotes;
    else if (strcasecmp(p_s, "receivable")==0)
      return AE_AccountType_Receivable;
    else if (strcasecmp(p_s, "liability")==0)
      return AE_AccountType_Liability;
    else if (strcasecmp(p_s, "creditCard")==0)
      return AE_AccountType_CreditCard;
    else if (strcasecmp(p_s, "openTransfers")==0)
      return AE_AccountType_OpenTransfers;
    else if (strcasecmp(p_s, "payable")==0)
      return AE_AccountType_Payable;
    else if (strcasecmp(p_s, "equity")==0)
      return AE_AccountType_Equity;
    else if (strcasecmp(p_s, "autoEquity")==0)
      return AE_AccountType_AutoEquity;
    else if (strcasecmp(p_s, "income")==0)
      return AE_AccountType_Income;
    else if (strcasecmp(p_s, "taxIncome")==0)
      return AE_AccountType_TaxIncome;
    else if (strcasecmp(p_s, "expense")==0)
      return AE_AccountType_Expense;
    else if (strcasecmp(p_s, "taxExpense")==0)
      return AE_AccountType_TaxExpense;
  }
  return AE_AccountType_Unknown;
}

const char *AE_AccountGroup_toString(AE_ACCOUNT_GROUP p_i) {
  switch(p_i) {
    case AE_AccountGroup_Asset: return "asset";
    case AE_AccountGroup_Liability: return "liability";
    case AE_AccountGroup_Equity: return "equity";
    case AE_AccountGroup_Income: return "income";
    case AE_AccountGroup_Expense: return "expense";
    default: return "unknown";
  }
}

const char *AE_AccountType_toString(AE_ACCOUNT_TYPE p_i) {
  switch(p_i) {
    case AE_AccountType_Asset: return "asset";
    case AE_AccountType_Cash: return "cash";
    case AE_AccountType_Bank: return "bank";
    case AE_AccountType_OpenDebitNotes: return "openDebitNotes";
    case AE_AccountType_Receivable: return "receivable";
    case AE_AccountType_Liability: return "liability";
    case AE_AccountType_CreditCard: return "creditCard";
    case AE_AccountType_OpenTransfers: return "openTransfers";
    case AE_AccountType_Payable: return "payable";
    case AE_AccountType_Equity: return "equity";
    case AE_AccountType_AutoEquity: return "autoEquity";
    case AE_AccountType_Income: return "income";
    case AE_AccountType_TaxIncome: return "taxIncome";
    case AE_AccountType_Expense: return "expense";
    case AE_AccountType_TaxExpense: return "taxExpense";
    default: return "unknown";
  }
}

AE_ACCOUNT *AE_Account_new(void) {
  AE_ACCOUNT *p_struct;

  GWEN_NEW_OBJECT(AE_ACCOUNT, p_struct)
  p_struct->_refCount=1;
  GWEN_LIST_INIT(AE_ACCOUNT, p_struct)
  GWEN_TREE_INIT(AE_ACCOUNT, p_struct)
  /* members */
  p_struct->id=0;
  p_struct->parentId=0;
  p_struct->type=AE_AccountType_Unknown;
  p_struct->name=NULL;
  p_struct->code=NULL;
  p_struct->description=NULL;
  p_struct->primaryCommodityId=0;
  p_struct->secondaryCommodityId=0;
  p_struct->bankAccountId=0;
  p_struct->flags=0;
  p_struct->taxId=0;
  p_struct->partnerId=0;
  p_struct->dbId=0;
  p_struct->runtimeFlags=0;
  p_struct->rules=AE_Rule_List_new();
  p_struct->balance=NULL;
  p_struct->branchBalance=NULL;
  /* virtual functions */

  return p_struct;
}

void AE_Account_free(AE_ACCOUNT *p_struct) {
  if (p_struct) {
  assert(p_struct->_refCount);
  if (p_struct->_refCount==1) {
    GWEN_LIST_FINI(AE_ACCOUNT, p_struct)
    GWEN_TREE_FINI(AE_ACCOUNT, p_struct)
  /* members */
    free(p_struct->name);
    free(p_struct->code);
    free(p_struct->description);
    AE_Rule_List_free(p_struct->rules);
    AE_AccountBalance_free(p_struct->balance);
    AE_AccountBalance_free(p_struct->branchBalance);
    p_struct->_refCount=0;
    GWEN_FREE_OBJECT(p_struct);
  }
  else
    p_struct->_refCount--;
  }
}

void AE_Account_Attach(AE_ACCOUNT *p_struct) {
  assert(p_struct);
  assert(p_struct->_refCount);
  p_struct->_refCount++;
}

AE_ACCOUNT *AE_Account_dup(const AE_ACCOUNT *p_src) {
  AE_ACCOUNT *p_struct;

  assert(p_src);
  p_struct=AE_Account_new();
  /* member "id" */
  p_struct->id=p_src->id;

  /* member "parentId" */
  p_struct->parentId=p_src->parentId;

  /* member "type" */
  p_struct->type=p_src->type;

  /* member "name" */
  if (p_struct->name) {
    free(p_struct->name);
    p_struct->name=NULL;
  }
  if (p_src->name) {
    p_struct->name=strdup(p_src->name);
  }

  /* member "code" */
  if (p_struct->code) {
    free(p_struct->code);
    p_struct->code=NULL;
  }
  if (p_src->code) {
    p_struct->code=strdup(p_src->code);
  }

  /* member "description" */
  if (p_struct->description) {
    free(p_struct->description);
    p_struct->description=NULL;
  }
  if (p_src->description) {
    p_struct->description=strdup(p_src->description);
  }

  /* member "primaryCommodityId" */
  p_struct->primaryCommodityId=p_src->primaryCommodityId;

  /* member "secondaryCommodityId" */
  p_struct->secondaryCommodityId=p_src->secondaryCommodityId;

  /* member "bankAccountId" */
  p_struct->bankAccountId=p_src->bankAccountId;

  /* member "flags" */
  p_struct->flags=p_src->flags;

  /* member "taxId" */
  p_struct->taxId=p_src->taxId;

  /* member "partnerId" */
  p_struct->partnerId=p_src->partnerId;

  /* member "dbId" */
  p_struct->dbId=p_src->dbId;

  /* member "runtimeFlags" */
  p_struct->runtimeFlags=p_src->runtimeFlags;

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
    p_struct->rules=NULL;
  }
  if (p_src->rules) {
    p_struct->rules=AE_Rule_List_dup(p_src->rules);
  }

  /* member "balance" */
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
    p_struct->balance=NULL;
  }
  if (p_src->balance) {
    p_struct->balance=AE_AccountBalance_dup(p_src->balance);
  }

  /* member "branchBalance" */
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
    p_struct->branchBalance=NULL;
  }
  if (p_src->branchBalance) {
    p_struct->branchBalance=AE_AccountBalance_dup(p_src->branchBalance);
  }

  return p_struct;
}

AE_ACCOUNT *AE_Account_copy(AE_ACCOUNT *p_struct, const AE_ACCOUNT *p_src) {
    assert(p_struct);
  assert(p_src);
  /* member "id" */
  p_struct->id=p_src->id;

  /* member "parentId" */
  p_struct->parentId=p_src->parentId;

  /* member "type" */
  p_struct->type=p_src->type;

  /* member "name" */
  if (p_struct->name) {
    free(p_struct->name);
  }
  if (p_struct->name) {
    free(p_struct->name);
    p_struct->name=NULL;
  }
  if (p_src->name) {
    p_struct->name=strdup(p_src->name);
  }

  /* member "code" */
  if (p_struct->code) {
    free(p_struct->code);
  }
  if (p_struct->code) {
    free(p_struct->code);
    p_struct->code=NULL;
  }
  if (p_src->code) {
    p_struct->code=strdup(p_src->code);
  }

  /* member "description" */
  if (p_struct->description) {
    free(p_struct->description);
  }
  if (p_struct->description) {
    free(p_struct->description);
    p_struct->description=NULL;
  }
  if (p_src->description) {
    p_struct->description=strdup(p_src->description);
  }

  /* member "primaryCommodityId" */
  p_struct->primaryCommodityId=p_src->primaryCommodityId;

  /* member "secondaryCommodityId" */
  p_struct->secondaryCommodityId=p_src->secondaryCommodityId;

  /* member "bankAccountId" */
  p_struct->bankAccountId=p_src->bankAccountId;

  /* member "flags" */
  p_struct->flags=p_src->flags;

  /* member "taxId" */
  p_struct->taxId=p_src->taxId;

  /* member "partnerId" */
  p_struct->partnerId=p_src->partnerId;

  /* member "dbId" */
  p_struct->dbId=p_src->dbId;

  /* member "runtimeFlags" */
  p_struct->runtimeFlags=p_src->runtimeFlags;

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
    p_struct->rules=NULL;
  }
  if (p_src->rules) {
    p_struct->rules=AE_Rule_List_dup(p_src->rules);
  }

  /* member "balance" */
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
  }
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
    p_struct->balance=NULL;
  }
  if (p_src->balance) {
    p_struct->balance=AE_AccountBalance_dup(p_src->balance);
  }

  /* member "branchBalance" */
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
  }
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
    p_struct->branchBalance=NULL;
  }
  if (p_src->branchBalance) {
    p_struct->branchBalance=AE_AccountBalance_dup(p_src->branchBalance);
  }

  return p_struct;
}

AQDB_ID AE_Account_GetId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->id;
}

AQDB_ID AE_Account_GetParentId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->parentId;
}

AE_ACCOUNT_TYPE AE_Account_GetType(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->type;
}

const char *AE_Account_GetName(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->name;
}

const char *AE_Account_GetCode(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->code;
}

const char *AE_Account_GetDescription(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->description;
}

AQDB_ID AE_Account_GetPrimaryCommodityId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->primaryCommodityId;
}

AQDB_ID AE_Account_GetSecondaryCommodityId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->secondaryCommodityId;
}

AQDB_ID AE_Account_GetBankAccountId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->bankAccountId;
}

uint32_t AE_Account_GetFlags(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->flags;
}

AQDB_ID AE_Account_GetTaxId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->taxId;
}

AQDB_ID AE_Account_GetPartnerId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->partnerId;
}

AQDB_ID AE_Account_GetDbId(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->dbId;
}

uint32_t AE_Account_GetRuntimeFlags(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->runtimeFlags;
}

AE_RULE_LIST *AE_Account_GetRules(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->rules;
}

AE_ACCOUNTBALANCE *AE_Account_GetBalance(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->balance;
}

AE_ACCOUNTBALANCE *AE_Account_GetBranchBalance(const AE_ACCOUNT *p_struct) {
  assert(p_struct);
  return p_struct->branchBalance;
}

void AE_Account_SetId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->id=p_src;
}

void AE_Account_SetParentId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->parentId=p_src;
}

void AE_Account_SetType(AE_ACCOUNT *p_struct, AE_ACCOUNT_TYPE  p_src) {
  assert(p_struct);
  p_struct->type=p_src;
}

void AE_Account_SetName(AE_ACCOUNT *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->name) {
    free(p_struct->name);
  }
  if (p_src) {
    p_struct->name=strdup(p_src);
  }
  else {
    p_struct->name=NULL;
  }
}

void AE_Account_SetCode(AE_ACCOUNT *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->code) {
    free(p_struct->code);
  }
  if (p_src) {
    p_struct->code=strdup(p_src);
  }
  else {
    p_struct->code=NULL;
  }
}

void AE_Account_SetDescription(AE_ACCOUNT *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->description) {
    free(p_struct->description);
  }
  if (p_src) {
    p_struct->description=strdup(p_src);
  }
  else {
    p_struct->description=NULL;
  }
}

void AE_Account_SetPrimaryCommodityId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->primaryCommodityId=p_src;
}

void AE_Account_SetSecondaryCommodityId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->secondaryCommodityId=p_src;
}

void AE_Account_SetBankAccountId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->bankAccountId=p_src;
}

void AE_Account_SetFlags(AE_ACCOUNT *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->flags=p_src;
}

void AE_Account_AddFlags(AE_ACCOUNT *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->flags|=p_src;
}

void AE_Account_SubFlags(AE_ACCOUNT *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->flags&=~p_src;
}

void AE_Account_SetTaxId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->taxId=p_src;
}

void AE_Account_SetPartnerId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->partnerId=p_src;
}

void AE_Account_SetDbId(AE_ACCOUNT *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->dbId=p_src;
}

void AE_Account_SetRuntimeFlags(AE_ACCOUNT *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->runtimeFlags=p_src;
}

void AE_Account_AddRuntimeFlags(AE_ACCOUNT *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->runtimeFlags|=p_src;
}

void AE_Account_SubRuntimeFlags(AE_ACCOUNT *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->runtimeFlags&=~p_src;
}

void AE_Account_SetRules(AE_ACCOUNT *p_struct, AE_RULE_LIST *p_src) {
  assert(p_struct);
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  p_struct->rules=p_src;
}

void AE_Account_SetBalance(AE_ACCOUNT *p_struct, AE_ACCOUNTBALANCE *p_src) {
  assert(p_struct);
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
  }
  p_struct->balance=p_src;
}

void AE_Account_SetBranchBalance(AE_ACCOUNT *p_struct, AE_ACCOUNTBALANCE *p_src) {
  assert(p_struct);
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
  }
  p_struct->branchBalance=p_src;
}

/* list1 functions */
AE_ACCOUNT_LIST *AE_Account_List_dup(const AE_ACCOUNT_LIST *p_src) {
  AE_ACCOUNT_LIST *p_dest;
  AE_ACCOUNT *p_elem;

  assert(p_src);
  p_dest=AE_Account_List_new();
  p_elem=AE_Account_List_First(p_src);
  while(p_elem) {
    AE_ACCOUNT *p_cpy;

    p_cpy=AE_Account_dup(p_elem);
    AE_Account_List_Add(p_cpy, p_dest);
    p_elem=AE_Account_List_Next(p_elem);
  }

  return p_dest;
}

void AE_Account_ReadDb(AE_ACCOUNT *p_struct, GWEN_DB_NODE *p_db) {
  assert(p_struct);
  /* member "id" */
  p_struct->id=GWEN_DB_GetIntValue(p_db, "id", 0, 0);

  /* member "parentId" */
  p_struct->parentId=GWEN_DB_GetIntValue(p_db, "parentId", 0, 0);

  /* member "type" */
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "type", 0, NULL); if (s) p_struct->type=AE_AccountType_fromString(s); else p_struct->type=AE_AccountType_Unknown; }

  /* member "name" */
  if (p_struct->name) {
    free(p_struct->name);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "name", 0, NULL); if (s) p_struct->name=strdup(s); }
  if (p_struct->name==NULL) {  p_struct->name=NULL;
  }

  /* member "code" */
  if (p_struct->code) {
    free(p_struct->code);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "code", 0, NULL); if (s) p_struct->code=strdup(s); }
  if (p_struct->code==NULL) {  p_struct->code=NULL;
  }

  /* member "description" */
  if (p_struct->description) {
    free(p_struct->description);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "description", 0, NULL); if (s) p_struct->description=strdup(s); }
  if (p_struct->description==NULL) {  p_struct->description=NULL;
  }

  /* member "primaryCommodityId" */
  p_struct->primaryCommodityId=GWEN_DB_GetIntValue(p_db, "primaryCommodityId", 0, 0);

  /* member "secondaryCommodityId" */
  p_struct->secondaryCommodityId=GWEN_DB_GetIntValue(p_db, "secondaryCommodityId", 0, 0);

  /* member "bankAccountId" */
  p_struct->bankAccountId=GWEN_DB_GetIntValue(p_db, "bankAccountId", 0, 0);

  /* member "flags" */
  p_struct->flags=GWEN_DB_GetIntValue(p_db, "flags", 0, 0);

  /* member "taxId" */
  p_struct->taxId=GWEN_DB_GetIntValue(p_db, "taxId", 0, 0);

  /* member "partnerId" */
  p_struct->partnerId=GWEN_DB_GetIntValue(p_db, "partnerId", 0, 0);

  /* member "dbId" */
  /* member "dbId" is volatile, just presetting */
  p_struct->dbId=0;

  /* member "runtimeFlags" */
  /* member "runtimeFlags" is volatile, just presetting */
  p_struct->runtimeFlags=0;

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  /* member "rules" is volatile, just presetting */
  p_struct->rules=AE_Rule_List_new();

  /* member "balance" */
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
  }
  /* member "balance" is volatile, just presetting */
  p_struct->balance=NULL;

  /* member "branchBalance" */
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
  }
  /* member "branchBalance" is volatile, just presetting */
  p_struct->branchBalance=NULL;

}

int AE_Account_WriteDb(const AE_ACCOUNT *p_struct, GWEN_DB_NODE *p_db) {
  int p_rv;

  assert(p_struct);
  /* member "id" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "id", p_struct->id);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "parentId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "parentId", p_struct->parentId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "type" */
  p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "type", AE_AccountType_toString(p_struct->type));
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "name" */
  if (p_struct->name) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "name", p_struct->name); else { GWEN_DB_DeleteVar(p_db, "name"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "code" */
  if (p_struct->code) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "code", p_struct->code); else { GWEN_DB_DeleteVar(p_db, "code"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "description" */
  if (p_struct->description) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "description", p_struct->description); else { GWEN_DB_DeleteVar(p_db, "description"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "primaryCommodityId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "primaryCommodityId", p_struct->primaryCommodityId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "secondaryCommodityId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "secondaryCommodityId", p_struct->secondaryCommodityId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "bankAccountId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "bankAccountId", p_struct->bankAccountId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "flags" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "flags", p_struct->flags);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "taxId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "taxId", p_struct->taxId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "partnerId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "partnerId", p_struct->partnerId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "dbId" is volatile, not writing to db */

  /* member "runtimeFlags" is volatile, not writing to db */

  /* member "rules" is volatile, not writing to db */

  /* member "balance" is volatile, not writing to db */

  /* member "branchBalance" is volatile, not writing to db */

  return 0;
}

AE_ACCOUNT *AE_Account_fromDb(GWEN_DB_NODE *p_db) {
  AE_ACCOUNT *p_struct;
  p_struct=AE_Account_new();
  AE_Account_ReadDb(p_struct, p_db);
  return p_struct;
}

int AE_Account_toDb(const AE_ACCOUNT *p_struct, GWEN_DB_NODE *p_db) {
  return AE_Account_WriteDb(p_struct, p_db);
}

void AE_Account_ReadXml(AE_ACCOUNT *p_struct, GWEN_XMLNODE *p_db) {
  assert(p_struct);
  /* member "id" */
  p_struct->id=GWEN_XMLNode_GetIntValue(p_db, "id", 0);

  /* member "parentId" */
  p_struct->parentId=GWEN_XMLNode_GetIntValue(p_db, "parentId", 0);

  /* member "type" */
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "type", NULL); if (s) p_struct->type=AE_AccountType_fromString(s); else p_struct->type=AE_AccountType_Unknown; }

  /* member "name" */
  if (p_struct->name) {
    free(p_struct->name);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "name", NULL); if (s) p_struct->name=strdup(s); }
  if (p_struct->name==NULL) {  /* member "name" is volatile, just presetting */
  p_struct->name=NULL;
  }

  /* member "code" */
  if (p_struct->code) {
    free(p_struct->code);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "code", NULL); if (s) p_struct->code=strdup(s); }
  if (p_struct->code==NULL) {  /* member "code" is volatile, just presetting */
  p_struct->code=NULL;
  }

  /* member "description" */
  if (p_struct->description) {
    free(p_struct->description);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "description", NULL); if (s) p_struct->description=strdup(s); }
  if (p_struct->description==NULL) {  /* member "description" is volatile, just presetting */
  p_struct->description=NULL;
  }

  /* member "primaryCommodityId" */
  p_struct->primaryCommodityId=GWEN_XMLNode_GetIntValue(p_db, "primaryCommodityId", 0);

  /* member "secondaryCommodityId" */
  p_struct->secondaryCommodityId=GWEN_XMLNode_GetIntValue(p_db, "secondaryCommodityId", 0);

  /* member "bankAccountId" */
  p_struct->bankAccountId=GWEN_XMLNode_GetIntValue(p_db, "bankAccountId", 0);

  /* member "flags" */
  p_struct->flags=GWEN_XMLNode_GetIntValue(p_db, "flags", 0);

  /* member "taxId" */
  p_struct->taxId=GWEN_XMLNode_GetIntValue(p_db, "taxId", 0);

  /* member "partnerId" */
  p_struct->partnerId=GWEN_XMLNode_GetIntValue(p_db, "partnerId", 0);

  /* member "dbId" */
  /* member "dbId" is volatile, just presetting */
  p_struct->dbId=0;

  /* member "runtimeFlags" */
  /* member "runtimeFlags" is volatile, just presetting */
  p_struct->runtimeFlags=0;

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  /* member "rules" is volatile, just presetting */
  p_struct->rules=AE_Rule_List_new();

  /* member "balance" */
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
  }
  /* member "balance" is volatile, just presetting */
  p_struct->balance=NULL;

  /* member "branchBalance" */
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
  }
  /* member "branchBalance" is volatile, just presetting */
  p_struct->branchBalance=NULL;

}

void AE_Account_WriteXml(const AE_ACCOUNT *p_struct, GWEN_XMLNODE *p_db) {
  assert(p_struct);
  /* member "id" */
  GWEN_XMLNode_SetIntValue(p_db, "id", p_struct->id);

  /* member "parentId" */
  GWEN_XMLNode_SetIntValue(p_db, "parentId", p_struct->parentId);

  /* member "type" */
  GWEN_XMLNode_SetCharValue(p_db, "type", AE_AccountType_toString(p_struct->type));

  /* member "name" */
  GWEN_XMLNode_SetCharValue(p_db, "name", p_struct->name);

  /* member "code" */
  GWEN_XMLNode_SetCharValue(p_db, "code", p_struct->code);

  /* member "description" */
  GWEN_XMLNode_SetCharValue(p_db, "description", p_struct->description);

  /* member "primaryCommodityId" */
  GWEN_XMLNode_SetIntValue(p_db, "primaryCommodityId", p_struct->primaryCommodityId);

  /* member "secondaryCommodityId" */
  GWEN_XMLNode_SetIntValue(p_db, "secondaryCommodityId", p_struct->secondaryCommodityId);

  /* member "bankAccountId" */
  GWEN_XMLNode_SetIntValue(p_db, "bankAccountId", p_struct->bankAccountId);

  /* member "flags" */
  GWEN_XMLNode_SetIntValue(p_db, "flags", p_struct->flags);

  /* member "taxId" */
  GWEN_XMLNode_SetIntValue(p_db, "taxId", p_struct->taxId);

  /* member "partnerId" */
  GWEN_XMLNode_SetIntValue(p_db, "partnerId", p_struct->partnerId);

  /* member "dbId" is volatile, not writing to xml */

  /* member "runtimeFlags" is volatile, not writing to xml */

  /* member "rules" is volatile, not writing to xml */

  /* member "balance" is volatile, not writing to xml */

  /* member "branchBalance" is volatile, not writing to xml */

}

void AE_Account_toXml(const AE_ACCOUNT *p_struct, GWEN_XMLNODE *p_db) {
  AE_Account_WriteXml(p_struct, p_db);
}

AE_ACCOUNT *AE_Account_fromXml(GWEN_XMLNODE *p_db) {
  AE_ACCOUNT *p_struct;
  p_struct=AE_Account_new();
  AE_Account_ReadXml(p_struct, p_db);
  return p_struct;
}

int AE_Account_ReadObject(AE_ACCOUNT *p_struct, const AQDB_OBJECT *p_db) {
  int p_rv;

  assert(p_struct);
  /* member "id" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_ID, &v64); if (p_rv>=0) p_struct->id=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "parentId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_PARENTID, &v64); if (p_rv>=0) p_struct->parentId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "type" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_TYPE, &v64); if (p_rv>=0) p_struct->type=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "name" */
  if (p_struct->name) {
    free(p_struct->name);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_ACCOUNT_FIELD_NAME, &s); if (p_rv>=0 && s) p_struct->name=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "code" */
  if (p_struct->code) {
    free(p_struct->code);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_ACCOUNT_FIELD_CODE, &s); if (p_rv>=0 && s) p_struct->code=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "description" */
  if (p_struct->description) {
    free(p_struct->description);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_ACCOUNT_FIELD_DESCRIPTION, &s); if (p_rv>=0 && s) p_struct->description=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "primaryCommodityId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_PRIMARYCOMMODITYID, &v64); if (p_rv>=0) p_struct->primaryCommodityId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "secondaryCommodityId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_SECONDARYCOMMODITYID, &v64); if (p_rv>=0) p_struct->secondaryCommodityId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "bankAccountId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_BANKACCOUNTID, &v64); if (p_rv>=0) p_struct->bankAccountId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "flags" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_FLAGS, &v64); if (p_rv>=0) p_struct->flags=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "taxId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_TAXID, &v64); if (p_rv>=0) p_struct->taxId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "partnerId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_ACCOUNT_FIELD_PARTNERID, &v64); if (p_rv>=0) p_struct->partnerId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "dbId" */
  /* member "dbId" is volatile, just presetting */
  p_struct->dbId=0;

  /* member "runtimeFlags" */
  /* member "runtimeFlags" is volatile, just presetting */
  p_struct->runtimeFlags=0;

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  /* member "rules" is volatile, just presetting */
  p_struct->rules=AE_Rule_List_new();

  /* member "balance" */
  if (p_struct->balance) {
    AE_AccountBalance_free(p_struct->balance);
  }
  /* member "balance" is volatile, just presetting */
  p_struct->balance=NULL;

  /* member "branchBalance" */
  if (p_struct->branchBalance) {
    AE_AccountBalance_free(p_struct->branchBalance);
  }
  /* member "branchBalance" is volatile, just presetting */
  p_struct->branchBalance=NULL;

  return 0;
}

int AE_Account_WriteObject(const AE_ACCOUNT *p_struct, AQDB_OBJECT *p_db) {
  int p_rv;

  assert(p_struct);
  /* member "id" */
  { int64_t v64=(int64_t) (p_struct->id); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_ID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "parentId" */
  { int64_t v64=(int64_t) (p_struct->parentId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_PARENTID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "type" */
  { int64_t v64=(int64_t) (p_struct->type); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_TYPE, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "name" */
  if (p_struct->name) p_rv=AQDB_Object_SetFieldString(p_db, AE_ACCOUNT_FIELD_NAME, p_struct->name); else p_rv=AQDB_Object_SetFieldString(p_db, AE_ACCOUNT_FIELD_NAME, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "code" */
  if (p_struct->code) p_rv=AQDB_Object_SetFieldString(p_db, AE_ACCOUNT_FIELD_CODE, p_struct->code); else p_rv=AQDB_Object_SetFieldString(p_db, AE_ACCOUNT_FIELD_CODE, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "description" */
  if (p_struct->description) p_rv=AQDB_Object_SetFieldString(p_db, AE_ACCOUNT_FIELD_DESCRIPTION, p_struct->description); else p_rv=AQDB_Object_SetFieldString(p_db, AE_ACCOUNT_FIELD_DESCRIPTION, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "primaryCommodityId" */
  { int64_t v64=(int64_t) (p_struct->primaryCommodityId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_PRIMARYCOMMODITYID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "secondaryCommodityId" */
  { int64_t v64=(int64_t) (p_struct->secondaryCommodityId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_SECONDARYCOMMODITYID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "bankAccountId" */
  { int64_t v64=(int64_t) (p_struct->bankAccountId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_BANKACCOUNTID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "flags" */
  { int64_t v64=(int64_t) (p_struct->flags); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_FLAGS, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "taxId" */
  { int64_t v64=(int64_t) (p_struct->taxId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_TAXID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "partnerId" */
  { int64_t v64=(int64_t) (p_struct->partnerId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_ACCOUNT_FIELD_PARTNERID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "dbId" is volatile, not writing to object */

  /* member "runtimeFlags" is volatile, not writing to object */

  /* member "rules" is volatile, not writing to object */

  /* member "balance" is volatile, not writing to object */

  /* member "branchBalance" is volatile, not writing to object */

  return 0;
}

int AE_Account_toObject(const AE_ACCOUNT *p_struct, AQDB_OBJECT *p_db) {
  return AE_Account_WriteObject(p_struct, p_db);
}

int AE_Account_fromObject(const AQDB_OBJECT *p_db, AE_ACCOUNT **pp_struct) {
  AE_ACCOUNT *p_struct;
  int p_rv;
  p_struct=AE_Account_new();
  p_rv=AE_Account_ReadObject(p_struct, p_db);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)", p_rv);
    AE_Account_free(p_struct);
    return p_rv;
  }
  *pp_struct=p_struct;
  return 0;
}

AQDB_COLUMN_LIST *AE_Account_CreateColumnList() {
  AQDB_COLUMN_LIST *p_cl;
  AQDB_COLUMN *p_c;

  p_cl=AQDB_Column_List_new();

  /* member "id" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "id", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "parentId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "parentId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "type" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "type", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "name" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "name", 64);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "code" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "code", 64);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "description" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "description", 64);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "primaryCommodityId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "primaryCommodityId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "secondaryCommodityId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "secondaryCommodityId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "bankAccountId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "bankAccountId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "flags" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "flags", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "taxId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "taxId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "partnerId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "partnerId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "dbId" is volatile, not adding to column list */

  /* member "runtimeFlags" is volatile, not adding to column list */

  /* member "rules" is volatile, not adding to column list */

  /* member "balance" is volatile, not adding to column list */

  /* member "branchBalance" is volatile, not adding to column list */

  return p_cl;
}

int AE_Account_CreateTable(AQDB_DB *p_db, const char *p_name, uint32_t p_flags) {
  AQDB_COLUMN_LIST *p_cl;
  int p_rv;

  p_cl=AE_Account_CreateColumnList();
  p_rv=AQDB_DB_CreateTable(p_db, p_name, p_flags, p_cl);
  AQDB_Column_List_free(p_cl);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)", p_rv);
    return p_rv;
  }
  return 0;
}

int AE_Account_CreateObject(AQDB_DB *p_db, AQDB_ID p_tableId, AQDB_ID p_id, AQDB_OBJECT **pp_o) {
  AQDB_OBJECT *p_o;

  p_o=AQDB_Object_new(p_tableId, p_id, AE_ACCOUNT_FIELD_COUNT);
  *pp_o=p_o;
  return 0;
}

AE_ACCOUNT *AE_Account_List_GetById(const AE_ACCOUNT_LIST *p_list, AQDB_ID p_cmp) {
  AE_ACCOUNT *p_struct;

  assert(p_list);
  p_struct = AE_Account_List_First(p_list);
  while(p_struct) {
    int p_rv;

    if (p_struct->id==p_cmp) p_rv=0; else if (p_cmp<p_struct->id) p_rv=-1; else p_rv=1;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Account_List_Next(p_struct);
  }
  return NULL;
}

AE_ACCOUNT *AE_Account_Tree_GetById(const AE_ACCOUNT_TREE *p_tree, AQDB_ID p_cmp) {
  AE_ACCOUNT *p_struct;

  assert(p_tree);
  p_struct = AE_Account_Tree_GetFirst(p_tree);
  while(p_struct) {
    int p_rv;

    if (p_struct->id==p_cmp) p_rv=0; else if (p_cmp<p_struct->id) p_rv=-1; else p_rv=1;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Account_Tree_GetBelow(p_struct);
  }
  return NULL;
}

AE_ACCOUNT *AE_Account_List_GetByName(const AE_ACCOUNT_LIST *p_list,  const char *p_cmp) {
  AE_ACCOUNT *p_struct;

  assert(p_list);
  p_struct = AE_Account_List_First(p_list);
  while(p_struct) {
    int p_rv;

    if (p_struct->name && p_cmp) p_rv=strcasecmp(p_cmp, p_struct->name); else if (p_cmp) p_rv=1; else if (p_struct->name) p_rv=-1; else p_rv=0;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Account_List_Next(p_struct);
  }
  return NULL;
}

AE_ACCOUNT *AE_Account_Tree_GetByName(const AE_ACCOUNT_TREE *p_tree,  const char *p_cmp) {
  AE_ACCOUNT *p_struct;

  assert(p_tree);
  p_struct = AE_Account_Tree_GetFirst(p_tree);
  while(p_struct) {
    int p_rv;

    if (p_struct->name && p_cmp) p_rv=strcasecmp(p_cmp, p_struct->name); else if (p_cmp) p_rv=1; else if (p_struct->name) p_rv=-1; else p_rv=0;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Account_Tree_GetBelow(p_struct);
  }
  return NULL;
}

AE_ACCOUNT *AE_Account_List_GetByBankAccountId(const AE_ACCOUNT_LIST *p_list, AQDB_ID p_cmp) {
  AE_ACCOUNT *p_struct;

  assert(p_list);
  p_struct = AE_Account_List_First(p_list);
  while(p_struct) {
    int p_rv;

    if (p_struct->bankAccountId==p_cmp) p_rv=0; else if (p_cmp<p_struct->bankAccountId) p_rv=-1; else p_rv=1;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Account_List_Next(p_struct);
  }
  return NULL;
}

AE_ACCOUNT *AE_Account_Tree_GetByBankAccountId(const AE_ACCOUNT_TREE *p_tree, AQDB_ID p_cmp) {
  AE_ACCOUNT *p_struct;

  assert(p_tree);
  p_struct = AE_Account_Tree_GetFirst(p_tree);
  while(p_struct) {
    int p_rv;

    if (p_struct->bankAccountId==p_cmp) p_rv=0; else if (p_cmp<p_struct->bankAccountId) p_rv=-1; else p_rv=1;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Account_Tree_GetBelow(p_struct);
  }
  return NULL;
}

void AE_Account_PathToBuffer(const AE_ACCOUNT *st, GWEN_BUFFER *buf) { assert(st); while(st) { const char *s; if (GWEN_Buffer_GetUsedBytes(buf)) GWEN_Buffer_InsertByte(buf, '/'); s=AE_Account_GetName(st); assert(s); GWEN_Buffer_InsertString(buf, s); st=AE_Account_Tree_GetParent(st); } }
typedef struct { const AE_ACCOUNT_TREE *accountTree; AE_ACCOUNT *current; } AE_ACCOUNT_PATH_DATA; static void* AE_Account_Tree__HandleAccountPath(const char *aname, void *data, int idx, uint32_t flags) { AE_ACCOUNT_PATH_DATA *adata; AE_ACCOUNT *acc; adata=(AE_ACCOUNT_PATH_DATA*) data; if (flags & GWEN_PATH_FLAGS_ROOT) { adata->current=NULL; return adata; } if (strcasecmp(aname, "..")==0) { if (adata->current) { adata->current=AE_Account_Tree_GetParent(adata->current); } else return NULL; } else if (strcasecmp(aname, ".")==0) { /* no change */ return adata; } if (adata->current) acc=AE_Account_Tree_GetFirstChild(adata->current); else acc=AE_Account_Tree_GetFirst(adata->accountTree); while(acc) { const char *s; s=AE_Account_GetName(acc); if (s && strcasecmp(s, aname)==0) break; acc=AE_Account_Tree_GetNext(acc); } if (acc) { adata->current=acc; return adata; } return NULL; }
AE_ACCOUNT* AE_Account_Tree_GetByPath(const AE_ACCOUNT_TREE *at, AE_ACCOUNT *startAccount, const char *path) { AE_ACCOUNT_PATH_DATA adata; AE_ACCOUNT_PATH_DATA *p; adata.accountTree=at; adata.current=startAccount; p=GWEN_Path_HandleWithIdx(path, (void*) &adata, GWEN_PATH_FLAGS_NAMEMUSTEXIST, AE_Account_Tree__HandleAccountPath); if (p) return p->current; return NULL; }
void AE_Account_AddRule(AE_ACCOUNT *st, AE_RULE *r) { assert(st); assert(st->_refCount); if (st->rules==NULL) st->rules=AE_Rule_List_new(); AE_Rule_List_Add(r, st->rules); }
AE_ACCOUNT_GROUP AE_AccountType_GetGroup(AE_ACCOUNT_TYPE t) { AE_ACCOUNT_GROUP g; g=((uint32_t)t>>29) & 0xffL; switch(g) { case AE_AccountGroup_Unknown: case AE_AccountGroup_Asset: case AE_AccountGroup_Liability: case AE_AccountGroup_Equity: case AE_AccountGroup_Income: case AE_AccountGroup_Expense: return g; default: DBG_ERROR(AE_LOGDOMAIN, "Invalid group: %d (from %08x)", g, t); return AE_AccountGroup_Unknown; } }

/* code headers */
#include "ae_account_fns.c"

