/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AE_ALIAS_H
#define AE_ALIAS_H

#include <aqfinance/engine/ae.h>

#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>

#include <gwenhywfar/list1.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef struct AE_ALIAS AE_ALIAS;
GWEN_LIST_FUNCTION_LIB_DEFS(AE_ALIAS, AE_Alias, AE_API)



AE_ALIAS *AE_Alias_new();
AE_ALIAS *AE_Alias_dup(const AE_ALIAS *al);
void AE_Alias_Attach(AE_ALIAS *al);
void AE_Alias_free(AE_ALIAS *al);

AQDB_ID AE_Alias_GetId(const AE_ALIAS *al);
void AE_Alias_SetId(AE_ALIAS *al, AQDB_ID id);

const char *AE_Alias_GetNameSpace(const AE_ALIAS *al);
void AE_Alias_SetNameSpace(AE_ALIAS *al, const char *s);

const char *AE_Alias_GetName(const AE_ALIAS *al);
void AE_Alias_SetName(AE_ALIAS *al, const char *s);

AQDB_ID AE_Alias_GetMainId(const AE_ALIAS *al);
void AE_Alias_SetMainId(AE_ALIAS *al, AQDB_ID id);

AQDB_ID AE_Alias_GetDbId(const AE_ALIAS *al);
void AE_Alias_SetDbId(AE_ALIAS *al, AQDB_ID id);

int AE_Alias_CreateTable(AQDB_DB *db, const char *tname, uint32_t flags);
int AE_Alias_fromObject(const AQDB_OBJECT *o, AE_ALIAS **pT);
int AE_Alias_toObject(const AE_ALIAS *al, AQDB_OBJECT *o);
int AE_Alias_CreateObject(AQDB_DB *db, AQDB_ID tableId, AQDB_ID id, AQDB_OBJECT **pObj);


#ifdef __cplusplus
}
#endif



#endif /* AE_ALIAS_H */








