/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AE_BOOK_P_H
#define AE_BOOK_P_H

#include "ae_book.h"


#define AE_BOOK_TABLENAME_COMMODITY             "commodity"
#define AE_BOOK_TABLENAME_IDCOUNTER             "idcounter"
#define AE_BOOK_TABLENAME_ACCOUNT               "account"
#define AE_BOOK_TABLENAME_TRANSACTION           "transaction"
#define AE_BOOK_TABLENAME_SPLIT                 "split"
#define AE_BOOK_TABLENAME_BANKACCOUNT           "bankaccount"
#define AE_BOOK_TABLENAME_ADDRESS               "address"
#define AE_BOOK_TABLENAME_PARTNER               "partner"


#define AE_BOOK_TABLENAME_PROJECT               "project"
#define AE_BOOK_TABLENAME_TASK                  "task"
#define AE_BOOK_TABLENAME_JOB                   "job"
#define AE_BOOK_TABLENAME_ITEM                  "item"

#define AE_BOOK_TABLENAME_WAREHOUSE             "warehouse"
#define AE_BOOK_TABLENAME_BANKSTATEMENT         "bankstatement"
#define AE_BOOK_TABLENAME_BANKTRANSFER          "banktransfer"
#define AE_BOOK_TABLENAME_BANKDEBITNOTE         "bankdebitnote"

#define AE_BOOK_TABLENAME_BANKACCOUNTGROUP      "bankaccountgroup"

#define AE_BOOK_TABLENAME_BANKTRANSFERPLANNED   "banktransferplanned"
#define AE_BOOK_TABLENAME_BANKTRANSFERTEMPLATE  "banktransfertemplate"
#define AE_BOOK_TABLENAME_BANKTRANSFERGROUP     "banktransfergroup"

#define AE_BOOK_TABLENAME_BOOKEDBALANCE         "bookedbalance"
#define AE_BOOK_TABLENAME_NOTEDBALANCE          "notedbalance"

#define AE_BOOK_TABLENAME_RULE                  "rule"

#define AE_BOOK_TABLENAME_PARTNERGROUP          "partnergroup"
#define AE_BOOK_TABLENAME_PARTNERRULE           "partnerrule"

#define AE_BOOK_TABLENAME_TAX                   "tax"
#define AE_BOOK_TABLENAME_TAXGROUP              "taxgroup"

#define AE_BOOK_TABLENAME_ITEMTEMPLATES         "itemtemplates"
#define AE_BOOK_TABLENAME_ITEMTEMPLATEGROUP     "itemtemplategroup"

#define AE_BOOK_TABLENAME_ACCOUNTBALANCE        "accountbalance"

#define AE_BOOK_TABLENAME_BANKSTANDINGORDER     "standingorder"
#define AE_BOOK_TABLENAME_BANKSTORECURRENCE     "storecurrence"

#define AE_BOOK_TABLENAME_VEHICLE               "vehicle"
#define AE_BOOK_TABLENAME_VEHICLEGROUP          "vehiclegroup"

#define AE_BOOK_TABLENAME_REFUELING             "refueling"

#define AE_BOOK_TABLENAME_GRAPHICREPORTGROUP    "graphicreportgroup"
#define AE_BOOK_TABLENAME_GRAPHICREPORTSETTINGS "graphicreportsettings"

#define AE_BOOK_TABLENAME_SHARE                 "share"



struct AE_BOOK {
  GWEN_INHERIT_ELEMENT(AE_BOOK)

  AQDB_DB *dataBase;
  AQDB_ID tableIds[AE_Book_TableType_Last];

  int dbOpened;
  int refCount;
};


static void GWENHYWFAR_CB *AE_Book_ReadGroup_Callback(AE_BOOK *bk,
						      AE_BOOK_TABLE_TYPE tt,
						      AQDB_OBJECT *o,
						      void *data);

static void GWENHYWFAR_CB *AE_Book_ReadBankAccount_Callback(AE_BOOK *bk,
							    AE_BOOK_TABLE_TYPE tt,
							    AQDB_OBJECT *o,
							    void *data);

static void GWENHYWFAR_CB *AE_Book_ReadStatement_Callback(AE_BOOK *bk,
							  AE_BOOK_TABLE_TYPE tt,
							  AQDB_OBJECT *o,
							  void *data);

static void GWENHYWFAR_CB *AE_Book_ReadBankBalance_Callback(AE_BOOK *bk,
							    AE_BOOK_TABLE_TYPE tt,
							    AQDB_OBJECT *o,
							    void *data);

static int addConflictingObjects(AE_BOOK *b,
				 AE_BOOK_TABLE_TYPE tt,
				 const char *qexpr,
				 AE_DBCONFLICT *cfl);


#endif
