/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AE_GROUP_H
#define AE_GROUP_H

#include <aqfinance/engine/ae.h>

#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>

#include <gwenhywfar/list1.h>
#include <gwenhywfar/tree.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef struct AE_GROUP AE_GROUP;
GWEN_LIST_FUNCTION_LIB_DEFS(AE_GROUP, AE_Group, AE_API)
GWEN_TREE_FUNCTION_LIB_DEFS(AE_GROUP, AE_Group, AE_API)



AE_API AE_GROUP *AE_Group_new();
AE_API AE_GROUP *AE_Group_dup(const AE_GROUP *gr);
AE_API void AE_Group_Attach(AE_GROUP *gr);
AE_API void AE_Group_free(AE_GROUP *gr);

AE_API AQDB_ID AE_Group_GetId(const AE_GROUP *gr);
AE_API void AE_Group_SetId(AE_GROUP *gr, AQDB_ID id);

AE_API const char *AE_Group_GetName(const AE_GROUP *gr);
AE_API void AE_Group_SetName(AE_GROUP *gr, const char *s);

AE_API const char *AE_Group_GetDescription(const AE_GROUP *gr);
AE_API void AE_Group_SetDescription(AE_GROUP *gr, const char *s);

AE_API AQDB_ID AE_Group_GetParentId(const AE_GROUP *gr);
AE_API void AE_Group_SetParentId(AE_GROUP *gr, AQDB_ID id);

AE_API int AE_Group_GetType(const AE_GROUP *gr);
AE_API void AE_Group_SetType(AE_GROUP *gr, int i);

AE_API AQDB_ID AE_Group_GetDbId(const AE_GROUP *gr);
AE_API void AE_Group_SetDbId(AE_GROUP *gr, AQDB_ID id);

AE_API int AE_Group_CreateTable(AQDB_DB *db, const char *tname, uint32_t flags);
AE_API int AE_Group_fromObject(const AQDB_OBJECT *o, AE_GROUP **pT);
AE_API int AE_Group_toObject(const AE_GROUP *gr, AQDB_OBJECT *o);
AE_API int AE_Group_CreateObject(AQDB_DB *db, AQDB_ID tableId, AQDB_ID id, AQDB_OBJECT **pObj);


#ifdef __cplusplus
}
#endif



#endif /* AE_GROUP_H */








