/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AE_BOOK_IDCOUNTER_H
#define AE_BOOK_IDCOUNTER_H

#include <aqfinance/engine/ae.h>

#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>

#include <gwenhywfar/list1.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef struct AE_IDCOUNTER AE_IDCOUNTER;
GWEN_LIST_FUNCTION_LIB_DEFS(AE_IDCOUNTER, AE_IdCounter, AE_API)


AE_API
AE_IDCOUNTER *AE_IdCounter_new();

AE_API
void AE_IdCounter_Attach(AE_IDCOUNTER *ic);

AE_API
AE_IDCOUNTER *AE_IdCounter_dup(const AE_IDCOUNTER *oic);

AE_API
void AE_IdCounter_free(AE_IDCOUNTER *ic);


AE_API
AQDB_ID AE_IdCounter_GetId(const AE_IDCOUNTER *ic);

AE_API
void AE_IdCounter_SetId(AE_IDCOUNTER *ic, AQDB_ID id);

AE_API
const char *AE_IdCounter_GetName(const AE_IDCOUNTER *ic);

AE_API
void AE_IdCounter_SetName(AE_IDCOUNTER *ic, const char *s);

AE_API
AQDB_ID AE_IdCounter_GetLastId(const AE_IDCOUNTER *ic);

AE_API
void AE_IdCounter_SetLastId(AE_IDCOUNTER *ic, AQDB_ID id);

AE_API
AQDB_ID AE_IdCounter_GetDbId(const AE_IDCOUNTER *ic);

AE_API
void AE_IdCounter_SetDbId(AE_IDCOUNTER *ic, AQDB_ID id);


AE_API
int AE_IdCounter_CreateTable(AQDB_DB *db,
			     const char *tname,
			     uint32_t flags);

AE_API
int AE_IdCounter_CreateObject(AQDB_DB *db, AQDB_ID tableId, AQDB_ID id, AQDB_OBJECT **pObj);

AE_API
int AE_IdCounter_fromObject(const AQDB_OBJECT *o, AE_IDCOUNTER **pIc);

AE_API
int AE_IdCounter_toObject(const AE_IDCOUNTER *ic, AQDB_OBJECT *o);


#ifdef __cplusplus
}
#endif



#endif

