/**********************************************************
 * This file has been automatically created by "typemaker2"
 * from the file "ae_partner.xml".
 * Please do not edit this file, all changes will be lost.
 * Better edit the mentioned source file instead.
 **********************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ae_partner_p.h"

#include <gwenhywfar/misc.h>
#include <gwenhywfar/debug.h>

/* code headers */
#include "ae_partner_fns.c"

/* macro functions */
GWEN_LIST_FUNCTIONS(AE_PARTNER, AE_Partner)
GWEN_LIST2_FUNCTIONS(AE_PARTNER, AE_Partner)


int AE_Partner_Group_Type_fromString(const char *p_s) {
  if (p_s && *p_s) {
    if (strcasecmp(p_s, "none")==0)
      return AE_Partner_Group_TypeNone;
    else if (strcasecmp(p_s, "new")==0)
      return AE_Partner_Group_TypeNew;
  }
  return AE_Partner_Group_TypeUnknown;
}

const char *AE_Partner_Group_Type_toString(int p_i) {
  switch(p_i) {
    case AE_Partner_Group_TypeNone: return "none";
    case AE_Partner_Group_TypeNew: return "new";
    default: return "unknown";
  }
}

AE_PARTNER *AE_Partner_new(void) {
  AE_PARTNER *p_struct;

  GWEN_NEW_OBJECT(AE_PARTNER, p_struct)
  p_struct->_refCount=1;
  GWEN_LIST_INIT(AE_PARTNER, p_struct)
  /* members */
  p_struct->id=0;
  p_struct->lastName=NULL;
  p_struct->firstName=NULL;
  p_struct->title=NULL;
  p_struct->note=NULL;
  p_struct->payableAccountId=0;
  p_struct->receivableAccountId=0;
  p_struct->groupId=0;
  p_struct->commodityId=0;
  p_struct->flags=0;
  p_struct->addressList=AE_Address_List_new();
  p_struct->bankAccountList=AE_BankAccount_List_new();
  p_struct->rules=AE_Rule_List_new();
  p_struct->runtimeFlags=0;
  p_struct->dbId=0;
  /* virtual functions */

  return p_struct;
}

void AE_Partner_free(AE_PARTNER *p_struct) {
  if (p_struct) {
  assert(p_struct->_refCount);
  if (p_struct->_refCount==1) {
    GWEN_LIST_FINI(AE_PARTNER, p_struct)
  /* members */
    free(p_struct->lastName);
    free(p_struct->firstName);
    free(p_struct->title);
    free(p_struct->note);
    AE_Address_List_free(p_struct->addressList);
    AE_BankAccount_List_free(p_struct->bankAccountList);
    AE_Rule_List_free(p_struct->rules);
    p_struct->_refCount=0;
    GWEN_FREE_OBJECT(p_struct);
  }
  else
    p_struct->_refCount--;
  }
}

void AE_Partner_Attach(AE_PARTNER *p_struct) {
  assert(p_struct);
  assert(p_struct->_refCount);
  p_struct->_refCount++;
}

AE_PARTNER *AE_Partner_dup(const AE_PARTNER *p_src) {
  AE_PARTNER *p_struct;

  assert(p_src);
  p_struct=AE_Partner_new();
  /* member "id" */
  p_struct->id=p_src->id;

  /* member "lastName" */
  if (p_struct->lastName) {
    free(p_struct->lastName);
    p_struct->lastName=NULL;
  }
  if (p_src->lastName) {
    p_struct->lastName=strdup(p_src->lastName);
  }

  /* member "firstName" */
  if (p_struct->firstName) {
    free(p_struct->firstName);
    p_struct->firstName=NULL;
  }
  if (p_src->firstName) {
    p_struct->firstName=strdup(p_src->firstName);
  }

  /* member "title" */
  if (p_struct->title) {
    free(p_struct->title);
    p_struct->title=NULL;
  }
  if (p_src->title) {
    p_struct->title=strdup(p_src->title);
  }

  /* member "note" */
  if (p_struct->note) {
    free(p_struct->note);
    p_struct->note=NULL;
  }
  if (p_src->note) {
    p_struct->note=strdup(p_src->note);
  }

  /* member "payableAccountId" */
  p_struct->payableAccountId=p_src->payableAccountId;

  /* member "receivableAccountId" */
  p_struct->receivableAccountId=p_src->receivableAccountId;

  /* member "groupId" */
  p_struct->groupId=p_src->groupId;

  /* member "commodityId" */
  p_struct->commodityId=p_src->commodityId;

  /* member "flags" */
  p_struct->flags=p_src->flags;

  /* member "addressList" */
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
    p_struct->addressList=NULL;
  }
  if (p_src->addressList) {
    p_struct->addressList=AE_Address_List_dup(p_src->addressList);
  }

  /* member "bankAccountList" */
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
    p_struct->bankAccountList=NULL;
  }
  if (p_src->bankAccountList) {
    p_struct->bankAccountList=AE_BankAccount_List_dup(p_src->bankAccountList);
  }

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
    p_struct->rules=NULL;
  }
  if (p_src->rules) {
    p_struct->rules=AE_Rule_List_dup(p_src->rules);
  }

  /* member "runtimeFlags" */
  p_struct->runtimeFlags=p_src->runtimeFlags;

  /* member "dbId" */
  p_struct->dbId=p_src->dbId;

  return p_struct;
}

AE_PARTNER *AE_Partner_copy(AE_PARTNER *p_struct, const AE_PARTNER *p_src) {
    assert(p_struct);
  assert(p_src);
  /* member "id" */
  p_struct->id=p_src->id;

  /* member "lastName" */
  if (p_struct->lastName) {
    free(p_struct->lastName);
  }
  if (p_struct->lastName) {
    free(p_struct->lastName);
    p_struct->lastName=NULL;
  }
  if (p_src->lastName) {
    p_struct->lastName=strdup(p_src->lastName);
  }

  /* member "firstName" */
  if (p_struct->firstName) {
    free(p_struct->firstName);
  }
  if (p_struct->firstName) {
    free(p_struct->firstName);
    p_struct->firstName=NULL;
  }
  if (p_src->firstName) {
    p_struct->firstName=strdup(p_src->firstName);
  }

  /* member "title" */
  if (p_struct->title) {
    free(p_struct->title);
  }
  if (p_struct->title) {
    free(p_struct->title);
    p_struct->title=NULL;
  }
  if (p_src->title) {
    p_struct->title=strdup(p_src->title);
  }

  /* member "note" */
  if (p_struct->note) {
    free(p_struct->note);
  }
  if (p_struct->note) {
    free(p_struct->note);
    p_struct->note=NULL;
  }
  if (p_src->note) {
    p_struct->note=strdup(p_src->note);
  }

  /* member "payableAccountId" */
  p_struct->payableAccountId=p_src->payableAccountId;

  /* member "receivableAccountId" */
  p_struct->receivableAccountId=p_src->receivableAccountId;

  /* member "groupId" */
  p_struct->groupId=p_src->groupId;

  /* member "commodityId" */
  p_struct->commodityId=p_src->commodityId;

  /* member "flags" */
  p_struct->flags=p_src->flags;

  /* member "addressList" */
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
  }
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
    p_struct->addressList=NULL;
  }
  if (p_src->addressList) {
    p_struct->addressList=AE_Address_List_dup(p_src->addressList);
  }

  /* member "bankAccountList" */
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
  }
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
    p_struct->bankAccountList=NULL;
  }
  if (p_src->bankAccountList) {
    p_struct->bankAccountList=AE_BankAccount_List_dup(p_src->bankAccountList);
  }

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
    p_struct->rules=NULL;
  }
  if (p_src->rules) {
    p_struct->rules=AE_Rule_List_dup(p_src->rules);
  }

  /* member "runtimeFlags" */
  p_struct->runtimeFlags=p_src->runtimeFlags;

  /* member "dbId" */
  p_struct->dbId=p_src->dbId;

  return p_struct;
}

AQDB_ID AE_Partner_GetId(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->id;
}

const char *AE_Partner_GetLastName(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->lastName;
}

const char *AE_Partner_GetFirstName(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->firstName;
}

const char *AE_Partner_GetTitle(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->title;
}

const char *AE_Partner_GetNote(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->note;
}

AQDB_ID AE_Partner_GetPayableAccountId(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->payableAccountId;
}

AQDB_ID AE_Partner_GetReceivableAccountId(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->receivableAccountId;
}

AQDB_ID AE_Partner_GetGroupId(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->groupId;
}

AQDB_ID AE_Partner_GetCommodityId(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->commodityId;
}

uint32_t AE_Partner_GetFlags(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->flags;
}

AE_ADDRESS_LIST *AE_Partner_GetAddressList(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->addressList;
}

AE_BANKACCOUNT_LIST *AE_Partner_GetBankAccountList(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->bankAccountList;
}

AE_RULE_LIST *AE_Partner_GetRules(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->rules;
}

uint32_t AE_Partner_GetRuntimeFlags(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->runtimeFlags;
}

AQDB_ID AE_Partner_GetDbId(const AE_PARTNER *p_struct) {
  assert(p_struct);
  return p_struct->dbId;
}

void AE_Partner_SetId(AE_PARTNER *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->id=p_src;
}

void AE_Partner_SetLastName(AE_PARTNER *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->lastName) {
    free(p_struct->lastName);
  }
  if (p_src) {
    p_struct->lastName=strdup(p_src);
  }
  else {
    p_struct->lastName=NULL;
  }
}

void AE_Partner_SetFirstName(AE_PARTNER *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->firstName) {
    free(p_struct->firstName);
  }
  if (p_src) {
    p_struct->firstName=strdup(p_src);
  }
  else {
    p_struct->firstName=NULL;
  }
}

void AE_Partner_SetTitle(AE_PARTNER *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->title) {
    free(p_struct->title);
  }
  if (p_src) {
    p_struct->title=strdup(p_src);
  }
  else {
    p_struct->title=NULL;
  }
}

void AE_Partner_SetNote(AE_PARTNER *p_struct, const char *p_src) {
  assert(p_struct);
  if (p_struct->note) {
    free(p_struct->note);
  }
  if (p_src) {
    p_struct->note=strdup(p_src);
  }
  else {
    p_struct->note=NULL;
  }
}

void AE_Partner_SetPayableAccountId(AE_PARTNER *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->payableAccountId=p_src;
}

void AE_Partner_SetReceivableAccountId(AE_PARTNER *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->receivableAccountId=p_src;
}

void AE_Partner_SetGroupId(AE_PARTNER *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->groupId=p_src;
}

void AE_Partner_SetCommodityId(AE_PARTNER *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->commodityId=p_src;
}

void AE_Partner_SetFlags(AE_PARTNER *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->flags=p_src;
}

void AE_Partner_AddFlags(AE_PARTNER *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->flags|=p_src;
}

void AE_Partner_SubFlags(AE_PARTNER *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->flags&=~p_src;
}

void AE_Partner_SetAddressList(AE_PARTNER *p_struct, AE_ADDRESS_LIST *p_src) {
  assert(p_struct);
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
  }
  p_struct->addressList=p_src;
}

void AE_Partner_SetBankAccountList(AE_PARTNER *p_struct, AE_BANKACCOUNT_LIST *p_src) {
  assert(p_struct);
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
  }
  p_struct->bankAccountList=p_src;
}

void AE_Partner_SetRules(AE_PARTNER *p_struct, AE_RULE_LIST *p_src) {
  assert(p_struct);
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  p_struct->rules=p_src;
}

void AE_Partner_SetRuntimeFlags(AE_PARTNER *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->runtimeFlags=p_src;
}

void AE_Partner_AddRuntimeFlags(AE_PARTNER *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->runtimeFlags|=p_src;
}

void AE_Partner_SubRuntimeFlags(AE_PARTNER *p_struct, uint32_t p_src) {
  assert(p_struct);
  p_struct->runtimeFlags&=~p_src;
}

void AE_Partner_SetDbId(AE_PARTNER *p_struct, AQDB_ID p_src) {
  assert(p_struct);
  p_struct->dbId=p_src;
}

/* list1 functions */
AE_PARTNER_LIST *AE_Partner_List_dup(const AE_PARTNER_LIST *p_src) {
  AE_PARTNER_LIST *p_dest;
  AE_PARTNER *p_elem;

  assert(p_src);
  p_dest=AE_Partner_List_new();
  p_elem=AE_Partner_List_First(p_src);
  while(p_elem) {
    AE_PARTNER *p_cpy;

    p_cpy=AE_Partner_dup(p_elem);
    AE_Partner_List_Add(p_cpy, p_dest);
    p_elem=AE_Partner_List_Next(p_elem);
  }

  return p_dest;
}

void AE_Partner_ReadDb(AE_PARTNER *p_struct, GWEN_DB_NODE *p_db) {
  assert(p_struct);
  /* member "id" */
  p_struct->id=GWEN_DB_GetIntValue(p_db, "id", 0, 0);

  /* member "lastName" */
  if (p_struct->lastName) {
    free(p_struct->lastName);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "lastName", 0, NULL); if (s) p_struct->lastName=strdup(s); }
  if (p_struct->lastName==NULL) {  p_struct->lastName=NULL;
  }

  /* member "firstName" */
  if (p_struct->firstName) {
    free(p_struct->firstName);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "firstName", 0, NULL); if (s) p_struct->firstName=strdup(s); }
  if (p_struct->firstName==NULL) {  p_struct->firstName=NULL;
  }

  /* member "title" */
  if (p_struct->title) {
    free(p_struct->title);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "title", 0, NULL); if (s) p_struct->title=strdup(s); }
  if (p_struct->title==NULL) {  p_struct->title=NULL;
  }

  /* member "note" */
  if (p_struct->note) {
    free(p_struct->note);
  }
  { const char *s; s=GWEN_DB_GetCharValue(p_db, "note", 0, NULL); if (s) p_struct->note=strdup(s); }
  if (p_struct->note==NULL) {  p_struct->note=NULL;
  }

  /* member "payableAccountId" */
  p_struct->payableAccountId=GWEN_DB_GetIntValue(p_db, "payableAccountId", 0, 0);

  /* member "receivableAccountId" */
  p_struct->receivableAccountId=GWEN_DB_GetIntValue(p_db, "receivableAccountId", 0, 0);

  /* member "groupId" */
  p_struct->groupId=GWEN_DB_GetIntValue(p_db, "groupId", 0, 0);

  /* member "commodityId" */
  p_struct->commodityId=GWEN_DB_GetIntValue(p_db, "commodityId", 0, 0);

  /* member "flags" */
  p_struct->flags=GWEN_DB_GetIntValue(p_db, "flags", 0, 0);

  /* member "addressList" */
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
  }
  /* member "addressList" is volatile, just presetting */
  p_struct->addressList=AE_Address_List_new();

  /* member "bankAccountList" */
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
  }
  /* member "bankAccountList" is volatile, just presetting */
  p_struct->bankAccountList=AE_BankAccount_List_new();

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  /* member "rules" is volatile, just presetting */
  p_struct->rules=AE_Rule_List_new();

  /* member "runtimeFlags" */
  /* member "runtimeFlags" is volatile, just presetting */
  p_struct->runtimeFlags=0;

  /* member "dbId" */
  /* member "dbId" is volatile, just presetting */
  p_struct->dbId=0;

}

int AE_Partner_WriteDb(const AE_PARTNER *p_struct, GWEN_DB_NODE *p_db) {
  int p_rv;

  assert(p_struct);
  /* member "id" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "id", p_struct->id);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "lastName" */
  if (p_struct->lastName) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "lastName", p_struct->lastName); else { GWEN_DB_DeleteVar(p_db, "lastName"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "firstName" */
  if (p_struct->firstName) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "firstName", p_struct->firstName); else { GWEN_DB_DeleteVar(p_db, "firstName"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "title" */
  if (p_struct->title) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "title", p_struct->title); else { GWEN_DB_DeleteVar(p_db, "title"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "note" */
  if (p_struct->note) p_rv=GWEN_DB_SetCharValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "note", p_struct->note); else { GWEN_DB_DeleteVar(p_db, "note"); p_rv=0; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "payableAccountId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "payableAccountId", p_struct->payableAccountId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "receivableAccountId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "receivableAccountId", p_struct->receivableAccountId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "groupId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "groupId", p_struct->groupId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "commodityId" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "commodityId", p_struct->commodityId);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "flags" */
  p_rv=GWEN_DB_SetIntValue(p_db, GWEN_DB_FLAGS_OVERWRITE_VARS, "flags", p_struct->flags);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "addressList" is volatile, not writing to db */

  /* member "bankAccountList" is volatile, not writing to db */

  /* member "rules" is volatile, not writing to db */

  /* member "runtimeFlags" is volatile, not writing to db */

  /* member "dbId" is volatile, not writing to db */

  return 0;
}

AE_PARTNER *AE_Partner_fromDb(GWEN_DB_NODE *p_db) {
  AE_PARTNER *p_struct;
  p_struct=AE_Partner_new();
  AE_Partner_ReadDb(p_struct, p_db);
  return p_struct;
}

int AE_Partner_toDb(const AE_PARTNER *p_struct, GWEN_DB_NODE *p_db) {
  return AE_Partner_WriteDb(p_struct, p_db);
}

void AE_Partner_ReadXml(AE_PARTNER *p_struct, GWEN_XMLNODE *p_db) {
  assert(p_struct);
  /* member "id" */
  p_struct->id=GWEN_XMLNode_GetIntValue(p_db, "id", 0);

  /* member "lastName" */
  if (p_struct->lastName) {
    free(p_struct->lastName);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "lastName", NULL); if (s) p_struct->lastName=strdup(s); }
  if (p_struct->lastName==NULL) {  /* member "lastName" is volatile, just presetting */
  p_struct->lastName=NULL;
  }

  /* member "firstName" */
  if (p_struct->firstName) {
    free(p_struct->firstName);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "firstName", NULL); if (s) p_struct->firstName=strdup(s); }
  if (p_struct->firstName==NULL) {  /* member "firstName" is volatile, just presetting */
  p_struct->firstName=NULL;
  }

  /* member "title" */
  if (p_struct->title) {
    free(p_struct->title);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "title", NULL); if (s) p_struct->title=strdup(s); }
  if (p_struct->title==NULL) {  /* member "title" is volatile, just presetting */
  p_struct->title=NULL;
  }

  /* member "note" */
  if (p_struct->note) {
    free(p_struct->note);
  }
  { const char *s; s=GWEN_XMLNode_GetCharValue(p_db, "note", NULL); if (s) p_struct->note=strdup(s); }
  if (p_struct->note==NULL) {  /* member "note" is volatile, just presetting */
  p_struct->note=NULL;
  }

  /* member "payableAccountId" */
  p_struct->payableAccountId=GWEN_XMLNode_GetIntValue(p_db, "payableAccountId", 0);

  /* member "receivableAccountId" */
  p_struct->receivableAccountId=GWEN_XMLNode_GetIntValue(p_db, "receivableAccountId", 0);

  /* member "groupId" */
  p_struct->groupId=GWEN_XMLNode_GetIntValue(p_db, "groupId", 0);

  /* member "commodityId" */
  p_struct->commodityId=GWEN_XMLNode_GetIntValue(p_db, "commodityId", 0);

  /* member "flags" */
  p_struct->flags=GWEN_XMLNode_GetIntValue(p_db, "flags", 0);

  /* member "addressList" */
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
  }
  /* member "addressList" is volatile, just presetting */
  p_struct->addressList=AE_Address_List_new();

  /* member "bankAccountList" */
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
  }
  /* member "bankAccountList" is volatile, just presetting */
  p_struct->bankAccountList=AE_BankAccount_List_new();

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  /* member "rules" is volatile, just presetting */
  p_struct->rules=AE_Rule_List_new();

  /* member "runtimeFlags" */
  /* member "runtimeFlags" is volatile, just presetting */
  p_struct->runtimeFlags=0;

  /* member "dbId" */
  /* member "dbId" is volatile, just presetting */
  p_struct->dbId=0;

}

void AE_Partner_WriteXml(const AE_PARTNER *p_struct, GWEN_XMLNODE *p_db) {
  assert(p_struct);
  /* member "id" */
  GWEN_XMLNode_SetIntValue(p_db, "id", p_struct->id);

  /* member "lastName" */
  GWEN_XMLNode_SetCharValue(p_db, "lastName", p_struct->lastName);

  /* member "firstName" */
  GWEN_XMLNode_SetCharValue(p_db, "firstName", p_struct->firstName);

  /* member "title" */
  GWEN_XMLNode_SetCharValue(p_db, "title", p_struct->title);

  /* member "note" */
  GWEN_XMLNode_SetCharValue(p_db, "note", p_struct->note);

  /* member "payableAccountId" */
  GWEN_XMLNode_SetIntValue(p_db, "payableAccountId", p_struct->payableAccountId);

  /* member "receivableAccountId" */
  GWEN_XMLNode_SetIntValue(p_db, "receivableAccountId", p_struct->receivableAccountId);

  /* member "groupId" */
  GWEN_XMLNode_SetIntValue(p_db, "groupId", p_struct->groupId);

  /* member "commodityId" */
  GWEN_XMLNode_SetIntValue(p_db, "commodityId", p_struct->commodityId);

  /* member "flags" */
  GWEN_XMLNode_SetIntValue(p_db, "flags", p_struct->flags);

  /* member "addressList" is volatile, not writing to xml */

  /* member "bankAccountList" is volatile, not writing to xml */

  /* member "rules" is volatile, not writing to xml */

  /* member "runtimeFlags" is volatile, not writing to xml */

  /* member "dbId" is volatile, not writing to xml */

}

void AE_Partner_toXml(const AE_PARTNER *p_struct, GWEN_XMLNODE *p_db) {
  AE_Partner_WriteXml(p_struct, p_db);
}

AE_PARTNER *AE_Partner_fromXml(GWEN_XMLNODE *p_db) {
  AE_PARTNER *p_struct;
  p_struct=AE_Partner_new();
  AE_Partner_ReadXml(p_struct, p_db);
  return p_struct;
}

int AE_Partner_ReadObject(AE_PARTNER *p_struct, const AQDB_OBJECT *p_db) {
  int p_rv;

  assert(p_struct);
  /* member "id" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_PARTNER_FIELD_ID, &v64); if (p_rv>=0) p_struct->id=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "lastName" */
  if (p_struct->lastName) {
    free(p_struct->lastName);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_PARTNER_FIELD_LASTNAME, &s); if (p_rv>=0 && s) p_struct->lastName=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "firstName" */
  if (p_struct->firstName) {
    free(p_struct->firstName);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_PARTNER_FIELD_FIRSTNAME, &s); if (p_rv>=0 && s) p_struct->firstName=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "title" */
  if (p_struct->title) {
    free(p_struct->title);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_PARTNER_FIELD_TITLE, &s); if (p_rv>=0 && s) p_struct->title=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "note" */
  if (p_struct->note) {
    free(p_struct->note);
  }
  { const char *s; p_rv=AQDB_Object_GetFieldString(p_db, AE_PARTNER_FIELD_NOTE, &s); if (p_rv>=0 && s) p_struct->note=strdup(s); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "payableAccountId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_PARTNER_FIELD_PAYABLEACCOUNTID, &v64); if (p_rv>=0) p_struct->payableAccountId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "receivableAccountId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_PARTNER_FIELD_RECEIVABLEACCOUNTID, &v64); if (p_rv>=0) p_struct->receivableAccountId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "groupId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_PARTNER_FIELD_GROUPID, &v64); if (p_rv>=0) p_struct->groupId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "commodityId" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_PARTNER_FIELD_COMMODITYID, &v64); if (p_rv>=0) p_struct->commodityId=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "flags" */
  { int64_t v64; p_rv=AQDB_Object_GetFieldInt64(p_db, AE_PARTNER_FIELD_FLAGS, &v64); if (p_rv>=0) p_struct->flags=(int) v64; }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "addressList" */
  if (p_struct->addressList) {
    AE_Address_List_free(p_struct->addressList);
  }
  /* member "addressList" is volatile, just presetting */
  p_struct->addressList=AE_Address_List_new();

  /* member "bankAccountList" */
  if (p_struct->bankAccountList) {
    AE_BankAccount_List_free(p_struct->bankAccountList);
  }
  /* member "bankAccountList" is volatile, just presetting */
  p_struct->bankAccountList=AE_BankAccount_List_new();

  /* member "rules" */
  if (p_struct->rules) {
    AE_Rule_List_free(p_struct->rules);
  }
  /* member "rules" is volatile, just presetting */
  p_struct->rules=AE_Rule_List_new();

  /* member "runtimeFlags" */
  /* member "runtimeFlags" is volatile, just presetting */
  p_struct->runtimeFlags=0;

  /* member "dbId" */
  /* member "dbId" is volatile, just presetting */
  p_struct->dbId=0;

  return 0;
}

int AE_Partner_WriteObject(const AE_PARTNER *p_struct, AQDB_OBJECT *p_db) {
  int p_rv;

  assert(p_struct);
  /* member "id" */
  { int64_t v64=(int64_t) (p_struct->id); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_PARTNER_FIELD_ID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "lastName" */
  if (p_struct->lastName) p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_LASTNAME, p_struct->lastName); else p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_LASTNAME, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "firstName" */
  if (p_struct->firstName) p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_FIRSTNAME, p_struct->firstName); else p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_FIRSTNAME, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "title" */
  if (p_struct->title) p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_TITLE, p_struct->title); else p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_TITLE, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "note" */
  if (p_struct->note) p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_NOTE, p_struct->note); else p_rv=AQDB_Object_SetFieldString(p_db, AE_PARTNER_FIELD_NOTE, NULL);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "payableAccountId" */
  { int64_t v64=(int64_t) (p_struct->payableAccountId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_PARTNER_FIELD_PAYABLEACCOUNTID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "receivableAccountId" */
  { int64_t v64=(int64_t) (p_struct->receivableAccountId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_PARTNER_FIELD_RECEIVABLEACCOUNTID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "groupId" */
  { int64_t v64=(int64_t) (p_struct->groupId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_PARTNER_FIELD_GROUPID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "commodityId" */
  { int64_t v64=(int64_t) (p_struct->commodityId); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_PARTNER_FIELD_COMMODITYID, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "flags" */
  { int64_t v64=(int64_t) (p_struct->flags); p_rv=AQDB_Object_SetFieldInt64(p_db, AE_PARTNER_FIELD_FLAGS, v64); }
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)\n", p_rv);
    return p_rv;
  }

  /* member "addressList" is volatile, not writing to object */

  /* member "bankAccountList" is volatile, not writing to object */

  /* member "rules" is volatile, not writing to object */

  /* member "runtimeFlags" is volatile, not writing to object */

  /* member "dbId" is volatile, not writing to object */

  return 0;
}

int AE_Partner_toObject(const AE_PARTNER *p_struct, AQDB_OBJECT *p_db) {
  return AE_Partner_WriteObject(p_struct, p_db);
}

int AE_Partner_fromObject(const AQDB_OBJECT *p_db, AE_PARTNER **pp_struct) {
  AE_PARTNER *p_struct;
  int p_rv;
  p_struct=AE_Partner_new();
  p_rv=AE_Partner_ReadObject(p_struct, p_db);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)", p_rv);
    AE_Partner_free(p_struct);
    return p_rv;
  }
  *pp_struct=p_struct;
  return 0;
}

AQDB_COLUMN_LIST *AE_Partner_CreateColumnList() {
  AQDB_COLUMN_LIST *p_cl;
  AQDB_COLUMN *p_c;

  p_cl=AQDB_Column_List_new();

  /* member "id" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "id", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "lastName" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "lastName", 128);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "firstName" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "firstName", 128);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "title" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "title", 128);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "note" */
  p_c=AQDB_Column_new(AQDB_DataType_String, "note", 512);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "payableAccountId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "payableAccountId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "receivableAccountId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "receivableAccountId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "groupId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "groupId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "commodityId" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "commodityId", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "flags" */
  p_c=AQDB_Column_new(AQDB_DataType_Int, "flags", 8);
  AQDB_Column_List_Add(p_c, p_cl);

  /* member "addressList" is volatile, not adding to column list */

  /* member "bankAccountList" is volatile, not adding to column list */

  /* member "rules" is volatile, not adding to column list */

  /* member "runtimeFlags" is volatile, not adding to column list */

  /* member "dbId" is volatile, not adding to column list */

  return p_cl;
}

int AE_Partner_CreateTable(AQDB_DB *p_db, const char *p_name, uint32_t p_flags) {
  AQDB_COLUMN_LIST *p_cl;
  int p_rv;

  p_cl=AE_Partner_CreateColumnList();
  p_rv=AQDB_DB_CreateTable(p_db, p_name, p_flags, p_cl);
  AQDB_Column_List_free(p_cl);
  if (p_rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)", p_rv);
    return p_rv;
  }
  return 0;
}

int AE_Partner_CreateObject(AQDB_DB *p_db, AQDB_ID p_tableId, AQDB_ID p_id, AQDB_OBJECT **pp_o) {
  AQDB_OBJECT *p_o;

  p_o=AQDB_Object_new(p_tableId, p_id, AE_PARTNER_FIELD_COUNT);
  *pp_o=p_o;
  return 0;
}

AE_PARTNER *AE_Partner_List_GetById(const AE_PARTNER_LIST *p_list, AQDB_ID p_cmp) {
  AE_PARTNER *p_struct;

  assert(p_list);
  p_struct = AE_Partner_List_First(p_list);
  while(p_struct) {
    int p_rv;

    if (p_struct->id==p_cmp) p_rv=0; else if (p_cmp<p_struct->id) p_rv=-1; else p_rv=1;
    if (p_rv == 0)
      return p_struct;
    p_struct = AE_Partner_List_Next(p_struct);
  }
  return NULL;
}

AE_BANKACCOUNT* AE_Partner_GetFirstBankAccount(const AE_PARTNER *st) { assert(st); assert(st->_refCount); if (st->bankAccountList==NULL) return NULL; else return AE_BankAccount_List_First(st->bankAccountList); }
AE_ADDRESS* AE_Partner_GetFirstAddress(const AE_PARTNER *st) { assert(st); assert(st->_refCount); if (st->addressList==NULL) return NULL; else return AE_Address_List_First(st->addressList); }
AE_RULE* AE_Partner_GetFirstRule(const AE_PARTNER *st) { assert(st); assert(st->_refCount); if (st->rules==NULL) return NULL; else return AE_Rule_List_First(st->rules); }
AE_PARTNER* AE_Partner_List_GetByPath(const AE_PARTNER_LIST *st, const char *path) { AE_PARTNER *pt; GWEN_BUFFER *tbuf; assert(st); assert(path); tbuf=GWEN_Buffer_new(0, 256, 0, 1); pt=AE_Partner_List_First(st); while(pt) { AE_Partner_PathToBuffer(pt, tbuf); if (strncasecmp(GWEN_Buffer_GetStart(tbuf), path, strlen(path))==0) break; GWEN_Buffer_Reset(tbuf); pt=AE_Partner_List_Next(pt); } GWEN_Buffer_free(tbuf); return pt; }
int AE_Partner_PathToBuffer(const AE_PARTNER *st, GWEN_BUFFER *buf) { const char *s; assert(st); assert(st->_refCount); assert(buf); s=st->title; if (s && *s) { GWEN_Buffer_AppendString(buf, s); s=st->lastName; if (s && *s) { GWEN_Buffer_AppendString(buf, " "); GWEN_Buffer_AppendString(buf, s); s=st->firstName; if (s && *s) { GWEN_Buffer_AppendString(buf, ", "); GWEN_Buffer_AppendString(buf, s); } } else { s=st->firstName; if (s && *s) GWEN_Buffer_AppendString(buf, s); else GWEN_Buffer_AppendString(buf, I18N("-Unnamed partner-")); } } else { s=st->lastName; if (s && *s) { GWEN_Buffer_AppendString(buf, s); s=st->firstName; if (s && *s) { GWEN_Buffer_AppendString(buf, ", "); GWEN_Buffer_AppendString(buf, s); } } else { s=st->firstName; if (s && *s) GWEN_Buffer_AppendString(buf, s); else GWEN_Buffer_AppendString(buf, I18N("-Unnamed partner-")); } } if (st->id) { char numbuf[32]; snprintf(numbuf, sizeof(numbuf)-1, " [%lu]", (unsigned long int) (st->id)); GWEN_Buffer_AppendString(buf, numbuf); } return 0; }

/* code headers */

