/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007-2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#include <aqfinance/engine/book/ae_utils.h>

#include <ctype.h>




int AE_Partner_Matches(const AE_PARTNER *pt, const char *s) {
  if (s && *s) {
    const char *t;
    int match=0;

    if (match==0) {
      t=AE_Partner_GetFirstName(pt);
      if (t && *t && AE_Utils_StrCaseStr(t, s)!=NULL) {
	match=1;
      }
    }

    if (match==0) {
      t=AE_Partner_GetLastName(pt);
      if (t && *t && AE_Utils_StrCaseStr(t, s)!=NULL) {
	match=1;
      }
    }

    if (match==0) {
      t=AE_Partner_GetTitle(pt);
      if (t && *t && AE_Utils_StrCaseStr(t, s)!=NULL) {
	match=1;
      }
    }

    if (match==0) {
      t=AE_Partner_GetNote(pt);
      if (t && *t && AE_Utils_StrCaseStr(t, s)!=NULL) {
	match=1;
      }
    }

    return match;
  }
  else {
    return 1;
  }
}




void AE_Partner_List_SelectMatching(AE_PARTNER_LIST *sl, const char *s) {
  AE_PARTNER *pt;

  if (s && *s) {
    /* select matching statements */
    pt=AE_Partner_List_First(sl);
    while(pt) {
      if (AE_Partner_Matches(pt, s))
	AE_Partner_AddRuntimeFlags(pt, AE_PARTNER_RTFLAGS_SELECTED);
      else
	AE_Partner_SubRuntimeFlags(pt, AE_PARTNER_RTFLAGS_SELECTED);

      pt=AE_Partner_List_Next(pt);
    }
  }
  else {
    /* set the SELECTED flags */
    pt=AE_Partner_List_First(sl);
    while(pt) {
      AE_Partner_AddRuntimeFlags(pt, AE_PARTNER_RTFLAGS_SELECTED);
      pt=AE_Partner_List_Next(pt);
    }
  }
}


