/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "ae_readxml.h"
#include "dbxmlctx_l.h"

#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/text.h>

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <fcntl.h>



int AE_Book_ReadXml(AE_BOOK *b, const char *fname, int openAndCloseTables) {
  int rv;
  GWEN_XML_CONTEXT *ctx;

  ctx=AE_DbXmlCtx_new(GWEN_XML_FLAGS_HANDLE_COMMENTS |
		      GWEN_XML_FLAGS_KEEP_CNTRL |
		      GWEN_XML_FLAGS_KEEP_BLANKS |
                      GWEN_XML_FLAGS_NO_CONDENSE |
                      GWEN_XML_FLAGS_HANDLE_HEADERS,
		      b, openAndCloseTables);
  rv=GWEN_XMLContext_ReadFromFile(ctx, fname);
  if (rv<0) {
    DBG_INFO(GWEN_LOGDOMAIN, "here (%d)", rv);
    GWEN_XmlCtx_free(ctx);
    return rv;
  }

  GWEN_XmlCtx_free(ctx);

  return 0;
}




