/***************************************************************************
 begin       : Wed Mar 17 2010
 copyright   : (C) 2010 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef AE_DBGROUP_L_H
#define AE_DBGROUP_L_H


#include <gwenhywfar/inherit.h>
#include <gwenhywfar/xmlctx.h>
#include <gwenhywfar/db.h>



typedef struct AE_DBGROUP AE_DBGROUP;
GWEN_INHERIT_FUNCTION_DEFS(AE_DBGROUP)


typedef int (*AE_DBGROUP_STARTTAG_FN)(AE_DBGROUP *g,
				      const char *tagName);
typedef int (*AE_DBGROUP_ENDTAG_FN)(AE_DBGROUP *g,
				    const char *tagName);
typedef int (*AE_DBGROUP_ADDDATA_FN)(AE_DBGROUP *g,
				     const char *data);

typedef int (*AE_DBGROUP_ENDSUBGROUP_FN)(AE_DBGROUP *g,
					 AE_DBGROUP *sg);




AE_DBGROUP *AE_DbGroup_new(const char *groupName,
			   AE_DBGROUP *parent,
			   GWEN_XML_CONTEXT *ctx);
void AE_DbGroup_free(AE_DBGROUP *g);


AE_DBGROUP *AE_DbGroup_GetParent(const AE_DBGROUP *g);
GWEN_XML_CONTEXT *AE_DbGroup_GetXmlContext(const AE_DBGROUP *g);
const char *AE_DbGroup_GetGroupName(const AE_DBGROUP *g);

GWEN_DB_NODE *AE_DbXmlCtx_GetCurrentAttributes(const GWEN_XML_CONTEXT *ctx);



AE_DBGROUP_STARTTAG_FN
  AE_DbGroup_SetStartTagFn(AE_DBGROUP *g,
			   AE_DBGROUP_STARTTAG_FN f);

AE_DBGROUP_ENDTAG_FN
  AE_DbGroup_SetEndTagFn(AE_DBGROUP *g,
			 AE_DBGROUP_ENDTAG_FN f);

AE_DBGROUP_ADDDATA_FN
  AE_DbGroup_SetAddDataFn(AE_DBGROUP *g,
			  AE_DBGROUP_ADDDATA_FN f);

AE_DBGROUP_ENDSUBGROUP_FN
  AE_DbGroup_SetEndSubGroupFn(AE_DBGROUP *g,
			      AE_DBGROUP_ENDSUBGROUP_FN f);



int AE_DbGroup_StartTag(AE_DBGROUP *g, const char *tagName);

/**
 * @return 1 if this tag ends the current group, 0 otherwise (<0 on error)
 */
int AE_DbGroup_EndTag(AE_DBGROUP *g, const char *tagName);
int AE_DbGroup_AddData(AE_DBGROUP *g, const char *data);

int AE_DbGroup_EndSubGroup(AE_DBGROUP *g, AE_DBGROUP *sg);

#endif
