/***************************************************************************
 begin       : Wed Mar 17 2010
 copyright   : (C) 2010 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef AE_DBXMLCTX_L_H
#define AE_DBXMLCTX_L_H


#include "dbgroup_l.h"

#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/xmlctx.h>



GWEN_XML_CONTEXT *AE_DbXmlCtx_new(uint32_t flags,
				  AE_BOOK *b,
				  int doOpenAndCloseTables);

AE_DBGROUP *AE_DbXmlCtx_GetCurrentGroup(const GWEN_XML_CONTEXT *ctx);

void AE_DbXmlCtx_SetCurrentGroup(GWEN_XML_CONTEXT *ctx, AE_DBGROUP *g);

const char *AE_DbXmlCtx_GetCurrentTagName(const GWEN_XML_CONTEXT *ctx);
void AE_DbXmlCtx_SetCurrentTagName(GWEN_XML_CONTEXT *ctx, const char *s);

AE_BOOK *AE_DbXmlCtx_GetBook(const GWEN_XML_CONTEXT *ctx);
int AE_DbXmlCtx_GetDoOpenAndCloseTables(const GWEN_XML_CONTEXT *ctx);


int AE_DbXmlCtx_SanitizeData(GWEN_XML_CONTEXT *ctx,
			     const char *data,
			     GWEN_BUFFER *buf);

#endif

