/***************************************************************************
 begin       : Wed Mar 17 2010
 copyright   : (C) 2010 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef AE_DBXMLCTX_P_H
#define AE_DBXMLCTX_P_H


#include "dbxmlctx_l.h"



typedef struct AE_DBXMLCTX AE_DBXMLCTX;
struct AE_DBXMLCTX {
  AE_BOOK *book;
  int doOpenAndCloseTables;

  AE_DBGROUP *currentGroup;
  char *currentTagName;
  GWEN_DB_NODE *dbCurrentAttribs;

};


static void GWENHYWFAR_CB AE_DbXmlCtx_FreeData(void *bp, void *p);


static int AE_DbXmlCtx_StartTag(GWEN_XML_CONTEXT *ctx, const char *tagName);
static int AE_DbXmlCtx_EndTag(GWEN_XML_CONTEXT *ctx, int closing);
static int AE_DbXmlCtx_AddData(GWEN_XML_CONTEXT *ctx, const char *data);
static int AE_DbXmlCtx_AddComment(GWEN_XML_CONTEXT *ctx, const char *data);
static int AE_DbXmlCtx_AddAttr(GWEN_XML_CONTEXT *ctx,
			       const char *attrName,
			       const char *attrData);


#endif

