/***************************************************************************
 begin       : Wed Mar 17 2010
 copyright   : (C) 2010 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "g_document_p.h"
#include "g_aqfinance_l.h"
#include "dbxmlctx_l.h"

#include "g_table_l.h"
#include "g_generic_l.h"

#include <gwenhywfar/misc.h>
#include <gwenhywfar/debug.h>




AE_DBGROUP *AE_DbGroup_Document_new(const char *groupName,
				    AE_DBGROUP *parent,
				    GWEN_XML_CONTEXT *ctx) {
  AE_DBGROUP *g;

  /* create base group */
  g=AE_DbGroup_Generic_new(groupName, parent, ctx);
  assert(g);

  /* set virtual functions */
  AE_DbGroup_SetStartTagFn(g, AE_DbGroup_Document_StartTag);
  AE_DbGroup_SetAddDataFn(g, AE_DbGroup_Document_AddData);

  return g;
}



int AE_DbGroup_Document_StartTag(AE_DBGROUP *g, const char *tagName) {
  AE_DBGROUP *gNew=NULL;
  GWEN_XML_CONTEXT *ctx;

  assert(g);

  ctx=AE_DbGroup_GetXmlContext(g);

  if (strcasecmp(tagName, "aqfinance")==0)
    gNew=AE_DbGroup_AqFinance_new(tagName, g, ctx);
  else {
    DBG_WARN(AE_LOGDOMAIN,
	     "Unexpected group [%s]", tagName);
    return GWEN_ERROR_BAD_DATA;
  }

  if (gNew) {
    AE_DbXmlCtx_SetCurrentGroup(ctx, gNew);
    GWEN_XmlCtx_IncDepth(ctx);
  }

  return 0;
}



int AE_DbGroup_Document_AddData(AE_DBGROUP *g, const char *data) {
  return 0;
}



