/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/




void AF_Graph_Settings_SetDefaults(AF_GRAPH_SETTINGS *rs) {
  AF_GRAPH_SETTINGS_PEN *pen;
  AF_GRAPH_SETTINGS_FONT *font;

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0x00000000);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenTitle(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0xff000000);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenSubTitle(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0x0000000);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenAxisLabel(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0x0000ff00);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenAxis(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0x00ff0000);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenGraph(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0xffec5b00);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenGraphBackground(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0xc0c0c000);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 1);
  AF_Graph_Settings_SetPenGrid(rs, pen);

  pen=AF_Graph_SettingsPen_new();
  AF_Graph_SettingsPen_SetFrontColour(pen, (int)0xffffff00);
  AF_Graph_SettingsPen_SetLineWidth(pen, 1);
  AF_Graph_SettingsPen_SetDashType(pen, 0);
  AF_Graph_Settings_SetPenBackground(rs, pen);


  font=AF_Graph_SettingsFont_new();
  AF_Graph_SettingsFont_SetFontSize(font, 20);
  AF_Graph_SettingsFont_SetFontSlant(font, AF_Graphics_Slant_None);
  AF_Graph_SettingsFont_SetFontWeight(font, AF_Graphics_Weight_Bold);
  AF_Graph_Settings_SetFontTitle(rs, font);

  font=AF_Graph_SettingsFont_new();
  AF_Graph_SettingsFont_SetFontSize(font, 16);
  AF_Graph_SettingsFont_SetFontSlant(font, AF_Graphics_Slant_Italic);
  AF_Graph_SettingsFont_SetFontWeight(font, AF_Graphics_Weight_None);
  AF_Graph_Settings_SetFontSubTitle(rs, font);

  font=AF_Graph_SettingsFont_new();
  AF_Graph_SettingsFont_SetFontSize(font, 12);
  AF_Graph_SettingsFont_SetFontSlant(font, AF_Graphics_Slant_None);
  AF_Graph_SettingsFont_SetFontWeight(font, AF_Graphics_Weight_None);
  AF_Graph_Settings_SetFontAxisLabel(rs, font);

  font=AF_Graph_SettingsFont_new();
  AF_Graph_SettingsFont_SetFontSize(font, 9);
  AF_Graph_SettingsFont_SetFontSlant(font, AF_Graphics_Slant_None);
  AF_Graph_SettingsFont_SetFontWeight(font, AF_Graphics_Weight_None);
  AF_Graph_Settings_SetFontTickLabel(rs, font);

  AF_Graph_Settings_AddFlags(rs, AF_GRAPH_FLAGS_WITH_GRID);
}







