/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_HTMLCTX_CAIRO_H
#define AF_HTMLCTX_CAIRO_H


#include <aqfinance/engine/ae_api.h>

#include <gwenhywfar/xml.h>

#ifdef __cplusplus
extern "C" {
#endif


AE_API GWEN_XML_CONTEXT *AF_HtmlCtxCairo_Pdf_new(uint32_t flags, const char *filename, double width, double height);
AE_API GWEN_XML_CONTEXT *AF_HtmlCtxCairo_Ps_new(uint32_t flags, const char *filename, double width, double height);

AE_API void AF_HtmlCtxCairo_SetFontSize(GWEN_XML_CONTEXT *ctx, int size);

AE_API void AF_HtmlCtxCairo_Paint(GWEN_XML_CONTEXT *ctx, int xOffset, int yOffset);

AE_API void AF_HtmlCtxCairo_EndPage(GWEN_XML_CONTEXT *ctx);
AE_API void AF_HtmlCtxCairo_Finish(GWEN_XML_CONTEXT *ctx);


#ifdef __cplusplus
}
#endif



#endif

