/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_HTMLCTX_CAIRO_P_H
#define AF_HTMLCTX_CAIRO_P_H

#include "af_htmlctx_cairo.h"

#include <gwenhywfar/htmlctx_be.h>
#include <gwenhywfar/htmlfont_be.h>


#include <cairo/cairo.h>




typedef struct AF_HTMLCTX_CAIRO AF_HTMLCTX_CAIRO;
struct AF_HTMLCTX_CAIRO {
  cairo_surface_t *surface;
  cairo_t *cr;

  HTML_FONT_LIST *fontList;
};


static GWENHYWFAR_CB void AF_HtmlCtxCairo_FreeData(void *bp, void *p);


static int AF_HtmlCtxCairo_GetTextWidth(GWEN_XML_CONTEXT *ctx,
				       HTML_FONT *fnt,
				       const char *s);

static int AF_HtmlCtxCairo_GetTextHeight(GWEN_XML_CONTEXT *ctx,
					HTML_FONT *fnt,
					const char *s);


static uint32_t AF_HtmlCtxCairo_GetColorFromName(const GWEN_XML_CONTEXT *ctx, const char *s);


static HTML_FONT* AF_HtmlCtxCairo_GetFont(GWEN_XML_CONTEXT *ctx,
					  const char *fontName,
					  int fontSize,
					  uint32_t fontFlags);

static HTML_IMAGE *AF_HtmlCtxCairo_GetImage(GWEN_XML_CONTEXT *ctx, const char *fileName);

#endif

