/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_REPORT2_L_H
#define AF_REPORT2_L_H



#include <aqfinance/engine/ae.h>
#include <aqfinance/report2/af_report2.h>

#include <aqfinance/graphs/af_graph_dataset.h>

#include <gwenhywfar/types.h>
#include <gwenhywfar/list1.h>
#include <gwenhywfar/list2.h>
#include <gwenhywfar/db.h>
#include <gwenhywfar/xml.h>


#include <aqfinance/engine/book/ae_book.h>


AE_API AF_REPORT2 *AF_Report2_new();
AE_API void AF_Report2_free(AF_REPORT2 *rp);

AE_API AF_REPORT2_CATEGORY_TREE *AF_Report2_GetCategoryTree(const AF_REPORT2 *rp);

AE_API int AF_Report2_AddDataPair(AF_REPORT2 *rp, AF_REPORT2_DATAPAIR *dp);

AE_API int AF_Report2_AddCategory(AF_REPORT2 *rp, AF_REPORT2_CATEGORY *cat, AQDB_ID parentId);


AE_API void AF_Report2_CollapseAllCategories(AF_REPORT2 *rp);
AE_API int AF_Report2_CollapseSubCategories(AF_REPORT2 *rp, AF_REPORT2_CATEGORY *cat);
AE_API void AF_Report2_RemoveEmptySubCategories(AF_REPORT2 *rp, AF_REPORT2_CATEGORY *cat);


AE_API void AF_Report2_AddDayData2DataSet(AF_REPORT2 *rp, AF_GRAPH_DATASET *ds, uint32_t flags,
                                          const char *label,
                                          int level, int graphType, int dataMode, int colour, int lineWidth, int dashType);

AE_API void AF_Report2_AddMonthData2DataSet(AF_REPORT2 *rp, AF_GRAPH_DATASET *ds, uint32_t flags,
                                            const char *label,
                                            int level, int graphType, int dataMode, int colour, int lineWidth, int dashType);



#endif

