/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



int AF_Report2_SettingsGraph_AddCategoryName(AF_REPORT2_SETTINGS_GRAPH *sg, const char *s) {
  int rv;

  if (sg->categoryNameList==NULL)
    sg->categoryNameList=GWEN_StringList2_new();
  rv=GWEN_StringList2_AppendString(sg->categoryNameList, s, 0, GWEN_StringList2_IntertMode_NoDouble);
  if (rv<0) {
    DBG_INFO(AE_LOGDOMAIN, "here (%d)", rv);
    return rv;
  }

  return rv;
}



void AF_Report2_SettingsGraph_ClearCategoryNames(AF_REPORT2_SETTINGS_GRAPH *sg) {
  if (sg->categoryNameList)
    GWEN_StringList2_free(sg->categoryNameList);
  sg->categoryNameList=GWEN_StringList2_new();
}



const char *AF_Report2_SettingsGraph_GetCategoryNameAt(const AF_REPORT2_SETTINGS_GRAPH *sg, int idx) {
  if (sg->categoryNameList)
    return GWEN_StringList2_GetStringAt(sg->categoryNameList, idx);
  return NULL;
}


