/***************************************************************************
 begin       : Sat Jun 25 2011
 copyright   : (C) 2011 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef AF_UPDATE_P_H
#define AF_UPDATE_P_H


#include "af_update.h"
#include <aqfinance/update/af_update_release.h>

#include <gwenhywfar/buffer.h>
#include <gwenhywfar/stringlist.h>


#define AF_UPDATE_UNZIP_CHUNK 2048



struct AF_UPDATE {
  char *server;

  char *dataFolder;

  char *appName;
  char *sysName;
  char *archName;

  int vMajor;
  int vMinor;
  int vPatchLevel;
  int vBuild;
  int maturity;

  GWEN_CRYPT_KEY *pubKey;

  int refCount;
};


static int AF_Update_GetProgramFolder(AF_UPDATE *upd, GWEN_BUFFER *buf);
static int AF_Update_ReadProgramVersion(AF_UPDATE *upd);

static int AF_Update_Download_ReleaseList(AF_UPDATE *upd, GWEN_BUFFER *lbuf);
static int AF_Update_ExtractNewReleaseList(AF_UPDATE *upd, GWEN_BUFFER *lbuf, GWEN_STRINGLIST *sl);

static int AF_Update_Download_ReleaseInfo(AF_UPDATE *upd, const char *rname, GWEN_BUFFER *lbuf);


static int AF_Update_UnzipSio2Sio(GWEN_SYNCIO *sioIn, uint64_t inSize, GWEN_SYNCIO *sioOut);


#endif


